// Arcadeflow - v 7.3
// Attract Mode Theme by zpaolo11x
//
// Based on carrier.nut scrolling module by Radek Dutkiewicz (oomek)
// Including code from the KeyboardSearch plugin by Andrew Mickelson (mickelson)

function gly(index){
	local uniglyphs = ["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""]
	local unizero = 0xe900	
	try {return (uniglyphs[index-unizero])} catch (err) {return ""}
}

local AFVERSION = "7.3"

local prefs = {
   l0 = []
	a0 = []
   l1 = []
	gl0 = [] //glyph array
   path = "help_images_sq_x/"
	ext = ".jpg"
	getout = false
	defaultprf = null
	affolder = fe.script_dir
	driveletters = null
}

// Load language file
fe.load_module("file")
fe.do_nut("nut_language.nut")
local TLNG = "EN"
try {TLNG = loadlanguage ()} catch (err){}
// Language is first taken from file if present. If it's not present "EN" is used. After settings the language is updated and file is updated too. 

if (FeVersionNum < 250) fe.overlay.splash_message (ltxt("Arcadeflow requires at least Attract Mode v2.5.0",TLNG))


// for debug purposes
function loaddebug(){
   local debugpath = fe.path_expand( prefs.affolder + "pref_debug.txt")
   local debugfile = ReadTextFile (debugpath)
   local out = debugfile.read_line()
   return (out == "true")
}

function savedebug(savecode){
   local debugpath = fe.path_expand( prefs.affolder + "pref_debug.txt")
   local debugfile = WriteTextFile (debugpath)
   debugfile.write_line(savecode)
}

local DEBUG = false
try {DEBUG = loaddebug()} catch (err) {}

function debugpr (instring){
	if (DEBUG) print (instring)
}

function testpr (instring){
	print ("\n"+instring+"\n")
}

function testprc (instring){
	print (instring+"\n")
}

function taglister () {
	local tagtable = {}
	for (local i = 0 ; i < fe.list.size ; i++) {
		local tag0 = fe.game_info (Info.Tags,i, (fe.filters.len()!=0 ? - fe.list.filter_index:0))
		local tagarray = split(tag0,";")
		foreach (tag in tagarray) {
			try {tagtable[tag] = tag}
			catch (err)
			{tagtable[tag] <- tag}
		}
	}
	local tagarray = []
	foreach (nametag in tagtable) {
		tagarray.push(nametag)
	}
	tagarray.sort()
	
	return tagarray
}

//taglister ()

function savetabletofile(table,file_name){
	local tempfile = WriteTextFile ( fe.path_expand( prefs.affolder + file_name ) )
	foreach (cell,val in table){
		local savestring = "|"+cell
		for (local i = 0 ; i < val.len() ; i++){
			savestring = savestring + "|" + val[i]
		}
		savestring = savestring+"|\n"
		tempfile.write_line(savestring)
	}
}

function loadtablefromfile (file_name){
	local tempfile = ReadTextFile ( fe.path_expand( prefs.affolder + file_name ) )
	local table = {}
	while (!tempfile.eos()){
		local templine = tempfile.read_line()
		local temparray = split(templine,"|")
		local outarray = []
		for (local i = 1 ; i < temparray.len();i++){
			local tempval = temparray[i]
			try {
				tempval = tempval.tointeger()
			} catch (err) {
				if (tempval == "true") tempval = true
				else if (tempval =="false") tempval = false
			}
			outarray.push (tempval)
		}
		table[temparray[0]] <- outarray
	}
	return table
}

fe.do_nut("nut_picfunctions.nut")
dofile( prefs.affolder + "nut_fileutil.nut" )

/// Preferences functions and table  
function letterdrives(){
	local letters = "CDEFGHIJKLMNOPQRSTUVWXYZ"
	local drives = []
	for (local i = 0 ; i < letters.len() ; i++){
		if (fe.path_test ( letters[i].tochar() + ":" , PathTest.IsDirectory) ) drives.push (letters[i].tochar()+":\\")
	}
	
	//	return (drives.len() > 0 ? drives : ["/"])
	return drives
}

prefs.driveletters = letterdrives()

local prf = null

function languageflags() {
	local inputarray = languagetokenarray()
	local out = inputarray
	for (local i = 0 ; i < inputarray.len() ; i++) {
		out[i] = "flags" + out[i] + prefs.ext
	}
	return out
}

prefs.l0.push({label = "GENERAL", glyph = 0xe993, description = "Define the main options of Arcadeflow like number of rows, general layout, control buttons, language, thumbnail source etc"})
prefs.l1.push([
{v = 7.2, varname = "layoutlanguage", glyph = 0xe9ca, initvar = function(val,prf){prf.LAYOUTLANGUAGE <- val}, title = "Layout language", help = "Chose the language of the layout" , options = languagearray(), values = languagetokenarray(), selection = 0, picsel = languageflags(),pic="flags.jpg"},
{v = 7.2, varname = "boxartmode", glyph = 0xe918, initvar = function(val,prf){prf.BOXARTMODE <- val}, title = "Box Art mode", help = "Show box art or flyers instead of screen captures by default (can be configured with menu or hotkey)" , options = ["Yes","No"], values = [true,false], selection = 1, picsel = ["boxarton"+prefs.ext,"boxartoff"+prefs.ext], pic = "boxart"+prefs.ext},
{v = 7.2, varname = "titleonbox", glyph = 0xe918, initvar = function(val,prf){prf.TITLEONBOX <- val}, title = "Game title over box art", help = "Shows the game title artwork overlayed on the box art graphics" , options = ["Yes","No"], values = [true,false], selection = 1,picsel = ["boxarttitle"+prefs.ext,"boxarton"+prefs.ext],pic = "boxarttitle"+prefs.ext},
{v = 7.2, varname = "boxartsource", glyph = 0xe918, initvar = function(val,prf){prf.BOXARTSOURCE <- val}, title = "Box Art artwork source", help = "Chose the artwork source for box art graphics" , options = ["flyer", "fanart"], values = "", selection = 0 },
{v = 7.2, varname = "overmenubutton", glyph = 0xea54, initvar = function(val,prf){prf.OVERMENUBUTTON <- val}, title = "Context menu button", help = "Chose the button to open the game context menu" , options = ["None","Select", "Custom 1", "Custom 2", "Custom 3", "Custom 4", "Custom 5", "Custom 6"], values=["none","select", "custom1", "custom2", "custom3", "custom4", "custom5", "custom6"], selection = 1,pic = "contextmenu"+prefs.ext},
{v = 7.2, varname = "utilitymenubutton", glyph = 0xea54, initvar = function(val,prf){prf.UTILITYMENUBUTTON <- val}, title = "Utility menu button", help = "Chose the button to open the utility menu" , options = ["None", "Up", "Custom 1", "Custom 2", "Custom 3", "Custom 4", "Custom 5", "Custom 6"], values =["none", "up", "custom1", "custom2", "custom3", "custom4", "custom5", "custom6"], selection = 1,pic = "utilitymenu"+prefs.ext},
{v = 7.2, varname = "historybutton", glyph = 0xea54, initvar = function(val,prf){prf.HISTORYBUTTON <- val}, title = "History page button", help = "Chose the button to open the history or overview page" , options = ["None", "Select", "Custom 1", "Custom 2", "Custom 3", "Custom 4", "Custom 5", "Custom 6"], values =["none", "select", "custom1", "custom2", "custom3", "custom4", "custom5", "custom6"], selection = 0,pic = "utilitymenu"+prefs.ext},
{v = 7.2, varname = "switchmodebutton", glyph = 0xea54, initvar = function(val,prf){prf.SWITCHMODEBUTTON <- val}, title = "Thumbnail mode button", help = "Chose the button to use to switch from snapshot mode to box art mode" , options = ["None", "Custom 1", "Custom 2", "Custom 3", "Custom 4", "Custom 5", "Custom 6"], values=["none", "custom1", "custom2", "custom3", "custom4", "custom5", "custom6"], selection = 3,pic = "boxarton"+prefs.ext},
{v = 7.2, varname = "horizontalrows", glyph = 0xea72, initvar = function(val,prf){prf.HORIZONTALROWS <- val}, title = "Rows in horizontal", help = "Number of rows to use in 'horizontal' mode" , options = ["1-Small", "1", "2", "3"], values = [-1,1,2,3], selection = 2, picsel = ["rows1mini"+prefs.ext,"rows1"+prefs.ext,"rows2"+prefs.ext,"rows3"+prefs.ext],pic = "rows2"+prefs.ext},
{v = 7.2, varname = "verticalrows", glyph = 0xea71, initvar = function(val,prf){prf.VERTICALROWS <- val}, title = "Rows in vertical", help = "Number of rows to use in 'vertical' mode" , options = ["1", "2", "3"], values = [1,2,3], selection = 2, picsel = ["rowsv1"+prefs.ext,"rowsv2"+prefs.ext,"rowsv3"+prefs.ext],pic = "rowsv3"+prefs.ext},
{v = 7.2, varname = "cleanlayout", glyph = 0xe997, initvar = function(val,prf){prf.CLEANLAYOUT <- val}, title = "Clean layout", help = "Reduce game data shown on screen" , options = ["Yes","No"], values = [true,false], selection = 1, picsel = ["cleanyes"+prefs.ext,"cleanno"+prefs.ext],pic = "cleanyes"+prefs.ext},
{v = 7.2, varname = "showsubname", glyph = 0xea6d, initvar = function(val,prf){prf.SHOWSUBNAME <- val}, title = "Display Game Long Name", help = "Shows the part of the rom name with version and region data" , options = ["Yes","No"], values = [true,false], selection = 0, picsel = ["subdefaultname"+prefs.ext,"subnosubname"+prefs.ext]},
{v = 7.2, varname = "showsysname", glyph = 0xea6d, initvar = function(val,prf){prf.SHOWSYSNAME <- val}, title = "Display System Name", help = "Shows the System name under the game title" , options = ["Yes","No"], values = [true,false], selection = 0, picsel = ["subdefaultname"+prefs.ext,"subnosystem"+prefs.ext]},
{v = 7.2, varname = "showsysart", glyph = 0xea6d, initvar = function(val,prf){prf.SHOWSYSART <- val}, title = "System Name as artwork", help = "If enabled, the system name under the game title is rendered as a logo instead of plain text" , options = ["Yes","No"], values = [true,false], selection = 0, picsel = ["subdefaultname"+prefs.ext,"subnosystemart"+prefs.ext]},
{v = 7.2, varname = "scrollertype", glyph = 0xea45, initvar = function(val,prf){prf.SCROLLERTYPE <- val}, title = "Scrollbar style", help = "Select how the scrollbar should look" , options = ["Timeline", "Scrollbar", "Label List"], values = ["timeline", "scrollbar", "labellist"] , selection = 0, picsel = ["scrolltimeline"+prefs.ext,"scrollscrollbar"+prefs.ext,"scrolllabellist"+prefs.ext],pic="scroll"+prefs.ext},
{v = 7.2, varname = "striparticle", glyph = 0xea4c, initvar = function(val,prf){prf.STRIPARTICLE <- val}, title = "Strip article from sort", help = "When sorting by Title ignore articles" , options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "sortsave", glyph = 0xea4c, initvar = function(val,prf){prf.SORTSAVE <- val}, title = "Save sort order", help = "Custom sort order is saved through Arcadeflow sessions" , options = ["Yes","No"], values = [true,false], selection = 0},
{v = 7.2, varname = "baserotation", glyph = 0xea2e, initvar = function(val,prf){prf.BASEROTATION <- val}, title = "Screen rotation", help = "Rotate screen" , options = ["None", "Left", "Right", "Flip"], values =["none", "left", "right", "flip"], selection =0,picsel=["rotnone"+prefs.ext,"rotleft"+prefs.ext,"rotright"+prefs.ext,"rotflip"+prefs.ext],pic = "rotright"+prefs.ext},
{v = 7.2, varname = "lowres", glyph = 0xe997, initvar = function(val,prf){prf.LOWRES <- val}, title = "Low resolution", help = "Optimize theme for low resolution screens, 1 row layout forced, increased font size and cleaner layout" , options = ["Yes","No"], values = [true,false], selection = 1,picsel = ["lowreson"+prefs.ext,"lowresoff"+prefs.ext],pic = "lowreson"+prefs.ext},
])

prefs.l0.push({ label = "DISPLAYS MENU MODE", glyph = 0xe912, description = "Configure how Arcadeflow will look when used as Displays Menu layout"})
prefs.l1.push([
{v = 7.2, varname = "dmhorizontalrows", glyph = 0xea72, initvar = function(val,prf){prf.DMHORIZONTALROWS <- val}, title = "Displays Rows in horizontal", help = "Number of rows to use in 'horizontal' Displays Menu mode" , options = ["1-Small", "1", "2", "3"], values =[-1,1,2,3], selection = 2,picsel = ["dmrows1small"+prefs.ext,"dmrows1"+prefs.ext,"dmrows2"+prefs.ext,"dmrows3"+prefs.ext],pic = "dmrows2"+prefs.ext},
{v = 7.2, varname = "dmverticalrows", glyph = 0xea71, initvar = function(val,prf){prf.DMVERTICALROWS <- val}, title = "Displays Rows in vertical", help = "Number of rows to use in 'vertical' Displays Menu mode" , options = ["1", "2", "3"], values = [1,2,3], selection = 2,picsel = ["dmrowsv1"+prefs.ext,"dmrowsv2"+prefs.ext,"dmrowsv3"+prefs.ext],pic = "dmrowsv3"+prefs.ext},
{v = 7.2, varname = "dmmissingwheel", glyph = 0xea6d, initvar = function(val,prf){prf.DMMISSINGWHEEL <- val}, title = "Generate missing name art", help = "If no display title is present, the layout can generate it" , options = ["Yes","No"], values = [true,false], selection = 0,picsel=["dmtitleyes"+prefs.ext,"dmtitleno"+prefs.ext],pic = "dmtitle"+prefs.ext},
{v = 7.2, varname = "dmthumbvideo", glyph = 0xe913, initvar = function(val,prf){prf.DMTHUMBVIDEO <- val}, title = "Enable video thumbnails", help = "Enable video thumbnails for Displays Menu mode if it's enabled in normal layout pages", options = ["Yes", "No"], values = [true,false], selection = 1}
])

prefs.l0.push({ label = "DISPLAYS MENU PAGE", glyph = 0xe912, description = "Arcadeflow has its own Displays Menu page that can be configured here"})
prefs.l1.push([
{v = 7.2, varname = "dmpimages", glyph = 0xea7a, initvar = function(val,prf){prf.DMPIMAGES <- val}, title = "Displays menu layout", help = "Chose the style to use when entering displays menu, a simple list or a list plus system artwork taken from the menu-art folder" , options = ["List", "List with artwork"], values= [false,true],selection = 0, picsel = ["dmplistartno"+prefs.ext,"dmplistartyes"+prefs.ext],pic = "dmplistartyes"+prefs.ext},
{v = 7.3, varname = "dmpgrouped", glyph = 0xea7a, initvar = function(val,prf){prf.DMPGROUPED <- val}, title = "Grouped displays menu", help = "Displays menu will be grouped by system: Arcades, Computer, Handhelds and Consoles and Others for collections" , options = ["Yes", "No"], values= [true,false],selection = 0, picsel = ["dmpgroupedyes"+prefs.ext,"dmpgroupedno"+prefs.ext],pic = "dmpgroupedyes"+prefs.ext},
{v = 7.2, varname = "dmpgeneratelogo", glyph = 0xe90d, initvar = function(val,prf){prf.DMPGENERATELOGO <- val}, title = "Generate display logo", help = "Generate displays name related artwork for displays list" , options = ["Yes","No"], values = [true,false], selection = 0,picsel=["dmplistlogoyes"+prefs.ext,"dmplistlogono"+prefs.ext], pic = "dmplistlogo"+prefs.ext},
])

prefs.l0.push({ label = "PERFORMANCE & FX", glyph = 0xe9a6, description = "Turn on or off special effects that might impact on Arcadeflow performance"})
prefs.l1.push([
{v = 7.2, varname = "lowspecmode", glyph = 0xe994, initvar = function(val,prf){prf.LOWSPECMODE <- val}, title = "Low Spec mode", help = "Reduce most visual effects to boost speed on lower spec systems" , options = ["Yes","No"], values = [true,false], selection = 1, picsel=["lslowspec"+prefs.ext,"lsdefault"+prefs.ext], pic = "lslowspec1"+prefs.ext},
{v = 7.2, varname = "customsize", glyph = 0xe994, initvar = function(val,prf){prf.CUSTOMSIZE <- val}, title = "Resolution W x H", help = "Define a custom resolution for your layout independent of screen resolution. Format is WIDTHxHEIGHT, leave blank for default resolution", options = "", values = "", selection = -1, pic = "customresyes"+prefs.ext},
{v = 7.2, varname = "enhancedmenu", glyph = 0xe994, initvar = function(val,prf){prf.ENHANCEDMENU <-val}, title = "Enhanced menu system", help = "Enable advanced menu with smooth scrolling and graphics effects", options = ["Yes","No"], values = [true,false], selection = 0, picsel=["enmenuon"+prefs.ext,"enmenuoff"+prefs.ext], pic = "enmenu"+prefs.ext}, 
{v = 7.2, varname = "datashadowsmooth", glyph = 0xe994, initvar = function(val,prf){prf.DATASHADOWSMOOTH <- val}, title = "Smooth shadow", help = "Enable smooth shadow under game title and data in the GUI" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["lsdefault"+prefs.ext,"lsnodrop"+prefs.ext], pic = "lsdrop"+prefs.ext},
{v = 7.2, varname = "frostedglass", glyph = 0xe994, initvar = function(val,prf){prf.FROSTEDGLASS <- val}, title = "Frosted glass", help = "Enable a frosted glass effect for overlay menus" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["frostedyes"+prefs.ext,"frostedno"+prefs.ext],pic = "frosted"+prefs.ext},
{v = 7.2, varname = "snapglow", glyph = 0xe994, initvar = function(val,prf){prf.SNAPGLOW <- val}, title = "Glow effect", help = "Add a glowing halo around the selected game thumbnail" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["lsdefault"+prefs.ext,"lsnoglow"+prefs.ext],pic = "lsglow"+prefs.ext},
{v = 7.2, varname = "logoshadow", glyph = 0xe994, initvar = function(val,prf){prf.LOGOSHADOW <- val}, title = "Logo smooth shadow", help = "Enable smooth shadows under game logo" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["lsdefault"+prefs.ext,"lslogoshadow"+prefs.ext],pic = "lslogoshadow1"+prefs.ext},
{v = 7.2, varname = "snapgradient", glyph = 0xe994, initvar = function(val,prf){prf.SNAPGRADIENT <- val}, title = "Thumb gradient", help = "Blurs the artwork behind the game logo so it's more readable" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["lsdefault"+prefs.ext,"lsgradient"+prefs.ext],pic = "lsgradient1"+prefs.ext},
])

prefs.l0.push({ label = "THUMBNAILS", glyph = 0xe915, description = "Chose the aspect ratio of thumbnails, video thumbnails and decorations"})
prefs.l1.push([
{v = 7.2, varname = "cropsnaps", glyph = 0xea57, initvar = function(val,prf){prf.CROPSNAPS <- val}, title = "Aspect ratio", help = "Chose wether you want cropped, square snaps or adaptive snaps depending on game orientation" options = ["Adaptive", "Square"], values = [false, true], selection = 0, picsel= ["aradaptive"+prefs.ext,"arsquare"+prefs.ext],pic = "arsquare"+prefs.ext},
{v = 7.2, varname = "thumbvideo", glyph = 0xe913, initvar = function(val,prf){prf.THUMBVIDEO <- val}, title = "Video thumbs", help = "Enable video overlay on snapshot thumbnails" , options = ["Yes","No"], values = [true,false], selection = 0},
{v = 7.2, varname = "thumbvidelay", glyph = 0xe913, initvar = function(val,prf){prf.THUMBVIDELAY <- val}, title = "Video delay multiplier", help = "Increase video load delay" , options = ["1x", "2x","3x","4x","5x"], values = [1,2,3,4,5], selection = 0},
{v = 7.2, varname = "missingwheel", glyph = 0xea6d, initvar = function(val,prf){prf.MISSINGWHEEL <- val}, title = "Generate missing title art", help = "If no game title is present, the layout can generate it" , options = ["Yes","No"], values = [true,false], selection = 0,picsel = ["missingwheelyes"+prefs.ext,"missingwheelno"+prefs.ext],pic = "missingwheel"+prefs.ext},
{v = 7.2, varname = "newgame", glyph = 0xe936, initvar = function(val,prf){prf.NEWGAME <- val}, title = "New game indicator", help = "Games not played are marked with a glyph" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["decornewgame"+prefs.ext,"decornone"+prefs.ext],pic = "decornewgame"+prefs.ext},
{v = 7.2, varname = "tagshow", glyph = 0xe936, initvar = function(val,prf){prf.TAGSHOW <- val}, title = "Show tag indicator", help = "Shows a tag attached to thumbnails that contains any tag" , options = ["Yes","No"], values = [true,false], selection = 0, picsel=["decortag"+prefs.ext,"decornone"+prefs.ext],pic = "decortag"+prefs.ext},
{v = 7.2, varname = "tagname", glyph = 0xe936, initvar = function(val,prf){prf.TAGNAME <- val}, title = "Custom tag name", help = "You can see a tag glyph overlayed to the thumbs, chose the tag name to use", options = "", values = "", selection = -1}, 
{v = 7.2, varname = "gbrecolor", glyph = 0xe90c, initvar = function(val,prf){prf.GBRECOLOR <- val}, title = "Game Boy color correction", help = "Apply a colorized palette to Game Boy games based on the system name or forced to your preference" , options = ["Automatic", "Classic", "Pocket", "Light", "None"], values = ["AUTO", "LCDGBC", "LCDGBP", "LCDGBL" ,"NONE"], selection = 0, picsel = ["gb"+prefs.ext,"gbclassic"+prefs.ext,"gbpocket"+prefs.ext,"gblight"+prefs.ext,"gbnone"+prefs.ext],pic = "gb"+prefs.ext},
])

prefs.l0.push({ label = "BACKGROUND", glyph = 0xe90c, description = "Chose the layout background theme in main page and in History page, or select custom backgrounds"})
prefs.l1.push([
{v = 7.2, varname = "colortheme", glyph = 0xe90c, initvar = function(val,prf){prf.COLORTHEME <- val}, title = "Overlay color", help = "Setup theme luminosity overlay, Basic is slightly muted, Dark is darker, Light has a white overlay and dark text, Pop keeps the colors unaltered" , options = ["Basic", "Dark", "Light", "Pop"], values =["basic", "dark", "light", "pop"], selection = 3, picsel = ["overlaybasic"+prefs.ext,"overlaydark"+prefs.ext,"overlaylight"+prefs.ext,"overlaypop"+prefs.ext], pic = "overlay"+prefs.ext},
{v = 7.2, varname = "bgcustom", glyph = 0xe930, initvar = function(val,prf){prf.BGCUSTOM <- val}, title = "Custom main BG image", help = "Insert custom background art path (use grey.png for blank background, vignette.png for vignette overlay)", options = "", values = "", selection = -3,pic="bgcustom"+prefs.ext},
{v = 7.2, varname = "bgcustomhistory", glyph = 0xe930, initvar = function(val,prf){prf.BGCUSTOMHISTORY <- val}, title = "Custom history BG image", help = "Insert custom background art path for history page (leave blank if the same as main background)", options = "", values ="", selection = -3,pic="bgcustomhistory"+prefs.ext},
{v = 7.2, varname = "layersnap", glyph = 0xe90d, initvar = function(val,prf){prf.LAYERSNAP <- val}, title = "Background snap", help = "Add a faded game snapshot to the background" , options = ["Yes","No"], values = [true,false], selection = 1, picsel = ["bgsnapyes"+prefs.ext,"bgsnapno"+prefs.ext],pic="bgsnap"+prefs.ext},
{v = 7.2, varname = "layervideo", glyph = 0xe913, initvar = function(val,prf){prf.LAYERVIDEO <- val}, title = "Animate BG snap", help = "Animate video on background" , options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "layervidelay", glyph = 0xe913, initvar = function(val,prf){prf.LAYERVIDELAY <- val}, title = "Delay BG animation", help = "Don't load immediately the background video animation" , options = ["Yes","No"], values = [true,false], selection = 1},
])

prefs.l0.push({ label = "LOGO", glyph = 0xe916, description = "Customize the splash logo at the start of Arcadeflow"})
prefs.l1.push([
{v = 7.2, varname = "splashon", glyph = 0xe916, initvar = function(val,prf){prf.SPLASHON <- val}, title = "Enable splash logo", help = "Enable or disable the AF start logo" , options = ["Yes","No"], values = [true,false], selection = 0,picsel = ["logoyes"+prefs.ext,"logono"+prefs.ext], pic = "logoyes"+prefs.ext},
{v = 7.2, varname = "splashlogofile", glyph = 0xe930, initvar = function(val,prf){prf.SPLASHLOGOFILE <- val}, title = "Custom splash logo", help = "Insert the path to a custom AF splash logo (or keep blank for default logo)", options = "", values ="", selection=-3,pic = "logocustom"+prefs.ext},
])

prefs.l0.push({ label = "ATTRACT MODE", glyph = 0xe9a5, description = "Arcadeflow has its own attract mode screensaver that kicks in after some inactivity. Configure all the options here"})
prefs.l1.push([
{v = 7.2, varname = "amenable", glyph = 0xe9a5, initvar = function(val,prf){prf.AMENABLE <- val}, title = "Enable attract mode", help = "Enable or disable attract mode at layout startup" , options = ["From start", "Inactivity only", "Disabled"], values =["From start", "Inactivity only", "Disabled"], selection = 1,pic = "attractmode"+prefs.ext},
{v = 7.2, varname = "amtune", glyph = 0xe911, initvar = function(val,prf){prf.AMTUNE <- val}, title = "Background music", help = "Path to a music file to play in background", options = "", values ="", selection = -3},
{v = 7.2, varname = "amsound", glyph = 0xea27, initvar = function(val,prf){prf.AMSOUND <- val}, title = "Enable game sound", help = "Enable game sounds during attract mode" , options = ["Yes","No"], values = [true,false], selection = 0},
{v = 7.2, varname = "amtimer", glyph = 0xe94e, initvar = function(val,prf){prf.AMTIMER <- val}, title = "Attract mode timer (s)", help = "Inactivity timer before attract mode is enabled", options = "", values ="120", selection=-1},
{v = 7.2, varname = "amchangetimer", glyph = 0xe94e, initvar = function(val,prf){prf.AMCHANGETIMER <- val}, title = "Game change time (s)", help = "Time interval between each game change", options = "", values = "10", selection=-1},
{v = 7.2, varname = "ammessage", glyph = 0xea6d, initvar = function(val,prf){prf.AMMESSAGE <- val}, title = "Attract message", help = "Text to show during attract mode", options = "", values = " - PRESS ANY KEY - ", selection = -1,pic = "attractmode"+prefs.ext},
])

prefs.l0.push({ label = "SEARCH", glyph = 0xe986, description = "Configure the search page"})
prefs.l1.push([
{v = 7.2, varname = "keyboard", glyph = 0xe955, initvar = function(val,prf){prf.KEYBOARD <- val}, title = "Search entry method", help = "Use keyboard or on-screen keys to enter search string" , options = ["Keyboard", "Screen keys"], values =[true, false], selection = 1,picsel=["inputkeyboard"+prefs.ext,"inputscreenkeys"+prefs.ext],pic="inputscreenkeys"+prefs.ext},
{v = 7.2, varname = "livesearch", glyph = 0xe985, initvar = function(val,prf){prf.LIVESEARCH <- val}, title = "Immediate search", help = "Live update results while searching" , options = ["Yes","No"], values = [true,false], selection = 0},
])

prefs.l0.push({ label = "HISTORY", glyph = 0xe923, description = "Configure the History page where larger thumbnail and game history data are shown"})
prefs.l1.push([
{v = 7.2, varname = "scanlinemode", glyph = 0xe95b, initvar = function(val,prf){prf.SCANLINEMODE <- val}, title = "Scanline effect", help = "Select scanline effect: Scanlines = default scanlines, Aperture = aperture mask, Half Resolution = reduced scanline resolution to avoid moiree, None = no scanline" options = ["Scanlines", "Half Resolution", "Aperture", "None"], values =["scanlines", "halfres", "aperture", "none"], selection = 2, picsel = ["slscanline"+prefs.ext,"slhalfres"+prefs.ext,"slaperture"+prefs.ext,"slnone"+prefs.ext],pic = "sl"+prefs.ext},
{v = 7.2, varname = "lcdmode", glyph = 0xe959, initvar = function(val,prf){prf.LCDMODE <- val}, title = "LCD effect", help = "Select LCD effect for handheld games: Matrix = see dot matrix, Half Resolution = see matrix at half resolution, None = no effect", options = ["Matrix", "Half Resolution", "None"], values = ["matrix", "halfres", "none"], selection = 1, picsel = ["lcdmatrix"+prefs.ext, "lcdhalfres"+prefs.ext, "lcdnone"+prefs.ext],pic = "lcd"+prefs.ext},
{v = 7.2, varname = "historypanel", glyph = 0xe923, initvar = function(val,prf){prf.HISTORYPANEL <- val}, title = "Text panel style", help = "Select the look of the history text panel", options = ["White panel", "Background"], values = [true,false], selection = 0, picsel = ["histpanelyes"+prefs.ext,"histpanelno"+prefs.ext],pic="histpanelyes"+prefs.ext},
{v = 7.2, varname = "darkpanel", glyph = 0xe923, initvar = function(val,prf){prf.DARKPANEL <- val}, title = "Game panel style", help = "Select the look of the history game panel", options = ["Dark", "Standard", "None"], values = [true,false,null], selection = 1,picsel=["histpaneldark"+prefs.ext,"histpaneldefault"+prefs.ext,"histpanelnone"+prefs.ext],pic = "histpaneldefault"+prefs.ext},
{v = 7.2, varname = "dat_path", glyph = 0xe930, initvar = function(val,prf){prf.DAT_PATH <- val}, title = "History.dat", help = "History.dat location.", options = "", values = "", selection = -3},
{v = 7.2, varname = "index_clones", glyph = 0xe922, initvar = function(val,prf){prf.INDEX_CLONES <- val}, title = "Index clones", help = "Set whether entries for clones should be included in the index. Enabling this will make the index significantly larger" , options = ["Yes","No"], values = [true,false], selection = 0},
{v = 7.2, varname = "generate", glyph = 0xea1c, initvar = function(val,prf){prf.GENERATE <- val}, title = "Generate index", help = "Generate the history.dat index now (this can take some time)", options = "" , values = function(){local tempprf = generateprefstable(); af_generate_index(tempprf)}, selection = -2},
])

prefs.l0.push({ label = "AUDIO", glyph = 0xea27, description = "Configure layout sounds and audio options for videos"})
prefs.l1.push([
{v = 7.2, varname = "themeaudio", glyph = 0xea27, initvar = function(val,prf){prf.THEMEAUDIO <- val}, title = "Enable theme sounds", help = "Enable audio sounds when browsing and moving around the theme" options = ["Yes","No"], values = [true,false], selection = 0},
{v = 7.2, varname = "audiovidsnaps", glyph = 0xea27, initvar = function(val,prf){prf.AUDIOVIDSNAPS <- val}, title = "Audio in videos (thumbs)", help = "Select wether you want to play audio in videos on thumbs" , options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "audiovidhistory", glyph = 0xea27, initvar = function(val,prf){prf.AUDIOVIDHISTORY <- val}, title = "Audio in videos (history)", help = "Select wether you want to play audio in videos on history detail page" , options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "backgroundtune", glyph = 0xe911, initvar = function(val,prf){prf.BACKGROUNDTUNE <- val}, title = "Layout background music", help = "Chose a background music file to play while using Arcadeflow" ,  options = "", values ="", selection = -3},
{v = 7.2, varname = "nobgonattract", glyph = 0xe911, initvar = function(val,prf){prf.NOBGONATTRACT <- val}, title = "Stop bg music in attract mode", help = "Stops playing the layout background music during attract mode" ,  options = ["Yes","No"], values =[true,false] selection = 0},
])

prefs.l0.push({ label = "DEBUG", glyph = 0xe998, description = "This section is for debug purposes only"})
prefs.l1.push([
{v = 7.2, varname = "fpson", glyph = 0xe998, initvar = function(val,prf){prf.FPSON <- val}, title = "FPS counter", help = "DEBUG FPS COUNTER" options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "debugmode", glyph = 0xe998, initvar = function(val,prf){prf.DEBUGMODE <- val}, title = "DEBUG mode", help = "Enter DEBUG mode, increased output logging" options = ["Yes","No"], values = [true,false], selection = 1},
{v = 7.2, varname = "oldoptions", glyph = 0xe998, initvar = function(val,prf){prf.OLDOPTIONS <- val}, title = "AM options page", help = "Shows the default Attract-Mode options page" options = "", values = function(){prf.OLDOPTIONSPAGE = true; prefs.getout = true; fe.signal("layout_options");fe.signal("reload")}, selection = -2},

{v = 7.2, varname = "resetlayout", glyph = 0xe998, initvar = function(val,prf){prf.RESETLAYOUT <- val}, title = "Reset all options", help = "Restore default settings for all layout options, erase sorting options, language options and thumbnail options" options = "", values = function(){ prefs.getout = true;reset_layout()}, selection = -2},
])

function reset_layout() {
	/*
	local tempfile = null
	savelanguage("EN")
	tempfile = WriteTextFile ( prefs.affolder + "pref_sortorder.txt" )
	tempfile.write_line("")
	tempfile = WriteTextFile ( prefs.affolder + "pref_thumbtype.txt" )
	tempfile.write_line("")
	saveprefdata(prefs.defaultprf)
	//tempfile = WriteTextFile ( prefs.affolder + "pref_layoutoptions.txt" )
	//tempfile.write_line("")
	*/
	
	try { remove (prefs.affolder + "pref_savedlanguage.txt") } catch (err) {}
	try { remove (prefs.affolder + "pref_sortorder.txt") } catch (err) {}
	try { remove (prefs.affolder + "pref_thumbtype.txt") } catch (err) {}
	try { remove (prefs.affolder + "pref_layoutoptions.txt") } catch (err) {}
	fe.signal("exit_to_desktop")
}

// Translate preference data structure
/*for (local i = 0 ; i < prefs.l0.len() ; i ++) {
	prefs.l0[i].label = ltxt(prefs.l0[i].label,TLNG)
	prefs.l0[i].description = ltxt(prefs.l0[i].description,TLNG)
	prefs.a0.push (prefs.l0[i].label)
	prefs.gl0.push (prefs.l0[i].glyph)
}
*/
for (local i = 0 ; i < prefs.l1.len() ; i ++) {
	local isnewparent = false
	for (local j = 0 ; j < prefs.l1[i].len() ; j ++) {
		local isnew =  (prefs.l1[i][j].v.tofloat() == AFVERSION.tofloat())
		prefs.l1[i][j].title = (isnew ? "❗ " : "") + ltxt(prefs.l1[i][j].title,TLNG) + (isnew ? " ❗" : "")
		prefs.l1[i][j].help = ltxt(prefs.l1[i][j].help,TLNG)
		prefs.l1[i][j].options = ltxtarray(prefs.l1[i][j].options,TLNG)
		if (isnew) isnewparent = true
	}
	prefs.l0[i].label = (isnewparent ? "❗ " : "") + ltxt(prefs.l0[i].label,TLNG) + (isnewparent ? " ❗" : "")
	prefs.l0[i].description = ltxt(prefs.l0[i].description,TLNG)
	prefs.a0.push (prefs.l0[i].label)
	prefs.gl0.push (prefs.l0[i].glyph)	
}

// GENERATE ABOUT FILE

function abouttext(){
	local about = []
	about.push ( "Arcadeflow v." + AFVERSION )
	about.push("")
	for (local i = 0 ; i < prefs.l0.len() ; i++){
		about.push (prefs.l0[i].label)
		about.push (prefs.l0[i].description)
		about.push("")
		for (local j = 0 ; j < prefs.l1[i].len() ; j++) {
			about.push ("- '" + prefs.l1[i][j].title + "'" + " : " + prefs.l1[i][j].help)
		}	
		about.push ("")
	}
	return (about)
}

function saveabout(){
   local aboutpath = fe.path_expand( prefs.affolder + "about.txt")
   local aboutfile = WriteTextFile (aboutpath)
   local about = abouttext()
	for (local i = 0 ; i < about.len() ; i++){
		aboutfile.write_line(about[i]+"\n")
	}
}

//saveabout()

// Reads data from the preferences structures and builds the preferences variable table
// This is the table with the values used in the layout like prf.BOXARTMODE = true etc
function generateprefstable(){
   local prf = {}
   for (local i = 0 ; i < prefs.l0.len() ; i++){
      for (local j = 0 ; j < prefs.l1[i].len() ; j++){
         local tempdat = prefs.l1[i][j]
         if (tempdat.selection >=0) tempdat.initvar(((tempdat.values != "") ? tempdat.values[tempdat.selection] : tempdat.options[tempdat.selection]),prf)
         else if (tempdat.selection != -2) tempdat.initvar(tempdat.values,prf) //-2 is the function execution
      }
   }
   return prf
}

// Reads data from the preferences structures and builds the selections variable table
// These values are the selections on the prefs and are used for save/load
// This table contains the NAME of the variable (like "BOXARTMODE" and the current selection like 0, 1, 2 etc )
function generateselectiontable(){
   local prf = {}
   for (local i = 0 ; i < prefs.l0.len() ; i++){
      for (local j = 0 ; j < prefs.l1[i].len() ; j++){
         local tempdat = prefs.l1[i][j]
         if (tempdat.selection >=0) tempdat.initvar(tempdat.selection,prf)
         else if (tempdat.selection != -2) tempdat.initvar(tempdat.values,prf)
      }
   }
   return prf
}

// Input output functions should save and load the SELECTION value, not the actual value. 
// Therefore saveprefdata must be called on a table generated with generateselectiontable()
function saveprefdata(prf){
   local prfpath = fe.path_expand( prefs.affolder+"pref_layoutoptions.txt")
   local prffile = WriteTextFile (prfpath)
	prffile.write_line (AFVERSION+"\n")
   foreach (label, val in prf){
      prffile.write_line ("|" + label + "|" + val+"|\n")
   }
}

// readprefdata() reads values of a selection and puts them in the preferences structure. 
// To use this values in the layout preferences variable must be recreated using generateprefstable()

function readprefdata(){
   local prfpath = fe.path_expand( prefs.affolder+"pref_layoutoptions.txt")
   local prffile = ReadTextFile (prfpath)
   local ptable = {}
	local version = ""
	try {	version = prffile.read_line() } catch (err) {
		fe.overlay.splash_message ("Error reading prefs file, resetting to default")
		return false
	}

	// if (version != AFVERSION) {
	//		fe.overlay.splash_message ("Preference version different from AF version, resetting to default")
	//		return false
	//	}
	// else {
		local warnmessage = ""
		while (!prffile.eos()){
			local templine = prffile.read_line()
			local z = split (templine,"|")

			for (local i = 0 ; i < prefs.l0.len() ; i++){
				for (local j = 0 ; j < prefs.l1[i].len() ; j++){
					local tempdat = prefs.l1[i][j] //Instancing!

					if (tempdat.varname.toupper() == z[0]) {

						if (tempdat.v.tofloat() <= version.tofloat() ) {
						/*
							if (z[1] == "sel") tempdat.selection = z[2].tointeger()
							else if (z.len() == 2) tempdat.values = ""
							else tempdat.values = z[2]
						*/
							if (tempdat.selection >= 0) tempdat.selection = z[1].tointeger()
							else if (z.len() == 1) tempdat.values = ""
							else tempdat.values = z[1]               
						}
						else {
							//TEST73
							warnmessage = warnmessage + ("- "+ tempdat.title + "\n")
						}
					}
				}
			}		
		}
		if (warnmessage != "") {
			fe.overlay.splash_message ("Reset prefs:\n\n" + warnmessage)
			return false
		}
	return true
	// }
}



/// Layout start ///


local transdata = ["StartLayout", "EndLayout", "ToNewSelection","FromOldSelection","ToGame","FromGame","ToNewList","EndNavigation","ShowOverlay","HideOverlay","NewSelOverlay","ChangedTag"]

local orderdatalabel = {}
orderdatalabel [Info.System] <- split(ltxt("_System",TLNG),"_")[0]
orderdatalabel [Info.Name] <- split(ltxt("_Name",TLNG),"_")[0]
orderdatalabel [Info.Title] <- split(ltxt("_Title",TLNG),"_")[0]
orderdatalabel [Info.Emulator] <- split(ltxt("_Emul",TLNG),"_")[0]
orderdatalabel [Info.CloneOf] <- split(ltxt("_Clone",TLNG),"_")[0]
orderdatalabel [Info.Year] <- split(ltxt("_Year",TLNG),"_")[0]
orderdatalabel [Info.Manufacturer] <- split(ltxt("_Manuf",TLNG),"_")[0]
orderdatalabel [Info.Category] <- split(ltxt("_Categ",TLNG),"_")[0]
orderdatalabel [Info.Players] <- split(ltxt("_Players",TLNG),"_")[0]
orderdatalabel [Info.Rotation] <- split(ltxt("_Rot",TLNG),"_")[0]
orderdatalabel [Info.Control] <- split(ltxt("_Cntrl",TLNG),"_")[0]
orderdatalabel [Info.Status] <- split(ltxt("_Status",TLNG),"_")[0]
orderdatalabel [Info.DisplayCount] <- split(ltxt("_DispCt",TLNG),"_")[0]
orderdatalabel [Info.DisplayType] <- split(ltxt("_DispTp",TLNG),"_")[0]
orderdatalabel [Info.AltRomname] <- split(ltxt("_AltRomn",TLNG),"_")[0]
orderdatalabel [Info.AltTitle] <- split(ltxt("_AltTitle",TLNG),"_")[0]
orderdatalabel [Info.Extra] <- split(ltxt("_Extra",TLNG),"_")[0]
orderdatalabel [Info.Favourite] <- split(ltxt("_Fav",TLNG),"_")[0]
orderdatalabel [Info.Tags] <- split(ltxt("_Tags",TLNG),"_")[0]
orderdatalabel [Info.PlayedCount] <- split(ltxt("_PlCount",TLNG),"_")[0]
orderdatalabel [Info.PlayedTime] <- split(ltxt("_PlTime",TLNG),"_")[0]
orderdatalabel [Info.FileIsAvailable] <- split(ltxt("_Avail",TLNG),"_")[0]





function readsystemdata(){
	local unilogos = [" ","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""]
	local sysdata = {}
	local sysinc = 0
	local syspath = fe.path_expand( prefs.affolder+"data_systems.txt")
	local sysfile = ReadTextFile(syspath)
	local tempcell = {}

	while ( !sysfile.eos() ) {
		local line = sysfile.read_line()
		if (line != ""){
			local linearray = split (line,",")
			if (linearray.len() > 1){

				sysdata[linearray[0]] <- {
					w = linearray[1].tofloat()
					h = linearray[2].tofloat()
					label = linearray[3]
					screen = linearray[4]
					group = linearray[5]
					logo = unilogos[sysinc]
				}
				tempcell = sysdata[linearray[0]]
			}
			else {
				sysdata[linearray[0]] <- tempcell
			}
		}
		else {
			sysinc++
		}
	}

return sysdata

}

local system_data = readsystemdata()

// prf is the table that cotains all the layout variables as they are used in the layout, like prf.CROPSNAPS etc
// this command generate default prefs table, this contains the variable names and values as used in the layout (not the selections)
prf = generateprefstable()
//local prfval = generateselectiontable()

// This function generates a clone of the "prefs" table (the one with all the data, not the variable table)
// It can be used as a reference to reset the save file to default values
prefs.defaultprf = generateselectiontable()

// tries to load variables from file and regenerates list
try {
	// This function loads saved data into the current "prefs" data structure
	readprefdata()
	// Then this data is used to generate the new prf file with variables to use in the layout
	prf = generateprefstable()
}
catch (err){print("Error loading prefs file\n")}

// readprefsdata returns false if there is an issue with the file or if some options need to be reset
if (readprefdata() == false) {
	saveprefdata(generateselectiontable())
	//	prf = generateprefstable()
	//	TLNG = prf.LAYOUTLANGUAGE
	//	savelanguage(TLNG)
	//	fe.signal("reload")
}

//This is used for parameters that can be changed dynamically with respect to the saved value
local prfzero = {}
foreach (item, val in prf){
	prfzero [item] <- val
}

// Prefs variables used as temporary checks for using grouped displays menu
prf.JUMPDISPLAYS <- false //This is used for group display jump, to avoid reordering lists until we are at the right spot
prf.JUMPSTEPS <- 0
prf.JUMPSHOW <- false

prf.OLDOPTIONSPAGE <- false

prf.SPLASHLOGOFILE = ( prf.SPLASHLOGOFILE == "" ? "aflogow3.png" : prf.SPLASHLOGOFILE),

prf.AMSTART <- (prf.AMENABLE == "From start")
prf.AMENABLE = (prf.AMENABLE != "Disabled")

prf.DISPLAYLISTON <- false
prf.DISPLAYMENUON <- null
prf.ZMENUON <-false

prf.SLIMLINE <- false

// Set and save debug mode
DEBUG = prf.DEBUGMODE
savedebug(DEBUG ? "true" : "false")

// Set and save layout language
TLNG = prf.LAYOUTLANGUAGE
savelanguage(TLNG)

// Save selected layout file
//savelayout (prf.LAYOUTFILE)

if ( 
	( ( prf.UTILITYMENUBUTTON != "none") && (prf.UTILITYMENUBUTTON == prf.OVERMENUBUTTON ) )
	|| 
	( ( prf.UTILITYMENUBUTTON != "none") && (prf.UTILITYMENUBUTTON == prf.SWITCHMODEBUTTON ) )
	||
	( ( prf.UTILITYMENUBUTTON != "none") && (prf.UTILITYMENUBUTTON == prf.HISTORYBUTTON ) )
	||
	( ( prf.SWITCHMODEBUTTON != "none") && (prf.SWITCHMODEBUTTON == prf.OVERMENUBUTTON ) )
	|| 
	( ( prf.SWITCHMODEBUTTON != "none") && (prf.SWITCHMODEBUTTON == prf.UTILITYMENUBUTTON ) )
	||
	( ( prf.SWITCHMODEBUTTON != "none") && (prf.SWITCHMODEBUTTON == prf.HISTORYBUTTON ) )
	) 
	fe.overlay.splash_message ("WARNING: Conflict in Arcadeflow button assignment")


try {prf.AMTIMER = prf.AMTIMER.tointeger()}
catch (err) {prf.AMTIMER = 120}

try {prf.AMCHANGETIMER = prf.AMCHANGETIMER.tointeger()}
catch (err) {prf.AMCHANGETIMER = 10}

if (prf.BASEROTATION == "none") fe.layout.base_rotation = RotateScreen.None
else if (prf.BASEROTATION == "left") fe.layout.base_rotation = RotateScreen.Left
else if (prf.BASEROTATION == "right") fe.layout.base_rotation = RotateScreen.Right
else if (prf.BASEROTATION == "flip") fe.layout.base_rotation = RotateScreen.Flip

local DISPLAYTABLE = {}
try { DISPLAYTABLE = loadtablefromfile("pref_thumbtype.txt") } catch (err) {}

local SORTTABLE = {}
try { SORTTABLE = loadtablefromfile("pref_sortorder.txt") } catch (err) {}

// Displays Menu detection
prf.DISPLAYMENUON = (fe.list.display_index == -1)
local displaystore = fe.list.display_index

if (prf.DISPLAYMENUON) {
	prf.CROPSNAPS = true
	prf.OVERMENUBUTTON = ""
	prf.SCROLLERTYPE = "scrollbar"
	if (!prf.DMTHUMBVIDEO) prf.THUMBVIDEO = false
	prf.LAYERSNAP = false
	prf.MISSINGWHEEL = prf.DMMISSINGWHEEL
}

try {
	prf.BOXARTMODE = ( (DISPLAYTABLE[fe.displays[fe.list.display_index].name][0] == "BOXES") ? true : false )
}
catch (err){}

if (prf.LOWSPECMODE){ 
	prf.FROSTEDGLASS = false
	prf.DATASHADOWSMOOTH = false
	prf.LOGOSHADOW = false
	prf.SNAPGRADIENT = false
	prf.SNAPGLOW = false
	prf.ENHANCEDMENU = false
}

// cleanup frosted glass screen grabs
local dir0 = {
	dir = DirectoryListing( FeConfigDirectory )
	fpos01 = null
	fpos02 = null
}

// workaround when no screenshots are present in the folder
if (file_exist(FeConfigDirectory+"screen.png") == false){
	fe.signal ("screenshot")
}

foreach ( f in dir0.dir.results ){
	dir0.fpos01 = f.find(".png")
	dir0.fpos02 = f.find("frostgrab")
	if ((dir0.fpos01 != null) && (dir0.fpos02 != null)){
		remove(f)
	}
}

// Background and data crossfade stack

local bgvidsurf = null

local bgs = {
	stacksize = (prf.LOWSPECMODE ? 3 : 5)
	bgpic_array = []
	bgvid_array = []
	alphapos = []
	bg_lcd = []
	bg_mono = []
	bg_box = []
}

local dat = {
	stacksize = (prf.LOWSPECMODE ? 3 : 5)
	var_array = []
	cat_array = []
	but_array = []
	ctl_array = []
	ply_array = []
	mainctg_array = []
	manufacturer_array = []
	manufacturername_array = []
	gamename_array = []
	gamesubname_array = []
	gameyear_array = []
	alphapos = []
}

// Initialize variables
local var = 0
local z_var = 0

// Fade data: [0 - FADE COUNTER, 1 - FADE VALUE, 2 - FADE STARTER, 3 - FADE INCREASER, 4 - FADE EASER]
// FADE COUNTER counts from 0 to 1 (if FADE INCREASER > 0) or from 1 to 0 (FADE INCREASER < 0) linearly
// FADE VALUE is a fade value calculated from FADE COUNTER based on FADE EASER: 0.0 linear, n.0 ease start, -n.0 ease stop
// FADE STARTER is the counter value at which the fade is when changing fade,
// it should be equal to FADE VALUE and FADE COUNTER when initializing the variable,
// is used for incremental non-linear fading and shouldn't be touched if not by startfade function

local flowT = {
	overmenu = [0.0,0.0,0.0,0.0,0.0]
	history = [0.0,0.0,0.0,0.0,0.0]
	histtext = [0.0,0.0,0.0,0.0,0.0]
	data = [0.0,0.0,0.0,0.0,0.0]
	logo = [1.0,1.0,1.0,0.0,0.0]
	fg = [1.0,1.0,1.0,0.0,0.0]
	attract = [1.0,1.0,1.0,0.0,0.0]
	gametoblack = [0.0,0.0,0.0,0.0,0.0]
	blacker = [1.0,1.0,1.0,0.0,0.0]
	historydata = [0.0,0.0,0.0,0.0,0.0]
	historyscroll = [0.0,0.0,0.0,0.0,0.0]
	historyblack = [0.0,0.0,0.0,0.0,0.0]
	frostfade = [1.0,1.0,1.0,0.0,0.0,0.0]
}

local noshader = fe.add_shader( Shader.Empty )

// Search parameters
local search_base_rule = "Title"
local backs = {
	index = -1
	corrector = -1
}

local tags = {
	menu = false
	decor = false
	decortr = false
}

local column ={
	stop = 0
	start = 0
	offset = 0
}

local squarizer = true

local favcheck = {
	oldsize = 0
	newsize = 0
	changed = false
	listchange = 0
}

// Apply color theme
local themeT = {
	themeoverlaycolor = 255 //basic color of overlay
	themeoverlayalpha = 80	// overlay alpha
	themetextcolor = 255	// color of main text
	themelettercolor = 255	// color of popup letter
	themehistorytextcolor = 90 // color of history text
	themeshadow = 50 // shadow color
	menushadow = 50 // menu shadow color
	listboxbg = 200 // listbox overlay color
	listboxalpha = 15 //listbox overlay alpha
	listboxselbg = 250 // listbox selection background
	listboxseltext = 250 // listbox text of selected item
	optionspanelrgb = 128 // Grey level of options panel
	optionspanelalpha = 80 // Alpha of options panel
}

local satin = {
	rate = 0.9
	vid = 50
}

if (prf.COLORTHEME == "basic"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 80
	themeT.themetextcolor = 255
	themeT.themelettercolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50
	themeT.menushadow = 50
	themeT.listboxbg = 200
	themeT.listboxalpha = 15
	themeT.listboxselbg = 250
	themeT.listboxseltext = 50
	themeT.optionspanelrgb = 100
	themeT.optionspanelalpha = 80
}
if (prf.COLORTHEME == "dark"){
	themeT.themeoverlaycolor = 0
	themeT.themeoverlayalpha = 110*0 + 140
	themeT.themetextcolor = 230
	themeT.themelettercolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 80
	themeT.menushadow = 80
	themeT.listboxbg = 200
	themeT.listboxalpha = 15
	themeT.listboxselbg = 225
	themeT.listboxseltext = 50
	themeT.optionspanelrgb = 0
	themeT.optionspanelalpha = 70
}
if (prf.COLORTHEME == "light"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 190
	themeT.themetextcolor = 90
	themeT.themelettercolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 50 
	themeT.menushadow = 25
	themeT.listboxbg = 255
	themeT.listboxalpha = 100 
	themeT.listboxselbg = 95 
	themeT.listboxseltext = 200
	themeT.optionspanelrgb = 128
	themeT.optionspanelalpha = 50
}
if (prf.COLORTHEME == "pop"){
	themeT.themeoverlaycolor = 255
	themeT.themeoverlayalpha = 0
	themeT.themetextcolor = 255
	themeT.themelettercolor = 255
	themeT.themehistorytextcolor = 90
	themeT.themeshadow = 70
	themeT.menushadow = 70
	themeT.listboxbg = 200
	themeT.listboxalpha = 15
	themeT.listboxselbg = 250
	themeT.listboxseltext = 50
	themeT.optionspanelrgb = 50
	themeT.optionspanelalpha = 50
}

// Math functions

function round(x, y) {
	return (x.tofloat()/y+(x>0?0.5:-0.5)).tointeger()*y
}

function max(x,y){
	return (x > y ? x : y)
}

function min(x,y){
	return (x < y ? x : y)
}

function absf (n) {
	return (n > 0 ? n : -n)
}

function hsl2rgb (H,S,L){
	local C = (1.0 - absf(2.0 * L - 1.0)) * S
	local X = C * (1.0 - absf( ((H*1.0/60.0) % 2 ) - 1.0 ))
	local m = L - C/2.0
	local R1 = null
	local G1 = null
	local B1 = null

	if			((H >= 0)	&& (H < 60))	{R1 = C ; G1 = X ; B1 = 0}
	else if	((H >= 60)	&& (H < 120))	{R1 = X ; G1 = C ; B1 = 0}
	else if	((H >= 120) && (H < 180))	{R1 = 0 ; G1 = C ; B1 = X}
	else if	((H >= 180) && (H < 240))	{R1 = 0 ; G1 = X ; B1 = C}
	else if	((H >= 240) && (H < 300))	{R1 = X ; G1 = 0 ; B1 = C}
	else if	((H >= 300) && (H < 360))	{R1 = C ; G1 = 0 ; B1 = X}
	
	local OUT ={
		R = (R1 + m)
		G = (G1 + m)
		B = (B1 + m)
	}
	return (OUT)
}

// UI sounds
local snd = {
	ticksound = fe.add_sound("mouse3.mp3")
	wooshsound = fe.add_sound("woosh4.mp3")
	attracttune = fe.add_sound(prf.AMTUNE)
	bgtune = fe.add_sound(prf.BACKGROUNDTUNE)
}

snd.attracttune.loop = true
snd.bgtune.loop = true


// parameters for slowing down key repeat on left-right scrolling
local count = {
	right = 0
	left = 0
	up = 0
	down = 0
	next_game = 0
	prev_game = 0
	next_letter = 0
	prev_letter = 0
	next_page = 0
	prev_page = 0

	movestart = 20
	movestep = 0
	movestepslow = 5
	movestepfast = 3
	movestepdelay = 10

	countstep = 0
	forceleft = false
	forceright = false
}
count.movestep = count.movestepslow

local globalposnew = 0
local	surfacePos = 0

// GAME BOY green tints in HSL format (H = 0 360, SL = 0 1)

local gbrgb = {
	"LCDGBC" : {
		a = hsl2rgb(150,0.5,0.2)
		b = hsl2rgb(70,0.50,0.6)
	}
	"LCDGBP" : {
		a = hsl2rgb(90,0.05,0.10)
		b = hsl2rgb(66,0.26,0.7)
	}
	"LCDGBL" : {
		a = hsl2rgb(160,0.9,0.15)
		b = hsl2rgb(160,0.7,0.5)
	}
	"NONE" : {
		a = hsl2rgb(150,0.5,0.2)
		b = hsl2rgb(70,0.50,0.6)
	}
}



//if (prf.GBGREENCOLOR == "none") prf.GBGREENON = false

// Horizontal rows definition
if (prf.DISPLAYMENUON) {
	if (prf.DMHORIZONTALROWS == -1){
		prf.DMHORIZONTALROWS = 1
		prf.SLIMLINE = true
	}
	else {
		prf.DMHORIZONTALROWS = prf.DMHORIZONTALROWS.tointeger()
		prf.SLIMLINE = false
	}
}
else {
	if (prf.HORIZONTALROWS == -1){
		prf.HORIZONTALROWS = 1
		prf.SLIMLINE = true
	}
	else {
		prf.HORIZONTALROWS = prf.HORIZONTALROWS.tointeger()
		prf.SLIMLINE = false
	}
}

// layout preferences
local rows = (prf.DISPLAYMENUON ? prf.DMHORIZONTALROWS : prf.HORIZONTALROWS)

local vertical = false

// font definition
local uifonts = {
	gui = "Roboto-Allcaps-EXT3X.ttf" 
	general = "Roboto-Bold.ttf"
	condensed = "Roboto-Condensed-Bold.ttf"
	lite = "Roboto-Regular.ttf"
	arcade = "CPMono_Black.otf"
	arcadeborder = "CPMono_BlackBorder2.otf"
	glyphs = "glyphs.ttf"
	pixel = 0.711
}


//screen layout definition
local scr = {
	w = ScreenWidth
	h = ScreenHeight
}

if (prf.CUSTOMSIZE != ""){
	try {
		scr.w = split(prf.CUSTOMSIZE,"xX")[0]
		scr.h = split(prf.CUSTOMSIZE,"xX")[1]
		scr.w = scr.w.tointeger()
		scr.h = scr.h.tointeger()
	}
	catch ( err ) { fe.overlay.splash_message("Wrong syntax in screen resolution");prf.CUSTOMSIZE = "";scr.w = ScreenWidth; scr.h = ScreenHeight }
}

local fl = {
	w = scr.w
	h = scr.h
}

local rotation = {
	real = null
	r90 = null
}

rotation.real = ( fe.layout.base_rotation + fe.layout.toggle_rotation ) % 4
rotation.r90 = ((rotation.real % 2) != 0)

if (rotation.r90){
	fl.w = scr.h
	fl.h = scr.w
}

if (fl.h>fl.w) vertical = true
if (vertical) prf.SLIMLINE = false
if (vertical) rows = (prf.DISPLAYMENUON ? prf.DMVERTICALROWS : prf.VERTICALROWS)

rows = (prf.LOWRES ? 1 : rows)

fe.layout.width = fl.w
fe.layout.height = fl.h
fe.layout.preserve_aspect_ratio = true
fe.layout.page_size = rows
fe.layout.font = uifonts.general

local scalerate = (vertical ? fl.w : fl.h)/1200.0

local header = {
	h = (prf.LOWRES ? 260*scalerate : 200*scalerate ) // content
	h2 = (prf.LOWRES ? 330*scalerate : (((rows == 1) && (!prf.SLIMLINE))? 250*scalerate : 200*scalerate))
}
local footer = {
	h = (prf.LOWRES ? 150*scalerate : 100*scalerate ) // content
	h2 = (prf.LOWRES ? 150*scalerate : (((rows == 1) && (!prf.SLIMLINE)) ? 150*scalerate : 100*scalerate)) //spacer
}

// multiplier of padding space (normally 1/6 of thumb area)
local padding_scaler = 1.0/6.0

local height = (fl.h - header.h2 - footer.h2)/(rows + rows*padding_scaler + padding_scaler)
if ((prf.SLIMLINE) ){
	height = (fl.h - header.h2 - footer.h2)/(2.0 + 2.0*padding_scaler + padding_scaler)
	footer.h = 1.5*footer.h
}
local width = height

local padding = height * padding_scaler
local widthpadded = width + 2 * padding
local heightpadded = height + 2 * padding

local verticalshift = height*16.0/480.0

//calculate number of columns
local cols = (1 + 2*(floor (( fl.w/2 + width/2 - padding) / (height + padding))))
// add safeguard tiles
cols += 2

// carrier sizing in general layout
local carrierT = {
	x = -(cols*(height + padding) + padding - fl.w) * 0.5,
	y = header.h2 + (((prf.SLIMLINE) ) ? height*0.5 : 0 ),
	w = cols*(height + padding) + padding,
	h = rows*height + rows*padding + padding
}

// selector and zooming data
local selectorscale = (rows == 1 ? (vertical ? 1.15 : 1.45) : ((prf.SCROLLERTYPE == "labellist") ? 1.4 : 1.5) )

local whitemargin = 0.15

local selectorwidth = selectorscale * widthpadded

// correction data for non-centered first tiles
local deltacol = (cols - 3)/2


local centercorr = {
	zero = null
	val = null
	shift = null
}
centercorr.zero = - deltacol*(width + padding) -(fl.w - (carrierT.w - 2*(width + padding))) / 2 - padding*(1 + selectorscale*0.5) - width/2 + selectorwidth/2
centercorr.val = 0
centercorr.shift = centercorr.zero



// transitions speeds
local spdT = {
	scrollspeed = 0.92
	zoomspeed = 0.87
	bgfadespeed = 0.88
	letterspeed = 0.85
	dataspeedin = 0.92
	dataspeedout = 0.88
	displayspeed = 0.9
	displayzoomspeed = 0.92
}

// Video delay parameters to skip fade-in
local vidstarter = 10000
local delayvid = vidstarter - 60*prf.THUMBVIDELAY
local fadevid = delayvid - 20

// Fading letter and scroller sizes
local lettersize = {
	name = 250 * scalerate
	display = 200 *scalerate / uifonts.pixel
}

local footermargin = 250 * scalerate
local scrollersize = 2 * floor (20 * scalerate * 0.5) + 1

// Blurred backdrop definition
local bgT = {
	x = 0
	y = (fl.h - fl.w) / 2.0
	w = fl.w
}

// Picture background definition
local bgpicT = {
	x = 0,
	y = 0,
	w = fl.w,
	h = fl.h,
	ar = 1
}

if (vertical){
	bgT.x = (fl.w - fl.h) / 2
	bgT.y = 0
	bgT.w = fl.h
}

// parameters for changing scroll jump spacing
local scrolljump = false
local scrollstep = rows
local sortjump = false

// keys definition for on screen keyboard
local key_names = { "a": "a", "b": "b", "c": "c", "d": "d", "e": "e", "f": "f", "g": "g", "h": "h", "i": "i", "j": "j", "k": "k", "l": "l", "m": "m", "n": "n", "o": "o", "p": "p", "q": "q", "r": "r", "s": "s", "t": "t", "u": "u", "v": "v", "w": "w", "x": "x", "y": "y", "z": "z", "1": "Num1", "2": "Num2", "3": "Num3", "4": "Num4", "5": "Num5", "6": "Num6", "7": "Num7", "8": "Num8", "9": "Num9", "0": "Num0", "<": "Backspace", " ": "Space", "-": "Clear", "~": "Done","_":"Nope" }
local key_rows = ["abcdefghi123", "jklmnopqr456", "stuvwxyz_789", "< -0","~"]
if (vertical) key_rows = ["1234567890","abcdefghij","klmnopqrst","uvwxyz_< -","~"]
local key_selected = [0,0]
local s_text = ""

// Frosted glass variables
local frg = {
	grabdither = 0
	grabticker = 0
	oldgrabnum = 0
	grabpath = ""
	firstpath = ""
	grabsignal = ""
	immediatesignal = false
	numgrabs = 0
	createdgrabs = []
}

/// Sort List Backend Functions ///

function modwrap (i,l){
	return (i>=0 ? i%l : (i%l == 0 ? 0 : l + (i%l) ))
}

function z_listprint(array){
	print("\n")
	for (local i = 0 ; i < array.len();i++){
		print(array[i].z_felistindex + " ||| " + array[i].z_title+" ||| " + array[i].z_manufacturer+" ||| " + array[i].z_year+" ||| " + array[i].z_category+"\n")
	}
	print("\n")
}

function z_stopprint(array){
	print("i L 0 1 < >\n")
	for (local i=0;i<array.len();i++){
		print(i+" "+array[i].key + " " + array[i].start + " " + array[i].stop + " " + array[i].prev+" " + array[i].next+"\n")
	}
}

// Define the new list data
local z_list = {
	index = 0
	newindex = 0
	gametable = []
	jumptable = []
	size = 0
	orderby = Info.Title
	reverse = false
	layoutstart = false
}

function z_list_startorder(){
	if (!prf.DISPLAYMENUON){
		 z_list.orderby = Info.Title
		 z_list.reverse = false

		if (prf.SORTSAVE){
			try {
				z_list.orderby = SORTTABLE[aggregatedisplayfilter()][0]
				z_list.reverse = SORTTABLE[aggregatedisplayfilter()][1]
			}
			catch (err){}
		}
	}
}

// Create the new list from current fe.list
function z_listcreate(){
	debugpr("LIST: Create\n")
	z_list.gametable.clear()
	z_list.jumptable.clear()
	z_list.index = z_list.newindex = fe.list.index

	z_list_startorder()

	z_list.size = fe.list.size

	for (local i = 0 ; i < fe.list.size; i++){
		z_list.jumptable.push (
			{
				index = i
				start = 0
				next = 0
				prev = 0
				stop = 0
				key = ""
			}
		)
	
		z_list.gametable.push(
			{
				z_felistindex = i

				z_name = fe.game_info(Info.Name,i-fe.list.index)
				z_title = fe.game_info(Info.Title,i-fe.list.index)
				//z_emulator = fe.game_info(Info.Emulator,i-fe.list.index)
				//z_cloneof = fe.game_info(Info.CloneOf,i-fe.list.index)
				z_year = fe.game_info(Info.Year,i-fe.list.index)
				z_manufacturer = fe.game_info(Info.Manufacturer,i-fe.list.index)
				z_category = fe.game_info(Info.Category,i-fe.list.index)
				z_players = fe.game_info(Info.Players,i-fe.list.index)
				z_rotation = fe.game_info(Info.Rotation,i-fe.list.index)
				//z_control = fe.game_info(Info.Control,i-fe.list.index)
				//z_status = fe.game_info(Info.Status,i-fe.list.index)
				//z_displaycount = fe.game_info(Info.DisplayCount,i-fe.list.index)
				//z_displaytype = fe.game_info(Info.DisplayType,i-fe.list.index)
				//z_altromname = fe.game_info(Info.AltRomname,i-fe.list.index)
				//z_alttitle = fe.game_info(Info.AltTitle,i-fe.list.index)
				//z_extra = fe.game_info(Info.Extra,i-fe.list.index)
				z_favourite = fe.game_info(Info.Favourite,i-fe.list.index)
				z_tags = fe.game_info(Info.Tags,i-fe.list.index)
				z_playedcount = fe.game_info(Info.PlayedCount,i-fe.list.index)
				//z_playedtime = fe.game_info(Info.PlayedTime,i-fe.list.index)
				//z_fileisavailable = fe.game_info(Info.FileIsAvailable,i-fe.list.index)
				z_system = fe.game_info(Info.System,i-fe.list.index)
				//z_overview = fe.game_info(Info.Overview,i-fe.list.index)
				//z_ispaused = fe.game_info(Info.IsPaused,i-fe.list.index)
			
			}
		)
	}
}

// scrap articles from names
function nameclean (s){	
	if (prf.STRIPARTICLE){
		if (s.find("The ") == 0) s = s.slice(4,s.len())
		else if (s.find("Vs. The ") == 0) s = s.slice(8,s.len())
		else if (s.find("Vs. ") == 0) s = s.slice(4,s.len())
		else if (s.find("Vs ") == 0) s = s.slice(3,s.len())
	}	
	return s
}

function sortclean (s){
	if ((s == "") || (s[0].tochar() == "<")) return "!"
	else if (s.tolower() == "bootleg") return "☠"
	else return s
}

function aggregatedisplayfilter(){
return ( fe.displays[fe.list.display_index].name + "_" + ( (fe.filters.len() != 0) ? fe.filters[fe.list.filter_index].name : "" ) )
}

// Function to sort the list
function z_listsort(orderby,reverse){
	debugpr ("LIST: Sort\n")
	z_list.orderby = orderby
	z_list.reverse = reverse

	if (!reverse){
		if (orderby == Info.Title) z_list.gametable.sort(@(a,b) nameclean(a.z_title).tolower()+a.z_system.tolower() <=> nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Year) z_list.gametable.sort(@(a,b) sortclean(a.z_year).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(b.z_year).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Manufacturer ) z_list.gametable.sort(@(a,b) sortclean(a.z_manufacturer).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(b.z_manufacturer).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.PlayedCount ) z_list.gametable.sort(@(a,b) a.z_playedcount.tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> b.z_playedcount.tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Category ) z_list.gametable.sort(@(a,b) sortclean(a.z_category).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(b.z_category).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Players ) z_list.gametable.sort(@(a,b) a.z_players.tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> b.z_players.tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.System) z_list.gametable.sort(@(a,b) a.z_system.tolower()+nameclean(a.z_title).tolower() <=> b.z_system.tolower()+nameclean(b.z_title).tolower())
	}
	else 
	{
		if (orderby == Info.Title) z_list.gametable.sort(@(a,b) nameclean(b.z_title).tolower()+a.z_system.tolower() <=> nameclean(a.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Year) z_list.gametable.sort(@(a,b) sortclean(b.z_year).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(a.z_year).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Manufacturer ) z_list.gametable.sort(@(a,b) sortclean(b.z_manufacturer).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(a.z_manufacturer).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.PlayedCount ) z_list.gametable.sort(@(a,b) b.z_playedcount.tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> a.z_playedcount.tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Category ) z_list.gametable.sort(@(a,b) sortclean(b.z_category).tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> sortclean(a.z_category).tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.Players ) z_list.gametable.sort(@(a,b) b.z_players.tolower()+nameclean(a.z_title).tolower()+a.z_system.tolower() <=> a.z_players.tolower()+nameclean(b.z_title).tolower()+b.z_system.tolower())
		else if (orderby == Info.System) z_list.gametable.sort(@(a,b) b.z_system.tolower()+nameclean(a.z_title).tolower() <=> a.z_system.tolower()+nameclean(b.z_title).tolower())
	} 
	//if (reverse) z_list.gametable.reverse()

	if ((prf.SORTSAVE) && (!prf.DISPLAYMENUON)){ 
		SORTTABLE [aggregatedisplayfilter()] <- [orderby,reverse]
		//try {fe.nv["AF_Sort_Order"] <- SORTTABLE} catch (err) {}
		savetabletofile(SORTTABLE,"pref_sortorder.txt")
	}
}

// Creates an array for prev-next jump
function z_liststops(){
	local temp = []

	for (local i = 0 ; i < z_list.size ; i++){
		/*
		if ((z_list.orderby == Info.NoSort)){
			local s = z_list.gametable[i].z_title
			if (detectstriparticle()) s = nameclean (s)
			s = s[0].tochar().tolower()
			if ("'1234567890".find (s) != null) s = "#"
			temp.push (s )
		}*/
		if ((z_list.orderby == Info.Title)) {
			local s = z_list.gametable[i].z_title
			if (prf.STRIPARTICLE) s = nameclean (s)
			s = s[0].tochar().tolower()
			if ("'1234567890".find (s) != null) s = "#"
			temp.push (s )
		}

		else if (z_list.orderby == Info.Year) {
			local s = z_list.gametable[i].z_year.tolower()
			if(s != "") s = s.slice (0,3)+"x"
			else (s = "?")
			temp.push( s)
		}
		
		else if (z_list.orderby == Info.Manufacturer ) {
			local s = z_list.gametable[i].z_manufacturer
			if (s == "") s = "?"
			else if (s.tolower() == "bootleg") s = "☠"
			else (s = s[0].tochar().tolower())
			if (s=="<") s = "?"
			if ("'1234567890".find (s) != null) s = "#"
			temp.push(s)
		}


		else if (z_list.orderby == Info.PlayedCount ) temp.push( z_list.gametable[i].z_playedcount.tolower())

		else if (z_list.orderby == Info.System ) temp.push( z_list.gametable[i].z_system.tolower())
		
		else if (z_list.orderby == Info.Category ) {
			local sout = ""
			local s0 = z_list.gametable[i].z_category.tolower()
			if (s0 == "") temp.push("?")
			else {
				local s = split( s0, "/" )
				if ( s.len() > 1 ) {
					sout = strip(s[0]).tolower()
				}
				else sout = strip(s0).tolower()

				temp.push(sout)
			}
		}
		else if (z_list.orderby == Info.Players ) temp.push( z_list.gametable[i].z_players.tolower())
	}

	for (local i = 0 ; i < z_list.size ; i++){
		z_list.jumptable[i].key = temp[i]
		if (i == 0) {
			z_list.jumptable[i].start = 0
			z_list.jumptable[z_list.size-1-i].stop = z_list.size -1
		}
		else {
			if (temp[i] == temp[i-1]) z_list.jumptable[i].start = z_list.jumptable[i-1].start
			else {
				z_list.jumptable[i].start = i
			}
			if (temp[z_list.size-1-i] == temp[z_list.size-i]) z_list.jumptable[z_list.size-1-i].stop = z_list.jumptable[z_list.size-i].stop
			else{
				z_list.jumptable[z_list.size-1-i].stop = z_list.size-1-i
			}
		}
	}

	for (local i=0;i<z_list.size;i++){
		z_list.jumptable[i].next = (z_list.jumptable[i].stop + 1 )%z_list.size
		
		if (z_list.jumptable[i].start == 0) {
			z_list.jumptable[i].prev = (z_list.jumptable[z_list.jumptable[z_list.size - 1].start ].start )
		}
		else {
			z_list.jumptable[i].prev = z_list.jumptable[i].start -1 -( z_list.jumptable[z_list.jumptable[i].start -1].stop - z_list.jumptable[z_list.jumptable[i].start -1].start)
		}
		//z_list.jumptable[i].prev = modwrap (z_list.jumptable[i].stop - 1 , z_list.size)
	}
}

// Function to re-sync the index when a list has been ordered
function z_liststupdateindex(){
	for (local i = 0 ; i < z_list.size ; i++){
		if (z_list.gametable[i].z_felistindex == fe.list.index) {
			z_list.index = i
			break
		}
	}
}

// Function to apply a change to the z_list
function z_list_indexchange(newindex){
	z_var = newindex - z_list.index
	z_list.newindex = newindex
	if (z_list.size != 0) fe.list.index = z_list.gametable[modwrap ( (newindex) , z_list.size)].z_felistindex
}


local regsys = {
	LCD = regexp(@"([Pp][Cc]\s*[Ee]ngine\s*[Gg][Tt])|([Vv]ita)|([Dd][Ss])|(3[Dd][Ss])|(PSP\s*Go)|([Gg]ame\s*[Bb]oy)|([Gg]ame\s*[Gg]ear)|([Ll]ynx)|([Tt]urbo\s*[Ee]xpress)|([Gg]amate)|([Ss]upervision)|([Nn]omad)|([Nn]eo\s*[Gg]eo\s*[Pp]ocket)|([Ww]onder\s*[Ss]wan)|([Pp]lay\s*[Ss]tation\s*[Pp]ortable)")
	MONO = regexp(@"([Gg]ame\s*[Bb]oy$)|([Gg]ame\s*[Bb]oy\s*[Pp]ocket$)")
}

function screentype (offset,var){
	local name = null
	local output = null
	if ( (fe.list.size > 0)){
		name = split(( z_list.gametable[ modwrap (z_list.index + offset + var, z_list.size) ].z_system ),";")
		if (name == "") return "CRT"
		try { output = system_data[name[0].tolower()].screen}
		catch (err) {return "CRT"}
		return output
	}
	return "CRT"
}

function screenrecolor (offset,var){
	return ((screentype (offset,var) == "LCDGBC") || (screentype (offset,var) == "LCDGBP") || (screentype(offset,var) == "LCDGBL"))
}

function islcd (offset,var,regexpress){
	local name = null
	local output = null
	if ( (fe.list.size > 0)){
		name = split(( z_list.gametable[ modwrap (z_list.index + offset + var, z_list.size) ].z_system ),";")
		if (name == "") return false
		try { output = (regexpress.search(name[0]) != null)}
		catch (err) {return false}
		return output
	}
	return false
}

/// Misc functions ///


// Detect if strip article is needed
/*
function detectstriparticle(){
	if ((fe.filters.len() == 0) || (fe.filters[fe.list.filter_index].sort_by == Info.NoSort)){
		for (local i = 0 ; i < fe.list.size; i++){
			if (fe.game_info( Info.Title, i ).find("The") == 0) {
				local s = fe.game_info( Info.Title, i-1 )
				return ( !(s[0].tochar() == "T") )
				break
			}
		}
	}
}
*/

// wrap around value witin range 0 - N
function wrap( i, N ) {
	while ( i < 0 ) { i += N }
	while ( i >= N ) { i -= N }
	return i
}

// scale a picture with origin at the center
function picscale (obj,scale){
	obj.width = obj.width * scale
	obj.height = obj.height * scale
	obj.origin_x = obj.width * 0.5
	obj.origin_y = obj.height * 0.5
}

// resize a picture with origin at the center
function picsize (obj,sizex,sizey,offx,offy){
	obj.origin_x = obj.width * 0.5 + offx * obj.width
	obj.origin_y = obj.height * 0.5 + offy * obj.height
	obj.width = sizex
	obj.height = sizey
	obj.origin_x = obj.width * 0.5 + offx * obj.width
	obj.origin_y = obj.height * 0.5 + offy * obj.height
}

function recalculate( str ) {
	if ( str.len() == 0 ) return ""
	str = str.tolower()
	local words = split( str, " " )
	local temp=""
	foreach ( idx, w in words ) {
		//print("searching: " + w )
		//if ( idx > 0 ) temp += " "
		//foreach( c in w )
		// if ( c != " " ) temp += ( "1234567890".find(c.tochar()) != null ) ? c.tochar() : "[" + c.tochar().toupper() + c.tochar().tolower() + "]"
		if ( temp.len() > 0 )
		temp += " "
		local f = w.slice( 0, 1 )
		temp += ( "1234567890".find(f) != null ) ? "[" + f + "]" + w.slice(1) : "[" + f.toupper() + f.tolower() + "]" + w.slice(1)
	}
	return temp
}

function zlistentry(offset){
	return z_list.newindex + 1
}

// gets the first letter of the game name, # if it's a number
function gameletter( offset ) {
	local letterout = ""
	try {
		letterout = z_list.jumptable[z_list.index].key
		letterout = systemfont (letterout,false)
	}
	catch ( err ) {}
	return (letterout)
}

function gamelistorder (offset){
	return ( "◊" + orderdatalabel [z_list.orderby] + (z_list.reverse ? " ▼":" ▲"))
}

//MAGIC TOKEN
function gameyearstring (offset){
	local s0 = fe.game_info( Info.Year, offset )
	if (s0 != ""){
		return ("© " + s0 + "  ")
	}
	else return ("")

}

// MAGIC TOKEN gets the first part of the game name
function gamename1 ( offset ) {
	local s = split( fe.game_info( Info.Title, offset ), "(" )
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

//MAGIC TOKEN
function gamename2( offset ) {
	local s0 = split(fe.game_info( Info.Title, offset ),"(")
	if (s0.len() > 0) {
		s0 = strip(s0[0])
		local s1 = split( s0, "/" )
		if ( s1.len() > 1 ) {
			return strip(s1[0])+"\n"+strip(s1[1])
		}
		else {
			return s0
		}
	}
	else
		return ""
}

function wrapme(testo , lim_col, lim_row){

	// INITIALIZE OUTPUT VARIABLE
	local out = {
		text = ""
		rows = 0
		cols = 0
	}
	
	if (testo == "") return (out)

	local col0 = lim_col
	testo = testo.toupper()
	local segmentfind = testo.find (" - ")

	if (segmentfind) testo = testo.slice(0,segmentfind)

	testo = split(testo,"(,")

	if (testo.len() > 0) {
		testo = strip(testo[0])
		testo = split( testo, "/" )
		testo = strip(testo[0])
	}
	else
		testo = ""



	// WORD SPLITTING AND LENGTH
	local textarray = split(testo," ")
	local lenarray = textarray.map(function(value){
		return value.len()
	})

	// CALCULATION OF MAX WORD LENGTH
	local maxword = 0
	for (local i = 0 ; i < textarray.len();i++){
		if (textarray[i].len() > maxword) maxword = textarray[i].len()
	}

	// SIMPLE ROWS CASE
	out.rows = textarray.len() // = 3 (tre righe)
	out.cols = maxword // = 6 (lunghezza di GUNNER)

	for (local i = 0 ; i < lim_row ; i++){
		if (textarray.len() == i+1) {
			out.text = textarray[0]
			for (local ii = 1 ; ii <= i ; ii++){
				out.text = out.text +"\n" + textarray[ii]
			}
			return out
		}
	}

	local coltrick = ceil(testo.len()/(lim_row - 0.2))
	local colsize = (coltrick > col0 ? coltrick : col0)
	
	if (colsize < maxword) colsize = maxword
	if (colsize > testo.len() ) colsize = testo.len()

	local curline = textarray[0] // è "ZERO"
	local finline = curline // è "ZERO"
	out.text = "" // RESETTA I DATI DI OUT
	out.rows = 0
	out.cols = 0
	local starter = 1
	
	while ((curline.len() < colsize) && (textarray.len()>1)){
		curline = curline + " " + textarray[starter]
		finline = curline
		starter ++
	}
	if (curline.len() > colsize) colsize = curline.len()

	for (local i = starter ; i < textarray.len() ; i++){
		
		curline = curline + " " + textarray[i]
		
		if (curline.len() > colsize){
			out.text = out.text + finline+"\n"
			out.rows ++
			finline = curline = textarray[i]
			if (finline.len() > colsize){
				out.text = out.text + finline.slice (0,colsize)+"\n"
				out.rows ++
				curline = finline = finline.slice (colsize,finline.len())
			}
		}
		else {
			finline = curline
		}
	}

	out.cols = colsize
	out.text = out.text + curline
	out.rows ++

	return out
}

//MAGIC TOKEN
function gamemanufacturer( offset ) {
	local s0 = fe.game_info( Info.Manufacturer, offset )
	local s1 = split( s0, "/" )
	if ( s1.len() > 1 ) {
		return strip(s1[0])+"\n"+strip(s1[1])
	}
	else {
		return s0
	}
}

//MAGIC TOKEN
function gameplaycount( offset ) {
	local s = fe.game_info( Info.PlayedCount, offset )
	if ( s.len() > 0 ) {
		return s[0]
	}
	return ""
}

// MAGIC TOKEN gets the second part of the game name, after the "("
function gamesubname( offset ) {
	//TEST return (fe.game_info (Info.Category,offset))
	
	local system = split ( fe.game_info (Info.System,offset) ,";" )
	local system2 = ""
	if ( system.len() > 0 ) system2 = system[0]

	local s = split( fe.game_info( Info.Title, offset ), "(" )
	local s2 = ""
	local s3 = ""
	if (( s.len() > 1 ) && (prf.SHOWSUBNAME)){
		for (local i = 1 ; i<s.len() ; i++){
			s2 = split(s[i],")")
			s3 = s3 + " " + s2[0]
		}
		return ( ((system2 == "") || (!prf.SHOWSYSNAME)) ? strip(s3) : (prf.SHOWSYSART ?  systemfont(system2,false) : system2) + " - " + strip(s3))
	}
	return ( ((system2 == "") || (!prf.SHOWSYSNAME)) ? "" : (prf.SHOWSYSART ?  systemfont(system2,false) : system2) )
}

local categorytable = {}

//grey on grey
categorytable[""] <- ["?"," ",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["?"] <- ["?"," ",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["MULTIPLAY"] <- ["MULTI","MULTI",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["RHYTHM"] <- ["RHTM","RHYTHM",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["ELECTROMECANICAL"] <- ["ELCT","ELECTR",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["MISC."] <- ["MISC","MISC",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["MISCELLANEOUS"] <- ["MISC","MISC",[0.25,0.25,0.25],[0.5,0.5,0.5]]//
categorytable["QUIZ"] <- ["QUIZ","QUIZ",[0.25,0.25,0.25],[0.5,0.5,0.5]]//

//dark on orange
categorytable["ACTION"] <- ["ACTN","ACTION",[0.2,0.1,0.0],[0.8,0.5,0.0]]//
categorytable["PLATFORM"] <- ["PLATF","PLATFRM",[0.2,0.1,0.0],[0.8,0.5,0.0]]//

//yellow on dark blue
categorytable["BALL & PADDLE"] <- ["PADDL","PADDLE",[0.8,0.6,0.0],[0,0,0.2]]//

//orange on dark red
categorytable["BEATEMUP"] <- ["BEAT","BEAT",[0.9,0.2,0],[0.5,0,0]]//
categorytable["BEAT-'EM-UP"] <- ["BEAT","BEAT",[0.9,0.2,0],[0.5,0,0]]//
categorytable["FIGHTER"] <- ["FIGHT","FIGHT",[0.9,0.2,0],[0.5,0,0]]//

//dark red on darker red
categorytable["DRIVING"] <- ["DRIVE","DRIVE",[0.9,0,0],[0.2,0.1,0.1]]//
categorytable["MOTORCYCLE"] <- ["MCYC","MCYCLE",[0.9,0,0],[0.2,0.1,0.1]]//

categorytable["MAZE"] <- ["MAZE","MAZE",[0.8,0.7,0.0],[0.2,0.1,0.0]]//

categorytable["PUZZLE"] <- ["PUZZL","PUZZLE",[0.9,0.7,0],[0.5,0.3,0]]

//light grey on blue
categorytable["SHOOTEMUP"] <- ["SHOOT","SHOOT",[0.6,0.6,0.6],[0,0,0.3]]//
categorytable["SHOOTER"] <- ["SHOOT","SHOOT",[0.6,0.6,0.6],[0,0,0.3]]//
categorytable["SHOOT-'EM-UP"] <- ["SHOOT","SHOOT",[0.6,0.6,0.6],[0,0,0.3]]//
categorytable["FLYING"] <- ["FLY","FLYIN",[0.6,0.6,0.6],[0,0,0.3]]//

categorytable["SIMULATION"] <- ["SIM","SIMUL",[0.1,0.1,0.2],[0,0.4,0.7]]//

//grey on brown
categorytable["ADVENTURE"] <- ["ADVN","ADVNT",[0.6,0.6,0.6],[0.6,0.3,0.0]]//
categorytable["ROLE-PLAYING"] <- ["RPG","RPG",[0.8,0.7,0.5],[0.6,0.3,0.0]]//

//grey on green
categorytable["STRATEGY"] <- ["STRT","STRAT",[0.6,0.6,0.6],[0.2,0.4,0.0]]//

categorytable["BOARDGAMES"] <- ["BOARD","BOARD",[0.2,0.2,0.2],[0.7,0.7,0.7]]//
categorytable["BOARD GAMES"] <- ["BOARD","BOARD",[0.2,0.2,0.2],[0.7,0.7,0.7]]//

categorytable["SPORTS"] <- ["SPORT","SPORT",[0,0,0.4],[0.3,0.3,0.8]]

categorytable["WHAC-A-MOLE"] <- ["WHAC","WHAC-M",[0.2,0.1,0.0],[0.8,0.5,0.0]]//

categorytable["CASINO"] <- ["CASINO","CASINO",[0.2,0.2,0.2],[0.8,0.8,0.8]]//

categorytable["GUN"] <- ["GUN","GUN",[0,0.9,0],[0,0.3,0]]//

categorytable["PINBALL"] <- ["PBALL","PBALL",[0.8,0.7,0],[0.6,0.3,0]]//

function systemlabel(input){
	local sout = input.tolower()
	try {
		return (system_data[sout].label)
	}
	catch (err) {
		return (sout.toupper())
	}
}

function systemfont(input,blank){
	local sout = input.tolower()
	try {
		return ( system_data[sout].logo)
	}
	catch (err) {
		return ((blank ? " " : input))
	}
}

function categorylabel(input,index){
	local sout = input.toupper()
	try {
		return (categorytable[sout][index])
	}
	catch (err) {
		return (sout)
	}
}

//MAGIC TOKEN
function maincategory(offset) {
	local sout = ""
	local s0 = fe.game_info( Info.Category, offset )
	if (s0 == "") return ""
	local s = split( s0, "/" )
	if ( s.len() > 1 ) {
		sout = strip(s[0]).toupper()
	}
	else sout = strip(s0).toupper()

	local s2 = categorylabel(sout,1)

	return (s2)
}

function categorycolor(offset,index){
	//index = 2 or 3 : first or second color
	local sout = ""
	local s0 = fe.game_info( Info.Category, offset )
	if (s0 == "") return ([0.5,0.5,0.5])
	local s = split( s0, "/" )
	if ( s.len() > 1 ) {
		sout = strip(s[0]).toupper()
	}
	else sout = strip(s0).toupper()

	sout = sout.toupper()

	try {
		return (categorytable[sout][index])
	}
	catch (err) {
		return ([0.5,0.5,0.5])
	}
}

function updatescreen(){
	local path = FeConfigDirectory
	local dir = DirectoryListing( path )
	local picname = ""
	local fpos1 = null
	local fpos2 = null
	local picnum = 0
	local picout = 0

	foreach ( f in dir.results ){
		fpos1 = f.find(".png")
		fpos2 = f.find("screen")
		if ((fpos1 != null) && (fpos2 != null)){
			picnum = f.slice(fpos2+6,fpos1)

			if (picnum == "") picnum = "0"
			picnum = picnum.tointeger()
			if (picout < picnum ) picout = picnum
		}
	}
	picname = FeConfigDirectory + "screen" + picout +".png"
	return picout
}

function getsnap(signalin){
	frostshaders(true)

	frg.oldgrabnum = updatescreen()
	fe.signal("screenshot")
	frg.oldgrabnum ++
	frg.firstpath = FeConfigDirectory + "screen" + frg.oldgrabnum +".png"
	frg.numgrabs ++
	frg.grabpath = FeConfigDirectory + "frostgrab" + frg.numgrabs +".png"
	frg.createdgrabs.push (frg.grabpath)
	frg.grabticker = 1
	frg.grabsignal = signalin

}

/// Background image creation ///

local bglay = {
	whitepic = null
	commonground = null
	smallsize = null
	blursize = null
	xsurf1 = null
	bgpic = null
	xsurf2 = null
	bg_surface = null
	pixelgrid = null
	bgvidsize = null
}

bglay.whitepic = fe.add_image("white.png",0,0,1,1)
bglay.whitepic.visible = false

bglay.commonground = fe.add_image("grey.png",0,0,fl.w,fl.h)
bglay.commonground.zorder = -7

bglay.smallsize = 26
bglay.blursize = 1/26.0

bglay.xsurf1 = fe.add_surface(bglay.smallsize,bglay.smallsize)

bglay.bgpic = null

for (local i = 0; i < bgs.stacksize; i++){
	bgs.alphapos.push (0)
	bglay.bgpic = bglay.xsurf1.add_image("transparent.png",0,0,bglay.smallsize,bglay.smallsize)
	bglay.bgpic.alpha = 255
	bglay.bgpic.trigger = Transition.EndNavigation
	// TEST VA TOLTO DAVVERO?
	//bglay.bgpic.video_flags = Vid.ImagesOnly
	bglay.bgpic.smooth = true
	//bglay.bgpic.mipmap = 1
	bglay.bgpic.preserve_aspect_ratio = false

	local bgs_shader = fe.add_shader (Shader.Fragment, "colormapper.glsl")
	bgs_shader.set_texture_param("texture")
	bgs_shader.set_param("remap",false)
	bgs_shader.set_param("color1",0,0,0)
	bgs_shader.set_param("color2",0,0,0)
	bglay.bgpic.shader = bgs_shader

	bgs.bgpic_array.push(bglay.bgpic)
	bgs.bg_lcd.push (false)
	bgs.bg_mono.push ("CRT")
	bgs.bg_box.push ([false,[0,0,0],[0,0,0]])
}

bglay.xsurf2 = fe.add_surface(bglay.smallsize,bglay.smallsize)

bglay.bg_surface = fe.add_surface(fl.w,fl.h)
bglay.bg_surface.alpha=255

local shader_bg = {
	h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
	v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_bg.h.set_texture_param( "texture")
shader_bg.h.set_param("kernelData", 9.0, 2.2)
shader_bg.h.set_param("offsetFactor", bglay.blursize, 0.0)
bglay.xsurf1.shader = shader_bg.h

shader_bg.v.set_texture_param( "texture")
shader_bg.v.set_param("kernelData", 9.0, 2.2)
shader_bg.v.set_param("offsetFactor", 0.0, bglay.blursize)
bglay.xsurf2.shader = shader_bg.v

bglay.xsurf2.visible = false
bglay.xsurf2 = bglay.bg_surface.add_clone(bglay.xsurf2)
bglay.xsurf2.visible = true

bglay.xsurf1.visible = false
bglay.xsurf1 = bglay.xsurf2.add_clone(bglay.xsurf1)
bglay.xsurf1.visible = true

bglay.xsurf2.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

bglay.pixelgrid = null
bglay.bgvidsize = 90.0

function squarebg(){
	for (local i = 0; i < bgs.stacksize ; i++){
		if ((!prf.BOXARTMODE) || ((prf.BOXARTMODE) && (prf.LAYERSNAP))){

			local remapcolor =((bgs.bg_mono[i] == "LCDGBL") || (bgs.bg_mono[i] == "LCDGBP") || (bgs.bg_mono[i] == "LCDGBC")) 

			bgs.bgpic_array[i].shader.set_param("remap", ( remapcolor ? (prf.GBRECOLOR != "NONE") : false) )
			if (remapcolor){
				local localcolor = prf.GBRECOLOR == "AUTO" ? gbrgb[bgs.bg_mono[i]] : gbrgb[prf.GBRECOLOR]
				bgs.bgpic_array[i].shader.set_param("color1",localcolor.a.R,localcolor.a.G,localcolor.a.B)
				bgs.bgpic_array[i].shader.set_param("color2",localcolor.b.R,localcolor.b.G,localcolor.b.B)
			}

			if (!(bgs.bg_lcd[i])){
				if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
					bgs.bgpic_array[i].subimg_x = bgs.bgpic_array[i].texture_width * 1/8.0
					bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_width * 3/4.0
				}
				else {
					bgs.bgpic_array[i].subimg_y = bgs.bgpic_array[i].texture_height * 1/8.0
					bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_height * 3/4.0
				}
				if (prf.LAYERSNAP){
					if (bgs.bgvid_array[i].texture_width >= bgs.bgvid_array[i].texture_height){
						bgs.bgvid_array[i].subimg_x = bgs.bgvid_array[i].texture_width * 1/8.0
						bgs.bgvid_array[i].subimg_width = bgs.bgvid_array[i].texture_width * 3/4.0
					}
					else
					{
						bgs.bgvid_array[i].subimg_y = bgs.bgvid_array[i].texture_height * 1/8.0
						bgs.bgvid_array[i].subimg_height = bgs.bgvid_array[i].texture_height * 3/4.0
					}
				}
			}
			else {
				if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
					bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
					bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].subimg_width)
				}
				else {
					bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
					bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].subimg_height)
				}
				if (prf.LAYERSNAP){

					if (bgs.bgvid_array[i].texture_width >= bgs.bgvid_array[i].texture_height){
						bgs.bgvid_array[i].subimg_width = bgs.bgvid_array[i].texture_height
						bgs.bgvid_array[i].subimg_x = 0.5*(bgs.bgvid_array[i].texture_width - bgs.bgvid_array[i].subimg_width)
					}
					else{
						bgs.bgvid_array[i].subimg_height = bgs.bgvid_array[i].texture_width
						bgs.bgvid_array[i].subimg_y = 0.5*(bgs.bgvid_array[i].texture_height - bgs.bgvid_array[i].subimg_height)
					}
				}
			}
		}
		else {

			bgs.bgpic_array[i].shader.set_param("remap",false)

			//TEST62 AGGIORNARE QUI I DATI DELLO SHADER GREY PER LE PARTI SENZA BOX

			bgs.bgpic_array[i].shader.set_param("remap",bgs.bg_box[i][0])
			bgs.bgpic_array[i].shader.set_param("color1",bgs.bg_box[i][1][0],bgs.bg_box[i][1][1],bgs.bg_box[i][1][2])
			bgs.bgpic_array[i].shader.set_param("color2",bgs.bg_box[i][2][0],bgs.bg_box[i][2][1],bgs.bg_box[i][2][2])

			// BOXART MODE ON
			if (bgs.bgpic_array[i].texture_width > bgs.bgpic_array[i].texture_height){
				bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
				bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].texture_height)
			}
			else if (bgs.bgpic_array[i].texture_width < bgs.bgpic_array[i].texture_height)
			{
				bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
				bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].texture_width)
			}
		}
		if (prf.DISPLAYMENUON){
			if (bgs.bgpic_array[i].texture_width >= bgs.bgpic_array[i].texture_height){
				bgs.bgpic_array[i].subimg_x = 0.5*(bgs.bgpic_array[i].texture_width - bgs.bgpic_array[i].texture_height)
				bgs.bgpic_array[i].subimg_width = bgs.bgpic_array[i].texture_height
			}
			else
			{
				bgs.bgpic_array[i].subimg_y = 0.5*(bgs.bgpic_array[i].texture_height - bgs.bgpic_array[i].texture_width)
				bgs.bgpic_array[i].subimg_height = bgs.bgpic_array[i].texture_width
			}
		}
	}
}

if (prf.LAYERSNAP){
	bgvidsurf = fe.add_surface(bglay.bgvidsize,bglay.bgvidsize)

	for (local i = 0; i < bgs.stacksize; i++){
		local bgvid = null

		if (!prf.LAYERVIDEO) {
			bgvid = bgvidsurf.add_clone(bgs.bgpic_array[i])
			//bgvid.video_flags = Vid.ImagesOnly
		}
		else if (i == bgs.stacksize - 1 ){
			if (prf.LAYERVIDELAY){			
				bgvid = bgvidsurf.add_image("white",0,0,bglay.bgvidsize,bglay.bgvidsize)
				bgvid.video_flags = Vid.NoAudio
				bgvid.alpha = 0
			}
			else {
				bgvid = bgvidsurf.add_artwork("snap",0,0,bglay.bgvidsize,bglay.bgvidsize)
				bgvid.video_flags = Vid.NoAudio
			}
		}
		else{
			bgvid = bgvidsurf.add_clone(bgs.bgpic_array[i])
			// bgvid.video_flags = Vid.NoAudio // TEST 
			// bgvid.video_flags = Vid.ImagesOnly
			bgvid.visible = false
		}
		
		bgvid.set_pos(0,0,bglay.bgvidsize,bglay.bgvidsize)
		bgvid.preserve_aspect_ratio = false
		bgvid.trigger = Transition.EndNavigation
		bgvid.smooth = true
		bgs.bgvid_array.push(bgvid)
	}

	bgvidsurf.smooth = false

	bgvidsurf.alpha = satin.vid

	bgvidsurf.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

	bglay.pixelgrid = fe.add_image("grid128x.png",bgT.x,bgT.y,bgT.w,bgT.w*128.0/bglay.bgvidsize)
	bglay.pixelgrid.alpha = 50

	bgvidsurf.zorder = bglay.pixelgrid.zorder = -2
}

local bgpicture = null

if (prf.BGCUSTOM != ""){
	bgpicture = fe.add_image(prf.BGCUSTOM,0,0,fl.w,fl.h)
	bgpicture.visible = false
	bgpicT.ar = (bgpicture.texture_width*1.0) / bgpicture.texture_height

	if (bgpicT.ar >= fl.w/(fl.h*1.0)){
		bgpicT.h = fl.h
		bgpicT.w = bgpicT.h * bgpicT.ar
		bgpicT.y = 0
		bgpicT.x = - (bgpicT.w - fl.w)*0.5
	}
	else {
		bgpicT.w = fl.w
		bgpicT.h = bgpicT.w / bgpicT.ar*1.0
		bgpicT.y = - (bgpicT.h - fl.h)*0.5
		bgpicT.x = 0
	}
	bgpicture=fe.add_image (prf.BGCUSTOM,bgpicT.x,bgpicT.y,bgpicT.w,bgpicT.h)
	bgpicture.visible=true
}

local bgoverlay = fe.add_image("white.png",0,0,fl.w,fl.h)
bgoverlay.set_rgb(themeT.themeoverlaycolor,themeT.themeoverlaycolor,themeT.themeoverlaycolor)
bgoverlay.alpha = themeT.themeoverlayalpha

bglay.bg_surface.zorder = -6
if (prf.BGCUSTOM != "") bgpicture.zorder = -5
bgoverlay.zorder = -4

/// Carrier - variables definition ///

local tilesTable = []
local snapzTable = []
local logozTable = []
local loshzTable = []
local favezTable = []
local donezTable = []
local nw_mxTable = []
local tg_mxTable = []
local sh_hzTable = []
local sh_vzTable = []
local sh_sqTable = []
local vidszTable = []
local gradzTable = []
local vid2zTable = []
local bd_mxTable = []
local glomxTable = []
local txt1zTable = []
local txt2zTable = []
local txshzTable = []
local txboxTable = []
local lsurfTable = []

local offseTable = []

local tilesTablePos = {
	X = []
	Y = []
	Offset = 0
}
local tilesTableZoom = []
local vidszTableFade = []
local vidpos = []
local vidindex = []

local corrector = 0

local newfocusindex = 0
local oldfocusindex = 0

local	vidposbg = 0
local vidbgfade=[0.0,0.0,0.0,0.0,0.0]

local fade = {
	letter = 0
	display = 0
	displayzoom = 0
}

local	search = {
	text = ""
	string = ""
}


/// Carrier - constructor ///

local tiles = {
	count = cols*rows
	offscreen = (vertical ? 3 * rows : 4 * rows)
	total = null
}
tiles.total = tiles.count + 2*tiles.offscreen

local surfacePosOffset = (tiles.offscreen/rows) * (width+padding)


// scroller definition
local scrolline = fe.add_image ("white.png",footermargin,fl.h - footer.h*0.5 - 1, fl.w-2*footermargin, 1 )
//scrolline.alpha = 255
scrolline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scrollineglow = fe.add_image ("whitedisc2.png",footermargin, fl.h - footer.h*0.5 - 10*scalerate -1 ,fl.w-2*footermargin, 20*scalerate + 1)
scrollineglow.visible = false
scrollineglow.alpha = 200
scrollineglow.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller = fe.add_image ("whitedisc.png",footermargin - scrollersize*0.5,fl.h-footer.h*0.5-(scrollersize + 1 )*0.5,scrollersize,scrollersize)
scroller.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local scroller2 = fe.add_image ("whitedisc2.png",scroller.x - scrollersize*0.5, scroller.y-scrollersize*0.5,scrollersize*2,scrollersize*2)
scroller2.visible = false
scroller2.alpha = 200
scroller2.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

if (prf.SCROLLERTYPE == "labellist") scroller2.alpha = scrollineglow.alpha = scroller.alpha = scrolline.alpha = 0
local labelstrip = fe.add_image("wbox2.png")
labelstrip.visible = false

local labelsurf = fe.add_surface (fl.w,fl.h)


local searchdata = fe.add_text (fe.list.search_rule,0,fl.h-footer.h*0.5,fl.w,footer.h*0.5)
searchdata.align = Align.Centre
searchdata.set_rgb( 255, 255, 255)
searchdata.word_wrap = true
searchdata.char_size = 25*scalerate
searchdata.visible = true
searchdata.font = uifonts.gui
searchdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local snap_glow = []
local loshz = null
local txshz = null
local txt1z = null
local txt2z = null
local txbox = null

local logosurf1 = null
local logosurf2 = null
local shader_lg = null

local gradsurf3 = null
local gradsurf1 = null
local gradsurf2 = null
local gradz = null
local vidsz = null
local greenshader = {
	vid = null,
	grad = null
}
local shader_gr = null

/// Carrier - tile creation loop ///

local logo = {
	w = null
	h = null
	margin = null
	shw = null
	shh = null
	shscale = null
	shcharsize = null

	txtlinespacing = null
	txtcharspacing = null
	txtfont = null
	txtmargin = null
	txtalign = null
}

logo.w = 240.0
logo.h = 120.0
logo.margin = 20.0
logo.shcharsize = 35.0

logo.shw = logo.w + 2 * logo.margin
logo.shh = logo.h + 2 * logo.margin

logo.shscale = 0.35

logo.txtlinespacing = 0.6
logo.txtcharspacing = 0.7
logo.txtfont = uifonts.arcade
logo.txtmargin = 0
logo.txtalign = Align.MiddleCentre

for ( local i = 0; i < tiles.total; i++ ) {

	local gradsizer = 8
	local gradscaler = 1

	if (prf.SNAPGRADIENT){
		gradsurf1 = fe.add_surface (gradsizer, gradsizer)

		gradz = gradsurf1.add_image("transparent.png",0,0,gradsizer,gradsizer)
		gradz.preserve_aspect_ratio = false
		//gradz.video_flags = Vid.ImagesOnly

		greenshader.grad = fe.add_shader (Shader.Fragment, "colormapper.glsl")
		greenshader.grad.set_texture_param("texture")
		greenshader.grad.set_param("remap",false)

		gradz.shader = greenshader.grad

		vidsz = gradsurf1.add_image("transparent.png",0,0,gradsizer,gradsizer)
		vidsz.preserve_aspect_ratio = false
		vidsz.mipmap = 1
		
		greenshader.vid = fe.add_shader (Shader.Fragment, "colormapper.glsl")
		greenshader.vid.set_texture_param("texture")
		greenshader.vid.set_param("remap",false)

		vidsz.shader = greenshader.vid
		

		//vidsz.visible = false
		if (!prf.AUDIOVIDSNAPS) vidsz.video_flags = Vid.NoAudio

		gradsurf2 = fe.add_surface (gradsizer, gradsizer)

		gradsurf3 = fe.add_surface (gradsizer, gradsizer)

		shader_gr = {
			h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
			v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
		}
		
		shader_gr.h.set_texture_param( "texture")
		shader_gr.h.set_param("kernelData", 7.0, 2.5)
		shader_gr.h.set_param("offsetFactor", 1.0/gradsizer, 0.0)
		gradsurf1.shader = shader_gr.h

		shader_gr.v.set_texture_param( "texture")
		shader_gr.v.set_param("kernelData", 7.0, 2.5)
		shader_gr.v.set_param("offsetFactor", 0.0, 1.0/gradsizer)
		gradsurf2.shader = shader_gr.v

		gradsurf1.visible = false
		gradsurf1 = gradsurf2.add_clone (gradsurf1)
		gradsurf1.visible = true
			
		gradsurf2.visible = false
		gradsurf2 = gradsurf3.add_clone (gradsurf2)
		gradsurf2.visible = true

		gradsurf3.set_pos (gradsizer*gradscaler*i , 0,gradsizer*gradscaler,gradsizer*gradscaler)
		gradsurf3.visible = false 
	}
	else {
		gradz = fe.add_image("transparent.png",0,0,gradsizer,gradsizer)
		gradz.preserve_aspect_ratio = false
		//gradz.video_flags = Vid.ImagesOnly

		vidsz = fe.add_image("transparent.png",0,0,gradsizer,gradsizer)
		vidsz.preserve_aspect_ratio = false
		vidsz.mipmap = 1

		greenshader.vid = fe.add_shader (Shader.Fragment, "colormapper.glsl")
		greenshader.vid.set_texture_param("texture")
		greenshader.vid.set_param("remap",false)

		vidsz.shader = greenshader.vid

		if (!prf.AUDIOVIDSNAPS) vidsz.video_flags = Vid.NoAudio

	}




	if (prf.LOGOSHADOW){
		logosurf2 = fe.add_surface (logo.shw*logo.shscale,logo.shh*logo.shscale)

		loshz = logosurf2.add_image ("transparent.png",logo.margin*logo.shscale,logo.margin*logo.shscale,logo.w*logo.shscale,logo.h*logo.shscale)

		txshz = logosurf2.add_text("...",loshz.x,loshz.y,loshz.width,loshz.height)
		txshz.char_size = logo.shcharsize*logo.shscale
		txshz.word_wrap = true
		txshz.align = logo.txtalign
		txshz.font = logo.txtfont
		txshz.margin = logo.txtmargin
		txshz.line_spacing = logo.txtlinespacing
		txshz.char_spacing = logo.txtcharspacing
		txshz.set_rgb (0,0,0)
		txshz.alpha = 150
		
		logosurf1 = fe.add_surface (logo.shw*logo.shscale,logo.shh*logo.shscale)

		shader_lg = {
			v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
			h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
		}
	
		shader_lg.v.set_texture_param( "texture")
		shader_lg.v.set_param("kernelData", 5.0 , 1.75)
		shader_lg.v.set_param("offsetFactor", 0.0000, 1.0/(logo.shh*logo.shscale))
		logosurf2.shader = shader_lg.v

		shader_lg.h.set_texture_param( "texture")
		shader_lg.h.set_param("kernelData", 5.0 , 1.75)
		shader_lg.h.set_param("offsetFactor", 1.0/(logo.shw*logo.shscale), 0.0)
		logosurf1.shader = shader_lg.h


		logosurf2.visible = false
		logosurf2 = logosurf1.add_clone (logosurf2)
		logosurf2.visible = true

		logosurf1.visible = false
	}
	// main tile object
	local obj = fe.add_surface(widthpadded*selectorscale,heightpadded*selectorscale)
	obj.origin_x = obj.width * 0.5
	obj.origin_y = obj.height * 0.5

	obj.zorder = -2
	
	local sh_hz = obj.add_image ("sh_h_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
	local sh_vz = obj.add_image ("sh_v_7.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
	local sh_sq = obj.add_image ("sh_sq_7b.png",0,0,widthpadded*selectorscale,heightpadded*selectorscale)
	sh_hz.alpha = sh_vz.alpha = sh_sq.alpha = 230
	
	//TEST62
	/*
	if (prf.CROPSNAPS) {
		sh_hz.visible = sh_vz.visible = false
	}
	else{
		sh_sq.visible = false
	}
	*/
	
	local glomx = obj.add_image ("glowx5d.png",0,-selectorscale*verticalshift,widthpadded*selectorscale,selectorscale*heightpadded)
	glomx.alpha = 0

	local bd_mx = obj.add_image ("white.png",selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3/4.0)+padding*2.0*whitemargin))
	bd_mx.set_rgb(255,255,255)
	bd_mx.alpha = 0
	
		local snapz = obj.add_clone(gradz)

	if(!prf.SNAPGRADIENT) gradz.visible = false

	snapz.preserve_aspect_ratio = false
	// snapz.video_flags = Vid.ImagesOnly
	snapz.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
	
	local snap_avg = null

	if (prf.SNAPGRADIENT){
		snap_avg = fe.add_shader( Shader.Fragment, "gradcomposer.glsl" )
		snap_avg.set_texture_param( "texture",snapz)
		snap_avg.set_texture_param( "texture2",gradsurf3)
		snap_avg.set_param ("remap",false)

	}
	else {
		snap_avg = fe.add_shader (Shader.Fragment, "colormapper.glsl")
		snap_avg.set_texture_param("texture")
		snap_avg.set_param("remap",false)

	}

	if (prf.SNAPGRADIENT) {
		snap_avg.set_param ("limits",0.20,0.75)
	}

	if (prf.SNAPGRADIENT) snap_avg.set_param ("enabled",true)

	snapz.shader = snap_avg
	
	txbox = obj.add_text("XXXXXXXXXXXXXXXXXXXXXXXX",selectorscale*padding*10.0/8.0,selectorscale*(padding*0.3 + padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
	txbox.char_size = txbox.height/4.0
	txbox.word_wrap = true
	txbox.align = Align.TopCentre
	txbox.font = logo.txtfont
	txbox.margin = 0
	txbox.line_spacing = logo.txtlinespacing
	txbox.char_spacing = logo.txtcharspacing
	txbox.set_rgb (255,255,255)
	//txbox.set_bg_rgb(255,0,0) 
	//txbox.bg_alpha = 128
	
	snap_glow.push (null)

	if (prf.SNAPGLOW){
		snap_glow[i] = fe.add_shader( Shader.Fragment, "powerglow61.glsl" )
		snap_glow[i].set_texture_param( "texture", (prf.SNAPGRADIENT ? gradsurf3 : bglay.whitepic) )
		snap_glow[i].set_texture_param( "textureglow",glomx)
		snap_glow[i].set_param ("orient",0.0)
		snap_glow[i].set_param ("enabled",true)
		
		glomx.shader = noshader
	}
	else{
		glomx.visible = false
	}

	local vid2z = obj.add_clone(vidsz)
	vid2z.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
	vid2z.preserve_aspect_ratio = false 
	//vidsz.visible = false
	if (!prf.SNAPGRADIENT) vidsz.visible = false
	// if (!prf.AUDIOVIDSNAPS) vid2z.video_flags = Vid.NoAudio

	local nw_mx = obj.add_image ("nw_1.png",selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0),width*selectorscale/8.0,height*selectorscale/8.0)
	nw_mx.visible = false
	nw_mx.alpha = ((prf.NEWGAME == true)? 220 : 0)

	local tg_mx = obj.add_image ("tagww.png",0,0,width*selectorscale/6.0,height*selectorscale/6.0)
	tg_mx.visible = false
	tg_mx.mipmap = true
	tg_mx.alpha = ((prf.TAGSHOW == true)? 255 : 0)

	local donez = obj.add_image("completed.png",selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*height)
	donez.visible = false
	donez.preserve_aspect_ratio = false
	donez.mipmap = true

	local favez = obj.add_image("starred.png",selectorscale*(padding+width/2),selectorscale*(padding+height/2-verticalshift),selectorscale*width/2,selectorscale*height/2)
	favez.visible = false
	favez.preserve_aspect_ratio = false

	if (prf.LOGOSHADOW){
		logosurf1 = obj.add_clone (logosurf1)
		logosurf1.preserve_aspect_ratio = true
		logosurf1.visible = true

		if (!prf.CROPSNAPS)
			logosurf1.set_pos (selectorscale*padding*0.5,selectorscale*(padding*0.4*0.5-verticalshift),selectorscale*(width+padding),selectorscale*(height*0.5+padding))
		else
			logosurf1.set_pos (selectorscale*padding,selectorscale*(padding-verticalshift),selectorscale*width,selectorscale*width*logo.shh/logo.shw)
	}

	if(!prf.LOGOSHADOW) {
		loshz = obj.add_image ("transparent.png",logo.margin*logo.shscale,logo.margin*logo.shscale,logo.w*logo.shscale,logo.h*logo.shscale)

	}

	local logoz = obj.add_clone (loshz)

	logoz.preserve_aspect_ratio = true

	if (!prf.CROPSNAPS)
		logoz.set_pos (selectorscale*padding,selectorscale*(padding*0.6-verticalshift),selectorscale*width,selectorscale*height*0.5)
	else
		logoz.set_pos (selectorscale*(padding+width*logo.margin/logo.shw),selectorscale*(padding-verticalshift+width*(15/20.0)*logo.margin/logo.shw),selectorscale*width*logo.w/logo.shw,selectorscale*height*logo.h/logo.shw)
	
	if (!prf.LOGOSHADOW){
		loshz.set_pos(logoz.x - scalerate*12,logoz.y,logoz.width+24*scalerate,logoz.height+20*scalerate)
		
		txshz = obj.add_text("...",loshz.x,loshz.y,loshz.width,loshz.height)
		txshz.char_size = logo.shcharsize*(88.0/40.0)*scalerate
		txshz.word_wrap = true
		txshz.align = logo.txtalign
		txshz.font = logo.txtfont
		txshz.margin = logo.txtmargin
		txshz.line_spacing = logo.txtlinespacing
		txshz.char_spacing = logo.txtcharspacing
		txshz.set_rgb (0,0,0)
		txshz.alpha = 150
		}

		txt2z = obj.add_text("...",logoz.x,logoz.y,logoz.width,logoz.height)
		txt2z.char_size = logo.shcharsize*(88.0/40.0)*scalerate
		txt2z.word_wrap = true
		txt2z.align = logo.txtalign
		txt2z.font = uifonts.arcadeborder
		txt2z.margin = logo.txtmargin
		txt2z.line_spacing = logo.txtlinespacing*0.6/0.6
		txt2z.char_spacing = logo.txtcharspacing
		txt2z.set_rgb (80,80,80)
		txt2z.alpha = 120
		
		txt2z.set_rgb (150,150,150)
		txt2z.alpha = 255

		txt2z.set_rgb (135,135,135)
		txt2z.alpha = 255

		//txshz = obj.add_text("[Title]",selectorscale*(padding +height*(1.0/8.0)),selectorscale*(padding+height*(1.0/8.0)),selectorscale*width*3.0/4.0,selectorscale*height*3.0/4.0)
		txt1z = obj.add_text("...",logoz.x,logoz.y,logoz.width,logoz.height)
		txt1z.char_size = logo.shcharsize*(88.0/40.0)*scalerate
		txt1z.word_wrap = true
		txt1z.align = logo.txtalign
		txt1z.font = logo.txtfont
		txt1z.margin = logo.txtmargin
		txt1z.line_spacing = logo.txtlinespacing
		txt1z.char_spacing = logo.txtcharspacing
		//txt1z.set_bg_rgb(200,0,0)
		//txt1z.bg_alpha = 50

	loshz.alpha = 150
	loshz.preserve_aspect_ratio = true
	loshz.set_rgb(0,0,0)

	tilesTablePos.X.push((width+padding) * (i/rows) + padding + obj.width*0.5)
	tilesTablePos.Y.push((width+padding) * (i%rows) + padding + carrierT.y + verticalshift + obj.height*0.5)
	tilesTableZoom.push ([0.0,0.0,0.0,0.0,0.0])
	vidszTableFade.push ([0.0,0.0,0.0,0.0,0.0])
	vidpos.push (0)
	vidindex.push (0)

	obj.preserve_aspect_ratio = false
	
	vidsz.alpha = vid2z.alpha = 0

	tilesTable.push (obj)
	snapzTable.push (snapz)
	logozTable.push (logoz)
	loshzTable.push (loshz)
	favezTable.push (favez)
	donezTable.push (donez)
	sh_hzTable.push (sh_hz)
	sh_vzTable.push (sh_vz)
	sh_sqTable.push (sh_sq)
	nw_mxTable.push (nw_mx)
	tg_mxTable.push (tg_mx)
	vidszTable.push (vidsz)
	vid2zTable.push (vid2z)
	gradzTable.push (gradz)
	bd_mxTable.push (bd_mx)
	glomxTable.push (glomx)
	txt1zTable.push (txt1z)
	txt2zTable.push (txt2z)
	txshzTable.push (txshz)
	txboxTable.push (txbox)
	lsurfTable.push (logosurf1)
	offseTable.push (0)
}

surfacePos = 0.5

/// Foreground panel surface ///
local fg_surface = fe.add_surface (fl.w,fl.h)
fg_surface.add_clone(bglay.bg_surface)
if (prf.BGCUSTOM != "") fg_surface.add_clone (bgpicture)
fg_surface.add_clone(bgoverlay)
fg_surface.zorder = 0

//fg_surface.alpha = 120
//fg_surface.set_pos(bgT.x,bgT.y,bgT.w,bgT.w)

/// Data surface construction ///

local data_surface = fe.add_surface (fl.w,fl.h)

local filterdata = data_surface.add_text ( "footer",0,fl.h-footer.h,footermargin,footer.h)
filterdata.align = Align.Centre
filterdata.set_rgb( 255, 255, 255)
filterdata.word_wrap = true
filterdata.char_size = (prf.LOWRES ? 35*scalerate/uifonts.pixel : 25*scalerate/uifonts.pixel)
filterdata.visible = true
filterdata.font = uifonts.gui
filterdata.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//filterdata.set_bg_rgb (200,10,10)

local filternumbers = data_surface.add_text ( (prf.CLEANLAYOUT ? "" :"[!zlistentry]\n[ListSize]"),fl.w-footermargin,fl.h-footer.h,footermargin,footer.h)
filternumbers.align = Align.Centre
filternumbers.set_rgb( 255, 255, 255)
filternumbers.word_wrap = true
filternumbers.char_size = (prf.LOWRES ? 35*scalerate/uifonts.pixel : 25*scalerate/uifonts.pixel)
filternumbers.visible = true
filternumbers.font = uifonts.gui
filternumbers.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

local separatorline = data_surface.add_image("white.png",fl.w-footermargin+footermargin*0.3, fl.h-footer.h + footer.h*0.5,footermargin*0.4,1)
separatorline.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
separatorline.visible = !((prf.CLEANLAYOUT))

function displaynamelogo (offset){
	if (prf.DISPLAYMENUON) return ""
	local dispname = ( fe.displays[fe.list.display_index].name)
	return systemfont (dispname,false)
}

local displayname = data_surface.add_text("[!displaynamelogo]",-fl.w*0.5, fl.h*0.5 - 400*0.5*scalerate/uifonts.pixel,fl.w*2.0,400*scalerate/uifonts.pixel)
displayname.char_size = lettersize.display
displayname.word_wrap = true
displayname.alpha = 0
displayname.font = uifonts.gui

// fading letter
local letterobj = data_surface.add_text("[!gameletter]",-fl.w*0.5,carrierT.y,fl.w*2.0,carrierT.h)
letterobj.alpha = 0
letterobj.char_size = lettersize.name
letterobj.font = uifonts.gui
letterobj.set_rgb(themeT.themelettercolor,themeT.themelettercolor,themeT.themelettercolor)
letterobj.margin = 0
letterobj.align = Align.MiddleCentre
if (prf.DISPLAYMENUON) letterobj.visible = false

local blsize = {
	mini = 45 * scalerate,
	catp = 110 * scalerate,
	subt = 35 * scalerate,
	posy = 137 * scalerate,
	manu = 145 * scalerate,
	dath = 25 * scalerate

}

if (prf.LOWRES) {
	blsize = {
		mini = 60 * scalerate,
		catp = 150 * scalerate,
		subt = 45 * scalerate,
		posy = 180 * scalerate,
		manu = 150 * scalerate,
		dath = 40 * scalerate
	}
}

// category image
local game_catpicT = {
	x = 30 * scalerate,
	y = 20 * scalerate,
	w = blsize.catp,
	h = blsize.catp
}

// players image, controller image, button image
local game_plypicT = {
	x = blsize.catp + 2.0 * game_catpicT.x,
	y = blsize.posy,
	w = blsize.mini,
	h = blsize.mini
}

local game_ctlpicT = {
	x = game_plypicT.x + (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini,
	h = blsize.mini
}

local game_butpicT = {
	x = game_plypicT.x + 2 * (blsize.mini + 10 * scalerate),
	y = game_plypicT.y,
	w = blsize.mini * 1.25,
	h = blsize.mini
}

// main game category
local game_maincatT = {
	x = 20 * scalerate,
	y = header.h - 20 * scalerate - blsize.subt,
	w = game_plypicT.x - 2 * 20 * scalerate,
	h = blsize.subt
}

// right side: manufacturer and year
local game_manufacturerpicT = {
	x = fl.w - 2 * blsize.manu - 30 * scalerate,
	y = (prf.LOWRES ? 20*scalerate : 10 * scalerate),
	w = 2 * blsize.manu,
	h = blsize.manu
}
local game_yearT = {
	x = game_manufacturerpicT.x,
	y = header.h - 20 * scalerate - blsize.dath,
	w = game_manufacturerpicT.w,
	h = blsize.dath
}

// game main name and subname
local game_mainnameT = {
	x = game_plypicT.x,
	y = game_catpicT.y,
	w = fl.w - game_plypicT.x - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = game_catpicT.h
}

local game_subnameT = {
	x = game_butpicT.x + game_butpicT.w + 15 * scalerate,
	y = game_maincatT.y,
	w = fl.w - game_butpicT.x - game_butpicT.w - 15 *scalerate - game_manufacturerpicT.w - 30*scalerate - 5 * scalerate,
	h = blsize.subt
}

local bwtoalpha = fe.add_shader( Shader.Fragment, "bwtoalpha.glsl" )
bwtoalpha.set_texture_param( "texture")

local txtoalpha = fe.add_shader( Shader.Fragment, "txtoalpha.glsl" )
txtoalpha.set_texture_param( "texture")

for (local i = 0; i < dat.stacksize; i++){

	local game_catpic = data_surface.add_image("white.png",game_catpicT.x, game_catpicT.y, game_catpicT.w, game_catpicT.h)
	if (prf.DISPLAYMENUON) game_catpic.file_name = "category_images/sprite_4.png"
	game_catpic.smooth = false
	game_catpic.preserve_aspect_ratio = true
	game_catpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_catpic.shader = bwtoalpha
	//game_catpic.fix_masked_image()

	local game_butpic = data_surface.add_image("white.png",game_butpicT.x, game_butpicT.y, game_butpicT.w, game_butpicT.h)
	game_butpic.smooth = true
	game_butpic.preserve_aspect_ratio = true
	game_butpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_butpic.shader = bwtoalpha
	// game_catpic.mipmap = 1
	
	local game_plypic = data_surface.add_image("white.png",game_plypicT.x, game_plypicT.y, game_plypicT.w, game_plypicT.h)
	game_plypic.smooth = true
	game_plypic.preserve_aspect_ratio = true
	game_plypic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_plypic.shader = bwtoalpha
	// game_plypic.mipmap = 1

	local game_ctlpic = data_surface.add_image("white.png",game_ctlpicT.x, game_ctlpicT.y, game_ctlpicT.w, game_ctlpicT.h)
	game_ctlpic.smooth = true
	game_ctlpic.preserve_aspect_ratio = true
	game_ctlpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_ctlpic.shader = bwtoalpha
	// game_ctlpic.mipmap = 1

	local game_maincat = data_surface.add_text("[!maincategory]",game_maincatT.x,game_maincatT.y,game_maincatT.w,game_maincatT.h)
	game_maincat.align = Align.MiddleCentre
	game_maincat.word_wrap = true
	game_maincat.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_maincat.char_size = (game_maincatT.h - 10*scalerate)/uifonts.pixel
	game_maincat.font = uifonts.condensed
	game_maincat.alpha = 255
	game_maincat.margin = 0
	game_maincat.line_spacing = 0.8
	//	game_maincat.set_bg_rgb (255,0,0)
	

	local game_mainname = data_surface.add_text( "[!gamename2]", game_mainnameT.x, game_mainnameT.y , game_mainnameT.w, game_mainnameT.h )
	game_mainname.align = Align.MiddleLeft
	game_mainname.word_wrap = true
	game_mainname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_mainname.char_size = (game_mainnameT.h - 10*scalerate)*0.5/uifonts.pixel
	game_mainname.line_spacing = 0.670000068
	game_mainname.margin = 0
	game_mainname.font = uifonts.gui
	game_mainname.alpha = 255
	// game_mainname.set_bg_rgb(200,0,0)
	game_mainname.visible = true

	local game_subname = data_surface.add_text( "[!gamesubname]", (prf.CLEANLAYOUT ? game_mainnameT.x : game_subnameT.x), game_subnameT.y, game_subnameT.w, game_subnameT.h )
	game_subname.align = Align.TopLeft
	game_subname.word_wrap = false
	game_subname.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	game_subname.char_size = game_subnameT.h/uifonts.pixel
	game_subname.font = uifonts.gui
	game_subname.alpha = 255
	game_subname.margin = 0
	//	game_subname.set_bg_rgb(200,100,0)


	local game_manufacturerpic = data_surface.add_text("",game_manufacturerpicT.x , game_manufacturerpicT.y , game_manufacturerpicT.w, game_manufacturerpicT.h)
	if (prf.DISPLAYMENUON) game_manufacturerpic.msg ="" 

	// game_manufacturerpic.mipmap = 1
//	game_manufacturerpic.smooth = true
//	game_manufacturerpic.preserve_aspect_ratio = false
	game_manufacturerpic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//	game_manufacturerpic.shader = bwtoalpha
	game_manufacturerpic.char_size = game_manufacturerpicT.h-5*scalerate
	game_manufacturerpic.margin = 5*scalerate
	game_manufacturerpic.align = Align.BottomCentre
	game_manufacturerpic.font = "manufacturers.ttf"
	//game_manufacturerpic.set_bg_rgb(255,0,0)


	local game_manufacturername = data_surface.add_text("[!gamemanufacturer]",game_manufacturerpicT.x , game_manufacturerpicT.y, game_manufacturerpicT.w, game_manufacturerpicT.h)
	// game_manufacturerpic.mipmap = 1
	game_manufacturername.align = Align.MiddleCentre
	game_manufacturername.set_rgb( 255, 255, 255)
	game_manufacturername.word_wrap = true
	game_manufacturername.char_size = 0.2*game_manufacturerpicT.h/uifonts.pixel
	game_manufacturername.visible = false
	game_manufacturername.font = uifonts.gui
	game_manufacturername.margin = 0
	game_manufacturername.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)


	local game_year = data_surface.add_text( "[!gameyearstring]", game_yearT.x, game_yearT.y, game_yearT.w, game_yearT.h)
	if (prf.DISPLAYMENUON) game_year.msg = "v" + AFVERSION
	game_year.align = Align.TopCentre
	game_year.set_rgb( 255, 255, 255)
	game_year.word_wrap = false
	game_year.char_size = game_yearT.h/uifonts.pixel
	game_year.visible = true
	game_year.font = uifonts.gui
	game_year.margin = 0
	game_year.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	// game_year.set_bg_rgb(200,000,100)
	
	if (prf.CLEANLAYOUT){
		game_manufacturerpic.visible = game_maincat.visible = game_year.visible = game_manufacturername.visible = game_catpic.visible = game_butpic.visible = game_ctlpic.visible = game_plypic.visible = false
	}
	
	dat.var_array.push(0)
	dat.alphapos.push (1)
	dat.cat_array.push(game_catpic)
	dat.but_array.push (game_butpic)
	dat.ply_array.push (game_plypic)
	dat.ctl_array.push (game_ctlpic)
	dat.mainctg_array.push(game_maincat)
	dat.manufacturer_array.push(game_manufacturerpic)
	dat.manufacturername_array.push(game_manufacturername)
	dat.gamename_array.push(game_mainname)
	dat.gamesubname_array.push(game_subname)
	dat.gameyear_array.push(game_year)


}

// Creation of data shadow

local sh_scale = {
	r1 = (vertical ? 400.0 / data_surface.width : 400.0 / data_surface.height)
	r2 = null
}

local shader_tx = {
	h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
	v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_tx.v.set_texture_param( "texture")
shader_tx.v.set_param("kernelData",9,3.0)
shader_tx.v.set_param("offsetFactor",0.000,1.0/(fl.h*sh_scale.r1))

shader_tx.h.set_texture_param( "texture")
shader_tx.h.set_param("kernelData",9,3.0)
shader_tx.h.set_param("offsetFactor",1.0/(fl.w*sh_scale.r1),0.000)

local data_surface_sh = fe.add_surface(data_surface.width * sh_scale.r1 , data_surface.height * sh_scale.r1)
local data_surface_sh1 = data_surface_sh.add_clone(data_surface)
data_surface_sh1.set_pos (0 , 0 , data_surface.width * sh_scale.r1 , data_surface.height * sh_scale.r1)

data_surface_sh.set_rgb(0,0,0)
data_surface_sh1.set_rgb(0,0,0)

if (prf.DATASHADOWSMOOTH){
	data_surface_sh.shader = shader_tx.v
	data_surface_sh1.shader = shader_tx.h
}

data_surface_sh.alpha = themeT.themeshadow

data_surface_sh.zorder =-1

data_surface_sh.set_pos(4*scalerate,7*scalerate,data_surface.width,data_surface.height)

/// Frosted glass surface ///

local frostpic = {
	size = 96.0 *0+64.0
	w = null
	h = null
}

if (!vertical){
	frostpic.w = frostpic.size
	frostpic.h = frostpic.size * fl.h/fl.w
}
else {
	frostpic.w = frostpic.size * fl.w/fl.h
	frostpic.h = frostpic.size
}

local AR = {
	display = ScreenWidth*1.0/ScreenHeight
	screen = scr.w*1.0/scr.h
	layout = fl.w*1.0/fl.h
}

if (rotation.r90) AR.display = 1.0/AR.display

local frost_picT = {
	x = null,
	y = null,
	w = null,
	h = null
}

if (AR.display > AR.layout){
	frost_picT.h = frostpic.h
	frost_picT.w = frostpic.h*AR.display
	frost_picT.x = (frostpic.w - frost_picT.w)*0.5
	frost_picT.y = 0
}
else{
	frost_picT.w = frostpic.w
	frost_picT.h = frostpic.w/AR.display
	frost_picT.x = 0
	frost_picT.y = (frostpic.h - frost_picT.h)*0.5
}

local frost = {
	surf1 = null
	surf2 = null
	pic = null
	surface = null
	top = null
	scaler = null
}

local flipshader = null
local shader_fr = null

if (prf.FROSTEDGLASS){
	frost.scaler = frostpic.w*1.0/fl.w
	
	frost.surface = fe.add_surface(fl.w*frost.scaler,(fl.h-header.h-footer.h)*frost.scaler)
	frost.surf1 = frost.surface.add_surface(frostpic.w,frostpic.h)
	frost.pic = frost.surf1.add_image("transparent.png",frost_picT.x,frost_picT.y,frost_picT.w,frost_picT.h)

	flipshader = fe.add_shader( Shader.Vertex, "flipper_v.glsl" )
	// flipshader.set_texture_param( "texture")
	flipshader.set_param("rotation",rotation.real)

	shader_fr = {
		v = fe.add_shader( Shader.VertexAndFragment, "flipper_v.glsl","gauss_kernsigma_o.glsl" )
		h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
	}
	
	shader_fr.v.set_texture_param( "texture")
	shader_fr.v.set_param("kernelData", 13.0, 2.5)
	shader_fr.v.set_param("rotation",rotation.real)
	shader_fr.v.set_param("offsetFactor", rotation.r90 ? 1.0/frost_picT.h : 0.0, rotation.r90 ? 0.0 : 1.0/frost_picT.h)

	shader_fr.h.set_texture_param( "texture")
	shader_fr.h.set_param("kernelData", 13.0, 2.5)
	shader_fr.h.set_param("offsetFactor", 1.0/frostpic.w, 0.000)

	frost.surf1.set_pos(0,-header.h*frost.scaler,fl.w*frost.scaler,fl.h*frost.scaler)

	frost.surface.set_pos(0,header.h,fl.w,fl.h-header.h-footer.h)

	frost.surface.alpha = 0
}

function frostshaders (turnon){
	if (turnon){
		frost.top.shader = flipshader
		frost.top.visible = true
		frost.surf1.shader = shader_fr.h
		frost.pic.shader = shader_fr.v
	}
	else{
		frost.top.shader = noshader
		frost.top.visible = false
		frost.surf1.shader = noshader
		frost.pic.shader = noshader
	}
}



/// Controls Overlays (Listbox) ///


local overlay = {
	charsize = null
	rowsize = null
	labelsize = null
	labelcharsize = null
	rows = null
	fullwidth = null
	fullheight = null
	glypharray = null
	glyphs = []
	glyphsize = null
	labelmsg = ""
}

overlay.charsize = (prf.LOWRES ? floor( 65*scalerate ) : floor( 50*scalerate ))
overlay.rowsize = (prf.LOWRES ? (overlay.charsize*2.5) : (overlay.charsize*3))
overlay.labelsize = (overlay.rowsize * 1)
overlay.labelcharsize = overlay.charsize * 1
overlay.fullwidth = (fl.w-2*padding)
overlay.fullheight = fl.h-header.h-footer.h-overlay.labelsize
overlay.rows = floor(overlay.fullheight/overlay.rowsize)

if (floor(overlay.rows / 2.0)*2.0 == overlay.rows ) overlay.rows ++

overlay.glyphsize = overlay.fullheight / overlay.rows


// Overlay area background
local overlay_background = fe.add_text ("", 0 , header.h, fl.w, fl.h-header.h-footer.h)
overlay_background.set_bg_rgb(themeT.listboxbg,themeT.listboxbg,themeT.listboxbg)
overlay_background.bg_alpha = themeT.listboxalpha

local overlay_listbox = fe.add_listbox( padding, header.h+overlay.labelsize, overlay.fullwidth, overlay.fullheight )
overlay_listbox.rows = overlay.rows
overlay_listbox.char_size = overlay.charsize
overlay_listbox.bg_alpha = 0
overlay_listbox.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_listbox.set_bg_rgb( 0, 0, 0 )
overlay_listbox.set_sel_rgb( themeT.listboxseltext, themeT.listboxseltext, themeT.listboxseltext )
overlay_listbox.set_selbg_rgb( themeT.listboxselbg,themeT.listboxselbg,themeT.listboxselbg )
overlay_listbox.selbg_alpha = 255
overlay_listbox.font = uifonts.gui
overlay_listbox.align = Align.MiddleCentre
overlay_listbox.sel_alpha = 255

local overlay_label = fe.add_text( "dummy", 0, header.h, fl.w, overlay.labelsize )
overlay_label.char_size = overlay.labelcharsize
overlay_label.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_label.align = Align.MiddleCentre
overlay_label.font = uifonts.gui
overlay_label.set_bg_rgb(0,200,0)
overlay_label.bg_alpha = 0

local overlay_glyph = fe.add_text( "", padding, header.h, overlay.labelsize*0.98, overlay.labelsize*0.98 )
overlay_glyph.font = uifonts.glyphs
overlay_glyph.margin = 0
overlay_glyph.char_size = overlay.charsize*1.25
overlay_glyph.align = Align.MiddleCentre
overlay_glyph.set_bg_rgb (100,0,0)
overlay_glyph.bg_alpha = 0
overlay_glyph.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
overlay_glyph.word_wrap = true

/// Glyph Boxes ///
// Create glyph boxes


for (local i = 0 ; i < overlay.rows ; i++){
	local box = fe.add_text("X",overlay_listbox.x,overlay_listbox.y+i*overlay.glyphsize,overlay.glyphsize,overlay.glyphsize)
	box.char_size = overlay.charsize*1.25
	box.bg_alpha = 0
	box.set_rgb(themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
	box.set_bg_rgb(0, 0, 0 )
	box.font = uifonts.glyphs
	box.align = Align.MiddleCentre
	overlay.glyphs.push (box)
}


function refreshglyphs(var0){
	for (local i = 0 ; i < overlay.rows; i++){
		try{overlay.glyphs[i].msg = overlay.glypharray[i-0.5*(overlay.rows-1)+var0]} catch (err) {overlay.glyphs[i].msg=""}
		if (i == 0.5*(overlay.rows-1)) overlay.glyphs[i].set_rgb( themeT.listboxseltext, themeT.listboxseltext, themeT.listboxseltext )
		else overlay.glyphs[i].set_rgb (themeT.themetextcolor-5,themeT.themetextcolor-5,themeT.themetextcolor-5)
	} 
}

function glyphshide(){
	for (local i = 0 ; i < overlay.rows; i++){
		overlay.glyphs[i].msg = ""
		overlay.glyphs[i].visible = false
		overlay.glypharray = null
	}
}

function glyphsshow(){
	for (local i = 0 ; i < overlay.rows; i++){
		overlay.glyphs[i].visible = true
	}
}

refreshglyphs(0)

/*
function zmenu_dialog(textarray, glypharray, title,presel){
	drawzmenu(textarray,glypharray,presel,false)
	return (fe.overlay.list_dialog(textarray,title,presel))
}
*/

function glyph_list_dialog(textarray, glypharray, title, titleglyph, presel){
   if (prf.ENHANCEDMENU ) {
		drawzmenu(textarray,glypharray,title,titleglyph,presel,false)
		return (fe.overlay.list_dialog(textarray,title,presel))
	}
	//if (prf.ENHANCEDMENU )	return (zmenu_dialog(textarray, glypharray, title, presel))
	overlay.labelmsg = title

	overlay_glyph.msg = gly(titleglyph)

	if (glypharray != null) {
		local maxwidth = 20
		for (local i = 0 ; i < overlay.rows; i++){
			//try{overlay.glyphs[i].msg = glypharray[i-2]} catch (err) {overlay.glyphs[i].msg=""}
			try{overlay.glyphs[i].msg = gly(glypharray[i+presel-0.5*(overlay.rows-1)])} catch (err) {overlay.glyphs[i].msg=""}
		}

		for (local i = 0 ; i < glypharray.len() ; i++){
			if (textarray[i].len() > maxwidth) maxwidth = textarray[i].len()
		}

		for (local i = 0 ; i < overlay.rows; i++){
			overlay.glyphs[i].x = max( ( 0.5*overlay.glyphs[i].width + overlay_listbox.x + overlay_listbox.width*0.5 - 0.5*(overlay.charsize*(maxwidth))) , overlay_listbox.x+padding)
		}

		overlay.glypharray = glypharray
		for (local i = 0 ; i < glypharray.len() ; i++){
			overlay.glypharray[i] = gly(glypharray[i])
		}
	}
   return (fe.overlay.list_dialog(textarray,title,presel))
}

local shader1 = fe.add_image ("wgradient.png",0,fl.h-footer.h,fl.w,50*scalerate)

local shader2 = fe.add_image ("white.png",padding,header.h+overlay.labelsize-2,fl.w-2*padding,2)

local shader3 = fe.add_image ("wgradient2.png",0,header.h-50*scalerate,fl.w,50*scalerate)

shader1.alpha = 50
shader2.alpha = 255
shader3.alpha = 50
shader1.set_rgb(0,0,0)
shader3.set_rgb(0,0,0)
shader2.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)

overlay_background.visible = overlay_listbox.visible = overlay_label.visible = overlay_glyph.visible = shader1.visible = shader2.visible = shader3.visible = false

fe.overlay.set_custom_controls( overlay_label, overlay_listbox )

function overlay_visible() {
	return overlay_listbox.visible
}

function overlay_show(var0){
	if (overmenu_visible()) overmenu_hide(true) //TEST70

	if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

	//if (var0 == Overlay.Displays) overlay_label.msg = "⊡ " + ltxt("DISPLAYS",TLNG) + "\t"
	//else if (var0 == Overlay.Filters) overlay_label.msg ="🍸 " + ltxt("FILTERS",TLNG) + "\t"
	//else if (var0 == Overlay.Tags) overlay_label.msg ="🏷 " + ltxt("TAGS",TLNG) + "\t"
	//else if (var0 == Overlay.Favourite) overlay_label.msg ="★ "+ltxt("FAVOURITES",TLNG) + "\t"
	//else if (var0 == Overlay.Exit) overlay_label.msg =ltxt("EXIT ARCADEFLOW?",TLNG)
	
	if (prf.FROSTEDGLASS) {
		frost.surface.alpha = 255
		frostshaders(true)
	}
	else {
		flowT.fg = [1.0,1.0,1.0,0.0,0.0]
		fg_surface.alpha = 255*satin.rate
	}
	if (!prf.ZMENUON) glyphsshow()
	overlay_listbox.visible = !prf.ZMENUON
	overlay_background.visible = overlay_label.visible = overlay_glyph.visible = shader1.visible = shader2.visible = shader3.visible = true
}

function overlay_hide(){
	if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.Default

	showdisp(false)

	if (prf.FROSTEDGLASS) {
		frost.surface.alpha = 0
		frostshaders(false)
	}
	else {
		fg_surface.alpha = 0
	}

	if (prf.FROSTEDGLASS) frg.grabdither = 2
	glyphshide()
	overlay_background.visible = overlay_listbox.visible = overlay_label.visible = overlay_glyph.visible = shader1.visible = shader2.visible = shader3.visible = false
}




/// Preferences overlay ///

function getsubmenu(index){
   local out = []
   for (local i = 0 ; i < prefs.l1[index].len() ; i++ ) {
      out.push (prefs.l1[index][i].title)
   }
   return out
}

function getsubmenuglyphs(index){
   local out = []
   for (local i = 0 ; i < prefs.l1[index].len() ; i++ ) {
      out.push (prefs.l1[index][i].glyph)
   }
   return out
}

local prfmenu = {
	res0 = 0
	res1 = 0
	res2 = 0
	outres0 = 0
	outres1 = 0
	outres2 = 0
	level = 0
	bg = fe.add_text("",0,0,0,0)
	description = fe.add_text("",0,0,100,100)
	helppic = fe.add_image("transparent.png",0,fl.h*0.5,fl.h*0.5,fl.h*0.5)
	showing = false
	browsershowing = false
	browserfile = ""
	browserdir = []
	//	picratew = overlay.fullwidth * 0.3
	picrateh = overlay.fullheight * 0.4
	//	picratew = 1.25 * overlay.fullheight * 0.4
	picratew = overlay.fullwidth * 0.3

}

prfmenu.picratew = prfmenu.picrateh = (overlay.fullheight * 1.0 / overlay.rows) * 2.0 - padding * 0.5

//prfmenu.description.set_bg_rgb(100,0,0)
prfmenu.description.char_size = 46*scalerate
prfmenu.description.word_wrap = true
prfmenu.description.margin = 0
prfmenu.description.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
//overlay_listbox.set_bg_rgb(80,0,0)
//overlay_listbox.bg_alpha = 128

prfmenu.helppic.preserve_aspect_ratio = true

prfmenu.bg.set_bg_rgb (themeT.optionspanelrgb,themeT.optionspanelrgb,themeT.optionspanelrgb)
prfmenu.bg.bg_alpha = themeT.optionspanelalpha

prfmenu.bg.set_pos(padding,overlay_listbox.y + overlay.fullheight - prfmenu.picrateh - padding * 0.5 , overlay.fullwidth , prfmenu.picrateh)
prfmenu.helppic.set_pos (prfmenu.bg.x, prfmenu.bg.y, prfmenu.picratew , prfmenu.picrateh)
prfmenu.description.set_pos (prfmenu.bg.x + padding + prfmenu.picratew , prfmenu.bg.y , overlay.fullwidth - prfmenu.picratew - 2*padding , prfmenu.picrateh)

/*
if (!vertical) {
	prfmenu.bg.set_pos(padding,overlay_listbox.y + overlay.fullheight - prfmenu.picrateh - padding*0.5 , overlay.fullwidth , prfmenu.picrateh)
	prfmenu.helppic.set_pos (prfmenu.bg.x, prfmenu.bg.y, prfmenu.picratew , prfmenu.picrateh)
	prfmenu.description.set_pos (prfmenu.bg.x + padding + prfmenu.picratew , prfmenu.bg.y , overlay.fullwidth - prfmenu.picratew - 2*padding , prfmenu.picrateh)
}
else {
	prfmenu.bg.set_pos(padding,overlay_listbox.y + overlay.fullheight - prfmenu.picrateh - padding*0.5 , overlay.fullwidth , prfmenu.picrateh)
	prfmenu.helppic.set_pos (prfmenu.bg.x, prfmenu.bg.y, prfmenu.picratew , prfmenu.picrateh)
	prfmenu.description.set_pos (prfmenu.bg.x + padding + prfmenu.picratew , prfmenu.bg.y , overlay.fullwidth - prfmenu.picratew - 2*padding , prfmenu.picrateh)

}
*/
prfmenu.description.visible = prfmenu.helppic.visible = prfmenu.bg.visible = false

function buildselectarray(options,selection){
	local out = []
	for (local i = 0 ; i < options.len(); i++) {
		out.push (0)
	} 
	out[selection] = 0xea10
	return (out)
}

function updatemenu(level,var){
	if (level == 1){
		prfmenu.helppic.file_name =prefs.affolder + prefs.path + "gear2.png"
		prfmenu.helppic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	}

	else if (level == 2) {
		prfmenu.helppic.set_rgb(255,255,255)
		try {prfmenu.helppic.file_name = prefs.affolder + prefs.path + prefs.l1[prfmenu.outres0][var].pic}
		catch (err) { 
			prfmenu.helppic.file_name = prefs.affolder + prefs.path + "gear2.png"
			prfmenu.helppic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
		}
	}

	else if (level == 3) {
		prfmenu.helppic.set_rgb(255,255,255)
		try {prfmenu.helppic.file_name = prefs.affolder + prefs.path + prefs.l1[prfmenu.outres0][prfmenu.outres1].picsel[var]}
		catch (err) { 
			try {prfmenu.helppic.file_name = prefs.affolder + prefs.path + prefs.l1[prfmenu.outres0][prfmenu.outres1].pic}
			catch (err) { 
				prfmenu.helppic.file_name = prefs.affolder + prefs.path + "gear2.png"
				prfmenu.helppic.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
			}
		}
	}
}



function optionsmenu(){


	prfmenu.res0 = prfmenu.res1 = prfmenu.res2 = prfmenu.outres0 = prfmenu.outres1 = prfmenu.outres2 = prfmenu.level = 0
	prfmenu.showing = true
	
	prfmenu.bg.visible = prfmenu.description.visible = prfmenu.helppic.visible = true
	overlay_listbox.height = prfmenu.bg.y - overlay_listbox.y

	for (local i = 0 ; i < overlay.rows ; i++){
		overlay.glyphs[i].set_pos(overlay_listbox.x,overlay_listbox.y+i*overlay_listbox.height/overlay.rows,overlay.glyphsize,overlay_listbox.height/overlay.rows)
	}


	local selection_pre = generateselectiontable()

	while (prfmenu.res0 != -1){
		prfmenu.description.msg = prefs.l0[prfmenu.outres0].description
		prfmenu.level = 1
		
		updatemenu(prfmenu.level,prfmenu.outres0)

		// First level menu
		prfmenu.res0 = glyph_list_dialog(prefs.a0, prefs.gl0, ltxt("Layout options",TLNG), 0xe991, prfmenu.outres0)
		if (prfmenu.res0 != -1) prfmenu.outres0 = prfmenu.res0 else prfmenu.outres0 = 0
		prfmenu.description.msg = prefs.l1[prfmenu.outres0][prfmenu.outres1].help
		
		// Second menu level (submenu)
		while ((prfmenu.res1 != -1) && (prfmenu.res0 != -1)){
			prfmenu.level = 2
			
			updatemenu(prfmenu.level,prfmenu.outres1)

			prfmenu.res1 = glyph_list_dialog(getsubmenu(prfmenu.outres0),getsubmenuglyphs(prfmenu.outres0),prefs.l0[prfmenu.outres0].label,prefs.l0[prfmenu.outres0].glyph,prfmenu.outres1)
			prfmenu.description.msg = prefs.l1[prfmenu.outres0][prfmenu.outres1].help
			if (prfmenu.res1 != -1) prfmenu.outres1 = prfmenu.res1 else prfmenu.outres1 = 0
			
			// Third menu level (option choice)
			while ( (prfmenu.res2!= -1) && (prfmenu.res1 != -1) && (prfmenu.res0 != -1)) {
				prfmenu.description.msg = prefs.l1[prfmenu.outres0][prfmenu.outres1].help
				prfmenu.level = 3
				
				updatemenu(prfmenu.level,prefs.l1[prfmenu.outres0][prfmenu.outres1].selection)

				if (prefs.l1[prfmenu.outres0][prfmenu.outres1].selection >= 0 ){
					// MULTIPLE CHOICE OPTION
					prfmenu.res2 = glyph_list_dialog(prefs.l1[prfmenu.outres0][prfmenu.outres1].options, buildselectarray(prefs.l1[prfmenu.outres0][prfmenu.outres1].options,prefs.l1[prfmenu.outres0][prfmenu.outres1].selection),prefs.l1[prfmenu.outres0][prfmenu.outres1].title ,0xe991,prefs.l1[prfmenu.outres0][prfmenu.outres1].selection)
					if (prfmenu.res2 != -1) {
						if(prf.THEMEAUDIO) snd.ticksound.playing = true
						prefs.l1[prfmenu.outres0][prfmenu.outres1].selection = prfmenu.res2
						prfmenu.outres2 = prfmenu.res2
					}
				} 
				else if (prefs.l1[prfmenu.outres0][prfmenu.outres1].selection == -1){
					// TEXT INPUT OPTION (selection = -1)
					prefs.l1[prfmenu.outres0][prfmenu.outres1].values = fe.overlay.edit_dialog( prefs.l1[prfmenu.outres0][prfmenu.outres1].title, prefs.l1[prfmenu.outres0][prfmenu.outres1].values )
					prfmenu.res2 = -1
				}
				else if (prefs.l1[prfmenu.outres0][prfmenu.outres1].selection == -2){
					// EXECUTE FUNCTION OPTION (selection = -1)
					prefs.l1[prfmenu.outres0][prfmenu.outres1].values()
					prfmenu.res2 = -1
				}
				else if (prefs.l1[prfmenu.outres0][prfmenu.outres1].selection == -3){
					// FILE REQUESTER OPTION (selection = -3)
					prefs.l1[prfmenu.outres0][prfmenu.outres1].values = filebrowser(prefs.l1[prfmenu.outres0][prfmenu.outres1].values)
					prfmenu.res2 = -1
				}
				frg.grabdither = 2 //updates the frosted glass effect when exiting text input
				if (prefs.getout) break
			}
			prfmenu.res2 = 0
			if (prefs.getout) break
		}
		prfmenu.res1 = 0
		if (prefs.getout) break
	}
	// Reset preference menu status
	prfmenu.showing = false
	
	prfmenu.description.visible = prfmenu.helppic.visible = prfmenu.bg.visible = false
	
	// Save prefs data and reload the layout
	local selection_post = generateselectiontable()
	
	local updated = false

	foreach (label, val in selection_post){
		if (selection_pre[label] != val) updated = true
	}
	
	if (updated){
		saveprefdata(selection_post)
		prf = generateprefstable()
		
		TLNG = prf.LAYOUTLANGUAGE
		savelanguage(TLNG)
		
		//savelayout(prf.LAYOUTFILE)
		
		DEBUG = prf.DEBUGMODE
		savedebug(DEBUG ? "true" : "false")
		
		fe.signal("reload")
	}
	for (local i = 0 ; i < overlay.rows ; i++){
				overlay.glyphs[i].set_pos(overlay_listbox.x,overlay_listbox.y+i*overlay.fullheight/overlay.rows,overlay.glyphsize,overlay.fullheight/overlay.rows)
			}
}

/// File Browser ///

function filebrowser(file0){
	local file00 = file0
	prfmenu.browsershowing = true
	//overlay_listbox.height = overlay.fullheight
	//prfmenu.bg.visible = prfmenu.description.visible = prfmenu.helppic.visible = false

	local extensions = {
		".png"	: 0xe90d
		".jpg"	: 0xe90d
		".jpeg"	: 0xe90d
		".psd"	: 0xe90d
		".gif"	: 0xe90d
		
		".txt"	: 0xe926
		".nut"	: 0xe926
		
		".mp3"	: 0xe911
		".wav"	: 0xe911
		
		".zip"	: 0xe92b
		".rar"	: 0xe92b
		
		".mp4"	: 0xe913
		".mkv"	: 0xe913	
		".avi"	: 0xe913

		".doc"	: 0xeae1
		".docx"	: 0xeae1	

		".xls"	: 0xeae2
		".xlsx"	: 0xeae2

		".pdf"	: 0xeadf

		".ttf"	: 0xea5c
		".otf"	: 0xea5c
	}
	
	local startdir = prefs.affolder
	
	if (file00 != "") {
		local startdir0 = split(file00,"\\/")
		startdir = file00.slice (0,-1 -1 * startdir0[startdir0.len()-1].len()) 
	}

	local dir = DirectoryListing( startdir, true )
	
	local sortdir = []

	for (local i = 0 ; i < dir.results.len() ; i++){
		if (fe.path_test(dir.results[i],PathTest.IsDirectory)) sortdir.push("0_"+dir.results[i])
		else sortdir.push("1_"+dir.results[i])
	}
	sortdir.sort(@(a,b) a.tolower() <=> b.tolower())
	for (local i = 0 ; i < sortdir.len() ; i++){
		sortdir[i] = sortdir[i].slice(2,sortdir[i].len())
	}

	local select0 = sortdir.find(file00)
	if (select0 == null) select0 = 0

	prfmenu.browserdir = sortdir
	prfmenu.browserfile = sortdir[select0]
	// ADD IMAGE UPDATE HERE???
	prfmenu.helppic.file_name = sortdir[select0]

	local out = 0
	local dirtype = []
	local prevdirarray = split(startdir,"\\/")

	local prevdir = startdir
	prevdir = prevdir.slice (0,-1 -1 * prevdirarray[prevdirarray.len()-1].len()) 
	sortdir.insert (0,prevdir)
	sortdir.insert (0,prefs.affolder)
	sortdir.insert (0,FeConfigDirectory)
	sortdir.insert (0,"")

	local lastname = null
	local folderappend = null

	local root = false

	while (out != -1){

		lastname = []
		folderappend = []

		lastname.push( ltxt ("DEFAULT", TLNG) )
		lastname.push( ltxt ("Attract Folder", TLNG) )
		lastname.push( ltxt ("Arcadeflow Folder", TLNG) )
		lastname.push("..")
		
		folderappend.push(0)
		folderappend.push(0)
		folderappend.push(0)
		folderappend.push(0)

		for (local i = 4 ; i < sortdir.len() ; i++){
			local isfile = !fe.path_test(sortdir[i],PathTest.IsDirectory)
			local lastnametemp = split(sortdir[i],"\\/")
			lastnametemp = (lastnametemp[lastnametemp.len()-1])
			lastname.push (lastnametemp)
			local extemp = ""
			if (isfile) {
				extemp = lastnametemp.slice(lastnametemp.len()-4,lastnametemp.len())
				try {extemp = extensions[extemp.tolower()]} catch (err) { extemp = ""}
			}
			folderappend.push (isfile ? extemp : 0xe92f)
		}
		
		out = glyph_list_dialog(lastname,folderappend,startdir,0xe930,4+select0)
		file00 = startdir

		if (out == -1) {
			prfmenu.browsershowing = false
			return (file0)
		}
		if (out == 0) {
			prfmenu.browsershowing = false
			return ("")
		}
		
		if ((out == 3) && root ){
				sortdir = letterdrives()
				startdir = "Volumes"
		}
		else {
			root = false

			// Updates startdir value with the selected file and update the browserfile
			startdir = sortdir[out]
			prfmenu.browserfile = startdir

			// if startdir is not a directory, then startdir is the selection
			if (!fe.path_test(startdir,PathTest.IsDirectory)) {
				prfmenu.browsershowing = false
				return (startdir)
			}

			dir = DirectoryListing( startdir, true )

			sortdir = []
			for (local i = 0 ; i < dir.results.len() ; i++){
				if (fe.path_test(dir.results[i],PathTest.IsDirectory)) sortdir.push("0_"+dir.results[i])
				else sortdir.push("1_"+dir.results[i])
			}
			sortdir.sort(@(a,b) a.tolower() <=> b.tolower())
			for (local i = 0 ; i < sortdir.len() ; i++){
				sortdir[i] = sortdir[i].slice(2,sortdir[i].len())
			}
		}

		select0 = sortdir.find( ((file00[file00.len()-1].tochar() == "/") ? file00.slice(0,file00.len()-1) : file00) )
		if (select0 == null) select0 = -1 //If there's no item found default to the ".." folder

		prfmenu.browserdir = sortdir
		try {prfmenu.browserfile = sortdir[select0]} catch (err) {prfmenu.browserfile = ""}
		try {prfmenu.helppic.file_name = sortdir[select0]} catch (err) {prfmenu.helppic.file_name = "transparent.png"}

		//decompound directory path
		prevdirarray = split(startdir,"\\/")

		// By default make previous directory equal to actual
		prevdir = startdir

		if (prefs.driveletters.len() > 0) { // Prev directory and root management for Windows
			if (prevdirarray.len() > 1) {
				prevdir = prevdir.slice (0,-1 -1 * prevdirarray[prevdirarray.len()-1].len()) //NEW MAC
				if (prevdir.len() == 2) prevdir = prevdir +"\\"
				sortdir.insert (0,prevdir)
				root = false
			}
			else if ( (prevdirarray.len() == 1)  ) {		
				sortdir.insert (0,prevdir)
				root = true
			}
			else  {
				prevdir = "C:\\"
				startdir = "Drives"
				sortdir = letterdrives()
				prfmenu.browserdir = sortdir
				sortdir.insert(0,"C:\\")
			}
		}
		if ((prefs.driveletters.len() == 0)) { // Prev directory and root management for MacOS, Linux etc
			if (prevdir[prevdir.len()-1].tochar() != "/") {
				prevdir = prevdir + "/"
			}
			if ( prevdirarray.len() > 0 ) prevdir = prevdir.slice (0, -1 -1 * prevdirarray[prevdirarray.len()-1].len()) 
			if (prevdir != "") 
				sortdir.insert (0,prevdir) 
			else 
				sortdir.insert (0,startdir)				
		}
		
		sortdir.insert (0,prefs.affolder)
		sortdir.insert (0,FeConfigDirectory)
		sortdir.insert (0,"")

	}

	//prfmenu.bg.visible = prfmenu.description.visible = prfmenu.helppic.visible = true
	//overlay_listbox.height = prfmenu.bg.y - overlay_listbox.y
	prfmenu.browsershowing = false
	return (file0)
}

/// Context Menu ///

//local overmenuwidth = (vertical ? fl.w * 0.7 : fl.h * 0.7)
local overmenuwidth = selectorwidth * 0.9
local overmenu = fe.add_image("overmenu3.png",fl.w*0.5-overmenuwidth*0.5,fl.h*0.5-overmenuwidth*0.5,overmenuwidth,overmenuwidth)
overmenu.visible = false
overmenu.alpha = 0

function overmenu_visible(){
	return ((overmenu.visible) && (flowT.overmenu[3] >= 0))
}

function overmenu_show(){
	overmenu.y = fl.h*0.5*0 + header.h2 + heightpadded*0.5 -overmenuwidth*0.5 - corrector * (heightpadded - padding)
	if (rows == 1 ) overmenu.y = fl.h*0.5*0 + header.h2 + heightpadded*0.5 - overmenuwidth*0.5
	if (prf.SLIMLINE == true) overmenu.y = header.h + (fl.h-header.h-footer.h)*0.5 - overmenuwidth*0.5
	overmenu.x = fl.w*0.5 - overmenuwidth*0.5 + centercorr.val
	if(prf.THEMEAUDIO) snd.wooshsound.playing = true

	overmenu.visible = true
	flowT.overmenu = startfade (flowT.overmenu , 0.095,0.0)
}

function overmenu_hide(strict){
	//test70 if(prf.THEMEAUDIO) {snd.wooshsound.playing = true
	//test70			testpr("snd05")}

	if(strict) overmenu.visible = false
	flowT.overmenu = startfade (flowT.overmenu , -0.095,-3.0)
}

/// Frosted Image Overlay ///

if (prf.FROSTEDGLASS){

	if (AR.display > AR.layout){
		frost.top = fe.add_image("transparent.png",(fl.h/frostpic.h)*frost_picT.x,0,fl.w*1.0*AR.display/AR.layout , fl.h)
		}
	else{
		frost.top = fe.add_image("transparent.png",0,(fl.w/frostpic.w)*frost_picT.y,fl.w,fl.h -2*(fl.w/frostpic.w)*frost_picT.y)
	}

	frost.top.preserve_aspect_ratio = false
	frost.top.visible = false
	frost.top.zorder = 2
}


/// Search Module ///

local search_surface = fe.add_surface(fl.w, fl.h)
local keys = null
keys = {}
local search_text = null
local key_low = 100

search_surface.preserve_aspect_ratio = true
search_surface.alpha = 255*0

//select( config.keys.selected[0], config.keys.selected[1] )

function search_toggle() {
	search_surface.alpha = ( search_surface.alpha == 0 ) ? 255: 0
	frg.grabdither = 2
	//clear text when shown
	if ( search_visible() ){
		if (search_text.msg == "") search_text.msg = search_base_rule + ": "
		search_clear()
	}
	
	if ((search_visible() == false) && (fe.list.search_rule == "")) {
		if (backs.index != -1) {
			fe.list.search_rule == ""
			fe.list.index = backs.index
			//corrector = backs.corrector
			backs.index = -1
		}

	}
	
}

function search_clear()
{
	s_text = ""
	search_text.msg = search_base_rule + ": "
	search_update_rule()
}

//get current visibility
function search_visible() {
	return (search_surface.alpha == 255)
}

function search_select_relative( rel_col, rel_row )
{
	search_select( key_selected[0] + rel_col, key_selected[1] + rel_row )
}

function search_select( col, row )
{
	row = ( row < 0 ) ? key_rows.len() - 1 : ( row > key_rows.len() - 1 ) ? 0 : row
	col = ( col < 0 ) ? key_rows[row].len() - 1 : ( col > key_rows[row].len() - 1 ) ? 0 : col
	local previous = key_rows[key_selected[1]][key_selected[0]].tochar()
	local selected = key_rows[row][col].tochar()

	keys[previous].set_rgb( key_low,key_low,key_low )
	keys[previous].alpha = 255
	keys[selected].set_rgb( 255,255,255 )
	keys[selected].alpha = 255
	key_selected = [ col, row ]
}

function search_type( c )
{
	if ( c == "<" )
		s_text = ( s_text.len() > 0 ) ? s_text.slice( 0, s_text.len() - 1 ) : ""
	else if ( c == "-" )
		search_clear()
	else if ( c == "~" )
	{
		//search_update_rule ()
		//backs.index = -1
		if (!prf.LIVESEARCH) search_update_rule()
		search_toggle()
		return
	}
	else if (c != "_")
		s_text = s_text + c
	search_text.msg = search_base_rule + ": " + s_text
	if (prf.LIVESEARCH) search_update_rule()
}

function search_update_rule(){
	try
	{
		local rule = search_base_rule + " contains " + recalculate (s_text)

		if (s_text.len() == 0) {
			searchdata.msg = ""
			search.string = ""
			fe.list.index = backs.index
		}
		else {
			search.string = ltxt(search_base_rule,TLNG) + ":"+s_text
			searchdata.msg = search.string
		}

		fe.list.search_rule = ( s_text.len() > 0 ) ? rule : ""
		corrector = (rows == 1 ? -1 : 0)

	} catch ( err ) { print( "Unable to apply filter: " + err ); }
}

function draw_osd() {
	
	//draw the search surface bg
	local bg = search_surface.add_image("kbg2.png", 0, 0, search_surface.width, search_surface.height)
	bg.alpha = 230
	
	//draw the search text object
	local osd_search = {
		x = ( search_surface.width * 0 ) * 1.0,
		y = ( search_surface.height * 0.2 ) * 1.0,
		width = ( search_surface.width * 1 ) * 1.0,
		height = ( search_surface.height * 0.1 ) * 1.0
	}
	
	search_text = search_surface.add_text(s_text, osd_search.x, osd_search.y, osd_search.width, osd_search.height)
	search_text.align = Align.Left
	search_text.font = uifonts.gui
	search_text.set_rgb( 255, 255, 255 )
	search_text.alpha = 255
	search_text.char_size = 80*scalerate
	
	
	//draw the search key objects
	foreach( key,val in key_names ) {
		
		local key_name = (key == "_") ? " " : ( key == "-" ) ? "⌧" : ( key == " " ) ? "⎵" : ( key == "<" ) ? "⌫" : ( key == "~" ) ? "DONE" : key.toupper()
		
		local textkey = search_surface.add_text( key_name, -1, -1, 1, 1 )
		textkey.font = uifonts.gui
		textkey.char_size = 80*scalerate
		
		textkey.set_rgb( key_low,key_low,key_low)
		textkey.alpha = 255
		
		keys[ key.tolower() ] <- textkey
		
	}
	
	
	//set search key positions
	local row_count = 0
	foreach ( row in key_rows )
	{
		local col_count = 0
		local osd = {
			x = ( search_surface.width * 0.1 ) * 1.0,
			y = ( search_surface.height * 0.4 ) * 1.0,
			width = ( search_surface.width * 0.8 ) * 1.0,
			height = ( search_surface.height * 0.5 ) * 1.0
		}
		//local keynumcol = (row == "- <~") ? 4 : 10
		local key_width = ( osd.width / row.len() ) * 1.0
		local key_height = ( osd.height / key_rows.len() ) * 1.0
		foreach ( char in row )
		{
			//local key_image = keys[ iii ]
			local key_image = keys[ char.tochar() ]
			local pos = {
				x = osd.x + ( key_width * col_count ),
				y = osd.y + key_height * row_count,
				w = key_width,
				h = key_height
			}
			key_image.set_pos( pos.x, pos.y, pos.w, pos.h )

			col_count++
		}
		row_count++
	}
}

draw_osd()
search_select (key_selected[0],key_selected[1])


/// History Page ///


local hist = {
	direction = 0,
	split_h = 0.55,
	scrollreset = false
}

local hist_titleT = {
	x = fl.w*hist.split_h + 15*scalerate,
	y = 0+15*scalerate,
	w = fl.w*(1.0 - hist.split_h)-30*scalerate,
	h = fl.h*0.25-30*scalerate
	transparency = 50
}

local hist_screenT = {
	x = 0,
	y = (fl.h-fl.w*hist.split_h)*0.5,
	w = fl.w*hist.split_h,
	h = fl.w*hist.split_h
}

hist_screenT.y += hist_screenT.y % 2.0
hist_screenT.w += hist_screenT.w % 2.0
hist_screenT.h += hist_screenT.h % 2.0

if (hist_screenT.h > fl.h){
	hist_screenT.x = (fl.w*hist.split_h-fl.h)*0.5
	hist_screenT.y = 0
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.w = fl.h
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = fl.h
	hist_screenT.h += hist_screenT.h % 2.0
}

local hist_textT = {
	x = fl.w*hist.split_h,
	y = fl.h*0.25,
	w = fl.w*(1.0-hist.split_h),
	h = fl.h*0.75
}

if (vertical){
	hist_titleT.x = 0
	hist_titleT.y = fl.h*hist.split_h
	hist_titleT.w = fl.w
	hist_titleT.h = fl.h*(1.0 - hist.split_h)*0.3

	hist_screenT.x = (fl.w-fl.h*hist.split_h)*0.5
	hist_screenT.x += hist_screenT.x % 2.0
	hist_screenT.y = 0
	hist_screenT.w = fl.h*hist.split_h
	hist_screenT.w += hist_screenT.w % 2.0
	hist_screenT.h = fl.h*hist.split_h
	hist_screenT.h += hist_screenT.h % 2.0

	if (hist_screenT.w > fl.w){
		hist_screenT.x = 0
		hist_screenT.y = (fl.h*hist.split_h - fl.w)*0.5
		hist_screenT.y += hist_screenT.y % 2.0
		hist_screenT.w = fl.w
		hist_screenT.w += hist_screenT.w % 2.0
		hist_screenT.h = fl.w
		hist_screenT.h += hist_screenT.h % 2.0
	}

	hist_textT.x = 0
	hist_textT.y = fl.h*hist.split_h + fl.h*(1.0 - hist.split_h)*0.3
	hist_textT.w = fl.w
	hist_textT.h = fl.h*(1.0 - hist.split_h)*0.7
}

local shadowscale = 0.025

hist_titleT.x = hist_titleT.x+hist_titleT.w*shadowscale
hist_titleT.y = hist_titleT.y+hist_titleT.h*shadowscale
hist_titleT.w = hist_titleT.w*(1-shadowscale*2)
hist_titleT.h = hist_titleT.h*(1-shadowscale*2)


local historypadding = (hist_screenT.w * 0.025)
historypadding += historypadding % 2.0

local hist_curr_rom = ""
local history_surface = fe.add_surface(fl.w,fl.h)

history_surface.add_clone(bglay.bg_surface)

local hist_bg = history_surface.add_text ("",0,0,history_surface.width,history_surface.height)
hist_bg.set_bg_rgb(0,0,0)
hist_bg.bg_alpha = 1


local bgpicture_hist = null
if ((prf.BGCUSTOMHISTORY != "") || (prf.BGCUSTOM != "")) {
	bgpicture_hist = history_surface.add_image(((prf.BGCUSTOMHISTORY != "") ? prf.BGCUSTOMHISTORY : prf.BGCUSTOM),0,0,fl.w,fl.h)
	bgpicture_hist.visible = false
	bgpicT.ar = (bgpicture_hist.texture_width*1.0) / bgpicture_hist.texture_height

	if (bgpicT.ar >= fl.w/(fl.h*1.0)){
		bgpicT.h = fl.h
		bgpicT.w = bgpicT.h * bgpicT.ar
		bgpicT.y = 0
		bgpicT.x = - (bgpicT.w - fl.w)*0.5
	}
	else {
		bgpicT.w = fl.w
		bgpicT.h = bgpicT.w / bgpicT.ar*1.0
		bgpicT.y = - (bgpicT.h - fl.h)*0.5
		bgpicT.x = 0
	}
	bgpicture_hist=history_surface.add_image (((prf.BGCUSTOMHISTORY != "") ? prf.BGCUSTOMHISTORY : prf.BGCUSTOM),bgpicT.x,bgpicT.y,bgpicT.w,bgpicT.h)
	bgpicture_hist.visible=true
}

history_surface.add_clone(bgoverlay)

local histgr = {
	black = null
	g1 = null
	g2 = null
}

if (!vertical){
	histgr.black = history_surface.add_image("black.png",0,0,fl.w*hist.split_h,fl.h)
	histgr.g1 = history_surface.add_image("wgradient2.png",0,0,fl.w*hist.split_h,fl.h*0.5) 
	histgr.g2 = history_surface.add_image("wgradient.png",0,fl.h*0.5,fl.w*hist.split_h,fl.h*0.5)
}
else{
	histgr.black = history_surface.add_image("black.png",0,0,fl.w,fl.h*hist.split_h)
	histgr.g1 = history_surface.add_image("wgradient3.png",0,0,fl.w*0.5,fl.h*hist.split_h)
	histgr.g2 = history_surface.add_image("wgradient4.png",fl.w*0.5,0,fl.w*0.5,fl.h*hist.split_h)
}

histgr.black.set_rgb (0,0,0)
histgr.g1.set_rgb (0,0,0)
histgr.g2.set_rgb (0,0,0)

histgr.g1.alpha = histgr.g2.alpha = (prf.DARKPANEL == null ? 0 : 150)
histgr.black.alpha =  (prf.DARKPANEL == null ? 0 : (prf.DARKPANEL == true ? 180 : 50))


local hist_white = null

if (prf.HISTORYPANEL){
	if (vertical) {
		hist_white = history_surface.add_image("white.png",0,fl.h*hist.split_h,hist_textT.w,fl.h-hist_screenT.h)
	}
	else{
		hist_white = history_surface.add_image("white.png",hist_textT.x,0,hist_textT.w,fl.h)
	}
	hist_white.alpha = 200
}

local hist_title = history_surface.add_image ("transparent.png",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)
hist_title.preserve_aspect_ratio = true


local hist_title_top = null
local hist_titletxt_bot = null



if (prf.HISTORYPANEL){
	hist_title_top = history_surface.add_clone (hist_title)
	
	hist_title_top.preserve_aspect_ratio = true

	hist_title.set_pos (hist_titleT.x-hist_titleT.w*shadowscale ,hist_titleT.y+2*shadowscale*hist_titleT.h,hist_titleT.w*(1+shadowscale*2),hist_titleT.h*(1+shadowscale*2))
	hist_title.set_rgb(0,0,0)
	hist_title.alpha = hist_titleT.transparency

	hist_titletxt_bot = history_surface.add_text("...",hist_title.x, hist_title.y, hist_title.width,hist_title.height)

	hist_titletxt_bot.char_size = 150*scalerate
	hist_titletxt_bot.word_wrap = true
	hist_titletxt_bot.margin = 0
	hist_titletxt_bot.align = Align.MiddleCentre
	hist_titletxt_bot.char_spacing = 0.7

	hist_titletxt_bot.font = uifonts.arcadeborder
	hist_titletxt_bot.line_spacing = 0.6
	hist_titletxt_bot.set_rgb(0,0,0)
	hist_titletxt_bot.alpha = hist_titleT.transparency

}

local hist_titletxt_bd = history_surface.add_text("...",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)
local hist_titletxt = history_surface.add_text("...",hist_titleT.x,hist_titleT.y,hist_titleT.w,hist_titleT.h)

hist_titletxt_bd.char_size = hist_titletxt.char_size = 150*scalerate
hist_titletxt_bd.word_wrap = hist_titletxt.word_wrap = true
hist_titletxt_bd.margin = hist_titletxt.margin = 0
hist_titletxt_bd.align = hist_titletxt.align = Align.MiddleCentre
hist_titletxt_bd.char_spacing = hist_titletxt.char_spacing = 0.7

hist_titletxt_bd.font = uifonts.arcadeborder
hist_titletxt_bd.line_spacing = 0.6
hist_titletxt_bd.set_rgb (80,80,80)
hist_titletxt_bd.alpha = 200
hist_titletxt_bd.set_rgb (135,135,135)
hist_titletxt_bd.alpha = 255

hist_titletxt.font = uifonts.arcade
hist_titletxt.line_spacing = 0.6
//hist_titletxt.set_bg_rgb(200,0,0)
//hist_titletxt.bg_alpha = 255


local CRTprf = null

if (prf.SCANLINEMODE == "scanlines"){
	CRTprf = {
		aperature_type = 0.0
		hardScan = -15.0
		hardPix = -2.0
		maskDark = 0.4
		maskLight = 1.5
		saturation = 1.0
		tint = 0.0
		blackClip = 0.1
		brightMult = 1.4
		distortion = 0.2
		cornersize = 0.05
		cornersmooth = 60
		scanresample = 1.0
	}
}

if (prf.SCANLINEMODE == "aperture"){
	CRTprf = {
		aperature_type = 3.0
		hardScan = -3.0
		hardPix = -2.0
		maskDark = 0.6
		maskLight = 1.3
		saturation = 1.0
		tint = 0.0
		blackClip = 0.1
		brightMult = 1.1
		distortion = 0.2
		cornersize = 0.05
		cornersmooth = 60
		scanresample = 1.0
	}
}

if (prf.SCANLINEMODE == "halfres"){
	CRTprf = {
		aperature_type = 0.0
		hardScan = -15.0
		hardPix = -4.0
		maskDark = 0.4
		maskLight = 1.5
		saturation = 1.0
		tint = 0.0
		blackClip = 0.1
		brightMult = 1.4
		distortion = 0.2
		cornersize = 0.05
		cornersmooth = 60
		scanresample = 0.5
	}
}

if (prf.SCANLINEMODE == "none"){
	CRTprf = {
		aperature_type = 0.0
		hardScan = -3.0
		hardPix = -2.0
		maskDark = 0.4
		maskLight = 1.5
		saturation = 1.0
		tint = 0.0
		blackClip = 0.1
		brightMult = 1.0
		distortion = 0.2
		cornersize = 0.05
		cornersmooth = 60
		scanresample = 1.0
	}
}

local LCDprf = null

if (prf.LCDMODE == "matrix"){
	LCDprf = {
		matrix = 1.0
		scaler = 1.0
	}
}
if (prf.LCDMODE == "halfres"){
	LCDprf = {
		matrix = 1.0
		scaler = 0.5
	}
}
if (prf.LCDMODE == "none"){
	LCDprf = {
		matrix = 0.0
		scaler = 1.0
	}
}

local shader_lottes = null;
shader_lottes=fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");
shader_lottes.set_param("aperature_type", CRTprf.aperature_type); // 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
shader_lottes.set_param("hardScan", CRTprf.hardScan);			// Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium
shader_lottes.set_param("hardPix", CRTprf.hardPix);			// Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
shader_lottes.set_param("maskDark",CRTprf.maskDark);			// Sets how dark a "dark subpixel" is in the aperture pattern.
shader_lottes.set_param("maskLight", CRTprf.maskLight);		// Sets how dark a "bright subpixel" is in the aperture pattern
shader_lottes.set_param("saturation", CRTprf.saturation);	// 1.0 is normal saturation. Increase as needed.
shader_lottes.set_param("tint", CRTprf.tint);					// 0.0 is 0.0 degrees of Tint. Adjust as needed.
shader_lottes.set_param("blackClip", CRTprf.blackClip);		// Drops the final color value by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("brightMult", CRTprf.brightMult);	// Multiplies the color values by this amount if GAMMA_CONTRAST_BOOST is defined
shader_lottes.set_param("distortion", CRTprf.distortion);	// 0.0 to 0.2 seems right
shader_lottes.set_param("cornersize", CRTprf.cornersize);	// 0.0 to 0.1
shader_lottes.set_param("cornersmooth", CRTprf.cornersmooth); // Reduce jagginess of corners
shader_lottes.set_param("vignettebase", 0.3,1.0,2.0);			// base lightness for vignette

shader_lottes.set_texture_param("texture")

local pixelpic = fe.add_image("pixel8.png",0,0)
pixelpic.visible = false
local shader_lcd = null
shader_lcd = fe.add_shader (Shader.Fragment,"lcd.glsl")
shader_lcd.set_texture_param( "texture")
shader_lcd.set_texture_param( "pixel",pixelpic)
shader_lcd.set_param ("pixelsize", 10,10)
shader_lcd.set_param ("matrix", LCDprf.matrix)
shader_lcd.set_param("color1",0,0,0)
shader_lcd.set_param("color2",0,0,0)
shader_lcd.set_param ("remap", false)

// History text surface
local hist_text_surf = history_surface.add_surface( hist_textT.w, hist_textT.h )
hist_text_surf.set_pos (hist_textT.x, hist_textT.y )

local hist_text = hist_text_surf.add_text( "", 0,0, hist_textT.w, hist_textT.h )
hist_text.char_size = (prf.LOWRES ? 55*scalerate : (40 * scalerate > 8 ? 40*scalerate : 8))
hist_text.align = Align.TopCentre

hist_text.first_line_hint = 3
hist_text.visible = true
if (prf.HISTORYPANEL) {
	hist_text.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
	hist_text_surf.set_rgb(themeT.themehistorytextcolor,themeT.themehistorytextcolor,themeT.themehistorytextcolor)
}
else {
	hist_text.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
	hist_text_surf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
}

local gradshader = fe.add_shader (Shader.Fragment, "blackgrad2.glsl")
gradshader.set_texture_param( "texture")
gradshader.set_param ("limits", 40 * scalerate * 1.7 / hist_textT.h , 40 * scalerate * 5.0 / hist_textT.h)

//hist_text_surf.shader = gradshader
hist_text_surf.shader = noshader

local histglow = {
	w = hist_screenT.w - 2 * historypadding
	x = hist_screenT.x + historypadding
	y = hist_screenT.y + historypadding
}

// shadow parameters
local shadow = {
	radius = histglow.w*0.25
	downsample = 64.0/histglow.w
	enlarge = 0.97
}

// creation of first surface with safeguards area
local shadowsurf1 = fe.add_surface (shadow.downsample * (histglow.w + 2 * shadow.radius), shadow.downsample * (histglow.w + 2 * shadow.radius))

// add a clone of the picture to topmost surface
local hist_glow_pic = shadowsurf1.add_image("transparent.png",(shadow.radius-0.5*histglow.w*(shadow.enlarge - 1.0))*shadow.downsample,(shadow.radius-0.5*histglow.w*(shadow.enlarge - 1.0))*shadow.downsample,histglow.w*shadow.enlarge*shadow.downsample,histglow.w*shadow.enlarge*shadow.downsample)
//hist_glow_pic.mipmap = 1
hist_glow_pic.preserve_aspect_ratio = true

local hist_glow_shader = fe.add_shader(Shader.Fragment, "colormapper.glsl")
hist_glow_shader.set_texture_param ("texture")
hist_glow_shader.set_param ("remap",false)
hist_glow_shader.set_param("color1",0,0,0)
hist_glow_shader.set_param("color2",0,0,0)
hist_glow_pic.shader = hist_glow_shader

// creation of second surface
local shadowsurf2 = fe.add_surface (shadowsurf1.width, shadowsurf1.height)

// nesting of surfaces
shadowsurf1.visible = false
shadowsurf1 = shadowsurf2.add_clone(shadowsurf1)
shadowsurf1.visible = true

shadowsurf2.visible = false
shadowsurf2 = history_surface.add_clone(shadowsurf2)
shadowsurf2.visible = true

local blursizeglow = {
	x = 1.0/shadowsurf2.width
	y = 1.0/shadowsurf2.height
}

local kerneldat = {
	size = shadow.downsample * (shadow.radius * 2) + 1
	sigma = shadow.downsample * shadow.radius * 0.3
}

local shadowshader = {
	h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
	v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o_glow.glsl" )
}
shadowshader.h.set_texture_param("texture")
shadowshader.h.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.h.set_param("offsetFactor", blursizeglow.x, 0.0)
//shadowsurf1.shader = shadowshader.h
shadowsurf1.shader = noshader

shadowshader.v.set_texture_param("texture")
shadowshader.v.set_param("kernelData", kerneldat.size, kerneldat.sigma)
shadowshader.v.set_param("offsetFactor", 0.0, blursizeglow.y)
//shadowsurf2.shader = shadowshader.v
shadowsurf2.shader = noshader

shadowsurf2.set_pos (histglow.x-shadow.radius,histglow.y-shadow.radius, histglow.w + 2 * shadow.radius , histglow.w + 2 * shadow.radius)

//local hist_screen_ar = hist_screenT.w * 1.0 / hist_screenT.h

local hist_screensurf = history_surface.add_surface (hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screensurf.set_pos(hist_screenT.x+historypadding,hist_screenT.y+historypadding)

local hist_screen = hist_screensurf.add_clone(hist_glow_pic)
hist_screen.set_pos(0,0,hist_screenT.w-2.0*historypadding,hist_screenT.h-2.0*historypadding)
hist_screen.preserve_aspect_ratio = true
if (!prf.AUDIOVIDHISTORY) hist_screen.video_flags = Vid.NoAudio
hist_screen.shader = noshader


history_surface.visible = false
history_surface.alpha = 0

function history_updatesnap(){
	hist_screen.file_name = fe.get_art ("snap")
	hist_screen.shader = ((screentype(0,0)!="CRT") ? shader_lcd : shader_lottes)
	if (screenrecolor(0,0)) {

		local localcolor = prf.GBRECOLOR == "AUTO" ? gbrgb[screentype(0,0)] : gbrgb[prf.GBRECOLOR]

		hist_screen.shader.set_param("remap",prf.GBRECOLOR != "NONE")
		hist_glow_shader.set_param("remap",prf.GBRECOLOR != "NONE")
		hist_glow_shader.set_param("color1", localcolor.a.R, localcolor.a.G, localcolor.a.B)
		hist_glow_shader.set_param("color2", localcolor.b.R, localcolor.b.G, localcolor.b.B)
		hist_screen.shader.set_param("color1", localcolor.a.R, localcolor.a.G, localcolor.a.B)
		hist_screen.shader.set_param("color2", localcolor.b.R, localcolor.b.G, localcolor.b.B)	}
	else{
		hist_screen.shader.set_param("remap",false)
		hist_glow_shader.set_param("remap",false)
	}

	shadowsurf1.shader = shadowshader.h
	shadowsurf2.shader = shadowshader.v

	hist_screen.width = hist_screensurf.subimg_width;
	hist_screen.height = hist_screensurf.subimg_height;

	local nativeres = null
	
	try{
		nativeres = [system_data[fe.game_info(Info.System).tolower()].w , system_data[fe.game_info(Info.System).tolower()].h]
	}
	catch (err){
		nativeres = [hist_screen.texture_width,hist_screen.texture_height]
	}

	if ( (nativeres[0] == 0) && (nativeres[1] == 0) ) {
		nativeres = [hist_screen.texture_width,hist_screen.texture_height]
	}


	if (screentype(0,0)=="CRT"){
		hist_screen.smooth = true
		hist_screen.shader.set_param("vert", (nativeres[0] >= nativeres[1] ? 0.0 : 1.0));
		hist_screen.shader.set_param("color_texture_sz", nativeres[0]*CRTprf.scanresample, nativeres[1]*CRTprf.scanresample);
		hist_screen.shader.set_param("color_texture_pow2_sz", nativeres[0]*CRTprf.scanresample, nativeres[1]*CRTprf.scanresample);
	}
	else {
		hist_screen.smooth = false
		hist_screen.shader.set_param("pixelsize", 1.0*nativeres[0]*LCDprf.scaler,1.0*nativeres[1]*LCDprf.scaler )
	}
}

function history_updatetext(){
	hist_title.file_name = fe.get_art ("wheel")
	
	local char_rows = ( ((hist_titleT.w/hist_titleT.h) > 3.0) ? 2 : 3)
	local charfontsize = 1.1*hist_titleT.h/char_rows
	local char_cols = floor (hist_titleT.w / (charfontsize*0.6))

	local hist_logotitle = wrapme( fe.game_info (Info.Title, 0),char_cols,char_rows )

	hist_titletxt_bd.msg = hist_titletxt.msg = hist_logotitle.text
	if (prf.HISTORYPANEL) hist_titletxt_bot.msg = hist_logotitle.text

	hist_titletxt_bd.char_size = hist_titletxt.char_size = min( ((charfontsize*0.95)*char_cols)/hist_logotitle.cols , ((charfontsize*0.95)*char_rows)/hist_logotitle.rows )

	if (prf.HISTORYPANEL) hist_titletxt_bot.char_size = hist_titletxt.char_size * (hist_titletxt_bot.width/hist_titletxt.width)
	
	hist_titletxt_bd.x = hist_titletxt.x + 0.015 * hist_titletxt.char_size
	hist_titletxt_bd.y = hist_titletxt.y - 0.025 * hist_titletxt.char_size

	hist_titletxt_bd.visible = hist_titletxt.visible = (hist_title.subimg_height == 0)
	if (prf.HISTORYPANEL) hist_titletxt_bot.visible = (hist_title.subimg_height == 0)

	hist_text_surf.shader = gradshader

	local sys = split( fe.game_info( Info.System ), ";" )
	local rom = fe.game_info( Info.Name )

	//
	// we only go to the trouble of loading the entry if
	// it is not already currently loaded
	//
	if ( hist_curr_rom != rom )
	{
		hist_curr_rom = rom
		local alt = fe.game_info( Info.AltRomname )
		local cloneof = fe.game_info( Info.CloneOf )

		local lookup = af_get_history_offset( sys, rom, alt, cloneof )
		
		if ( lookup >= 0 )
		{
			//fe.overlay.splash_message(lookup + " " + my_config)
			hist_text.first_line_hint = 3
			try {
				hist_text.msg = af_get_history_entry( lookup, prf )
				} catch ( err ) { hist_text.msg = "\n\n\nThere was an error loading game data, please check history.dat preferences in the layout options"; }
		}
		else
		{
			
			if ( lookup == -2 )
				hist_text.msg = "\n\n\nIndex file not found. Try generating an index from the history.dat plug-in configuration menu."
			else
			//	hist_text.msg = "\n\n\nUnable to locate: "+ rom
		
				//	hist_text.first_line_hint = 3

			hist_text.msg = "\n\n\n" + fe.game_info (Info.Title) + "\n" + "© " + fe.game_info(Info.Year) + " by " + fe.game_info(Info.Manufacturer) +"\n\n"+ fe.game_info(Info.Overview) +"\n\n\n"
		}
	}
}

function history_show(h_startup)
{
	if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

	history_updatesnap()
	history_updatetext()

	if (h_startup) {
		history_surface.visible=true
		flowT.history = startfade (flowT.history,0.05,3.0)
		flowT.histtext = startfade (flowT.histtext,0.05,-3.0)
		flowT.data = startfade (flowT.data,-0.08,-3.0)
		flowT.fg = startfade (flowT.fg,0.08,-3.0)
		flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]
	}
}


function history_hide() {
	//history_surface.visible = false
	if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.Default

	flowT.history = startfade (flowT.history,-0.05,-3.0)
	flowT.histtext = startfade (flowT.histtext,-0.5,0.0)
	flowT.data = startfade (flowT.data,0.06,3.0)
	flowT.fg = startfade (flowT.fg,-0.06,3.0)
}

function history_visible() {
	return ((history_surface.visible) && (flowT.history[3] >= 0))
}

function on_scroll_up() {
	hist_text.first_line_hint--
}

function on_scroll_down() {
	hist_text.first_line_hint++
}

function history_exit () {
//	hist_title.file_name = "transparent.png"
//	hist_screen.file_name = "transparent.png"
	history_hide()
}

// Fade helper functions

function fadeupdate(fadearray){
	local t_counter = fadearray[0]
	local t_value = fadearray[1]
	local t_starter = fadearray[2]
	local t_increaser = fadearray[3]
	local t_easer = fadearray[4]

	t_counter = t_counter + t_increaser

	if (t_easer == 0)
		t_value = t_counter
	else if (t_easer > 0)
		t_value = t_starter + pow (t_counter-t_starter,t_easer)
	else if (t_easer < 0)
		t_value = t_starter + 1 - pow (1.0 - t_counter + t_starter, -1*t_easer)

	return ([t_counter,t_value,t_starter,t_increaser,t_easer])
}

function checkfade(fadearray) {
	return (fadearray[3] != 0)
}

function startfade (fadearray,t_increaser,t_easer) {
	local t_data = fadearray[1]
	return ([t_data,t_data,t_data,t_increaser,t_easer])
}

function history_changegame(direction){
	
	if ((prf.AUDIOVIDSNAPS) && (prf.THUMBVIDEO)) vidszTable[newfocusindex].video_flags = Vid.NoAudio

	flowT.historyscroll = startfade (flowT.historyscroll,0.0751,0.0)
	flowT.historyblack = startfade (flowT.historyblack,flowT.historyscroll[3]*2.0,0.0)
	flowT.historydata = startfade (flowT.historydata,0.101,0.0)
	hist.scrollreset = true
	hist.direction = direction
}


/// Display Menu Page ///

local disp0 = {
	w = fl.w
	h = fl.h-header.h-footer.h-overlay.labelsize
}


// DISPLAY ARTWORKS (DECOUPLED FROM DISPLAYS MENU)
local disp = {
	items = []
	dispcode = []
	tilew =  ((disp0.h > disp0.w*0.5) ? disp0.w * 0.5 : disp0.h) 
	tileh =  ((disp0.h > disp0.w*0.5) ? disp0.w * 0.5 : disp0.h) 
	pos0 = []
	xstart = 0
	xstop = 0
	speed = null
	pad = padding
	width = null
	height = fl.h-header.h-footer.h-overlay.labelsize
	spacing = null
	x = null
	y = header.h + overlay.labelsize
	starter = false
	shown = 0
}

disp.width = disp.tilew 
disp.speed = disp.tileh * 0.1
disp.spacing = disp0.h
disp.x = fl.w - disp.tilew

local zmenu = {
	items = []
	tilew = fl.w 
	tileh = floor(overlay.fullheight/overlay.rows)
	pos0 = []
	xstart = 0
	xstop = 0
	speed = null
	pad = padding
	width = fl.w
	height = overlay.fullheight
	x = 0
	y = header.h + overlay.labelsize
	shown = 0
	selected = 0
	glyphs = []
	glyphw = floor(overlay.fullheight/overlay.rows)
	glyphh = floor(overlay.fullheight/overlay.rows)
	midoffset = 0
	virtualheight = 0
	blanker = null
	overlaymsg = ""
	selectedbar = null
}


zmenu.speed = zmenu.tileh * 0.1

local zmenu_surface = fe.add_surface (zmenu.width,zmenu.height)
local zmenu_surface_container = fe.add_surface (zmenu.width,zmenu.height)

zmenu_surface.visible = false
zmenu_surface = zmenu_surface_container.add_clone(zmenu_surface)
zmenu_surface.visible = true

zmenu_surface_container.set_pos (zmenu.x,zmenu.y)

zmenu_surface.add_image("black.png",0,0,zmenu_surface.width,zmenu_surface.height)
zmenu.selectedbar = zmenu_surface.add_image ("white.png",zmenu.pad,0,zmenu.width - 2 * zmenu.pad,zmenu.tileh) 

zmenu.blanker = zmenu_surface.add_image("black.png",0,0,1,1)
zmenu.blanker.visible = false
 zmenu_surface.shader = txtoalpha


/*
function nodisplayartwork(){
	local dispcount = 0
	foreach (item in disp.items){
		try {dispcount = dispcount + item.texture_width*item.texture_height}
		catch (err){}
	}
	return (dispcount == 0)
}
*/

zmenu_surface_container.zorder = 1
sh_scale.r2 = 0.5 * sh_scale.r1


local zmenu_surface_sh = fe.add_surface(zmenu_surface.width * sh_scale.r2 , zmenu_surface.height * sh_scale.r2)
local zmenu_surface_sh1 = zmenu_surface_sh.add_clone(zmenu_surface_container)
zmenu_surface_sh1.set_pos (0 , 0 , zmenu_surface.width * sh_scale.r2 , zmenu_surface.height * sh_scale.r2)

zmenu_surface_sh.set_rgb(0,0,0)
zmenu_surface_sh1.set_rgb(0,0,0)

local shader_tx2 = {
	h = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
	v = fe.add_shader( Shader.Fragment, "gauss_kernsigma_o.glsl" )
}

shader_tx2.v.set_texture_param( "texture")
shader_tx2.v.set_param("kernelData",9,3.0)
shader_tx2.v.set_param("offsetFactor",0.000,1.0/(fl.h*sh_scale.r2))

shader_tx2.h.set_texture_param( "texture")
shader_tx2.h.set_param("kernelData",9,3.0)
shader_tx2.h.set_param("offsetFactor",1.0/(fl.w*sh_scale.r2),0.000)

zmenu_surface_sh.shader = noshader
zmenu_surface_sh1.shader = noshader


zmenu_surface_sh.alpha = themeT.menushadow

zmenu_surface_sh.zorder = 0

zmenu_surface_sh.set_pos(zmenu_surface_container.x + 4*scalerate,zmenu_surface_container.y + 8*scalerate,zmenu_surface_container.width,zmenu_surface_container.height)

function drawdisplays(){
	local artname = ""
	local filename = ""
	local zippo = null
	local pad = disp.pad
	local iindex = 0

	for (local i = 0 ; i < fe.displays.len() ; i++){
		if (fe.displays[i].in_menu){

			disp.dispcode.push (i)
			artname = FeConfigDirectory+"menu-art/snap/"+fe.displays[i].name
			filename = ""
			if ( file_exist (artname+".jpg") ) filename = artname+".jpg"
			if ( file_exist (artname+".png") ) filename = artname+".png"

			zippo = zmenu_surface_container.add_image( "", pad + disp.x + disp.width*0.5 - 0.5 * disp.tilew , pad + disp.height * 0.5 - disp.tileh * 0.5 + iindex * disp.spacing , disp.tilew - 2.0*pad , disp.tileh -2.0*pad )
			zippo.preserve_aspect_ratio = true
			zippo.file_name = filename
			disp.items.push(zippo)
			disp.pos0.push (zippo.y)
					
			iindex ++
		}
	}

	disp.shown = iindex
}

function showdisp(status){
	foreach (item in disp.items){
		item.visible = status
	}
}

function drawzmenu(menuarray,glypharray,title,titleglyph,presel,shrink){
	zmenu.blanker.visible = false
	overlay.labelmsg = title
	overlay_glyph.msg = gly(titleglyph)

	if (prfmenu.showing) {
		zmenu.glyphh = zmenu.tileh = floor(overlay_listbox.height/overlay.rows)
		zmenu.height = overlay_listbox.height
//		zmenu_surface_sh.visible = false
	}
	else {
		zmenu.glyphh = zmenu.tileh = floor(overlay.fullheight/overlay.rows)
		zmenu.height = overlay.fullheight
//		zmenu_surface_sh.visible = true
	}

	if (!prf.ENHANCEDMENU) return
	prf.ZMENUON = true

	if (glypharray == null) {
		glypharray = []
		for (local i=0;i<menuarray.len();i++){
			glypharray.push (" ")
		}
	}

	local artname = ""
	local filename = ""
	local obj_item = null
	local obj_glyph = null
	local pad = zmenu.pad
	local fontscaler = 0.7
	local iindex = 0

	// Hide excess items from menu display
	for (local i = 0 ; i < zmenu.items.len() ; i++ ){
		zmenu.items[i].visible = false
		zmenu.glyphs[i].visible = false
	}
	zmenu.virtualheight = zmenu.tileh*menuarray.len()
	zmenu.midoffset = zmenu.height * 0.5 - zmenu.virtualheight * 0.5
	// Generate items for menu display
	for (local i = 0 ; i < menuarray.len() ; i++){
		
			 
		//Y obj_item = zmenu_surface.add_text(" ",pad, zmenu.height*0.5 - zmenu.tileh*0.5 + i * zmenu.tileh , zmenu.tilew - 2.0*pad, zmenu.tileh)		
		obj_item = zmenu_surface.add_text(" ",zmenu.glyphw, zmenu.midoffset + i * zmenu.tileh , zmenu.tilew + (shrink ? pad - disp.width : 0) - 2 * zmenu.glyphw, zmenu.tileh)		
		obj_item.msg = menuarray[i]
		obj_item.font = uifonts.gui
		obj_item.char_size = overlay.charsize //TEST70 was zmenu.tileh*fontscaler
		obj_item.word_wrap = true
		obj_item.margin = padding*2
		obj_item.align = Align.MiddleCentre
		obj_item.bg_alpha = 0
		obj_item.set_rgb(255,255,255)

		obj_glyph = zmenu_surface.add_text(" ",pad, zmenu.height*0.5 - zmenu.tileh*0.5 + i * zmenu.tileh , zmenu.glyphw, zmenu.glyphh)
		obj_glyph.font = uifonts.glyphs
		obj_item.margin = 0
		obj_glyph.char_size = overlay.charsize*1.25
		obj_glyph.align = Align.MiddleCentre
		obj_glyph.msg = gly(glypharray[i])
		obj_glyph.set_bg_rgb (100,0,0)
		obj_glyph.bg_alpha = 0
		obj_glyph.set_rgb(255,255,255)


		try { zmenu.glyphs[i] = obj_glyph } catch (err) { zmenu.glyphs.push (obj_glyph) }		
		try { zmenu.items[i] = obj_item } catch (err) { zmenu.items.push (obj_item) }
		
		try { zmenu.pos0 [i] = obj_item.y } catch (err) { zmenu.pos0.push (obj_item.y) }
		
	}

	local maxwidth = 0
	for (local i = 0 ; i < glypharray.len() ; i++){
		if (zmenu.items[i].msg_width > maxwidth) maxwidth = zmenu.items[i].msg_width
	}

   for (local i = 0 ; i < glypharray.len(); i++){
		zmenu.glyphs[i].x = max( ( overlay_listbox.x + overlay_listbox.width*0.5 - 0.5*maxwidth - zmenu.glyphs[i].width ) , zmenu.pad*0.5 )
		//zmenu.glyphs[i].x = min(zmenu.glyphs[i].x,overlay_listbox.x + overlay_listbox.width*0.4)

	}

	zmenu.shown = menuarray.len()
	zmenu.selected = presel

	zmenu.items[zmenu.selected].set_rgb(0,0,0)
	zmenu.glyphs[zmenu.selected].set_rgb(0,0,0)
	zmenu.selectedbar.y = zmenu.items[zmenu.selected].y
	zmenu.selectedbar.height = zmenu.items[zmenu.selected].height
	zmenu.selectedbar.width = zmenu.tilew + (shrink ? pad - disp.width : 0) - 2 * zmenu.pad

	if (prfmenu.showing){
		zmenu.blanker = zmenu_surface.add_image("black.png",0,zmenu.height,fl.w,prfmenu.picrateh+padding)
		zmenu.blanker.visible = true
	}
	
	zmenu_surface.set_rgb(themeT.listboxselbg,themeT.listboxselbg,themeT.listboxselbg)
}

if (prf.DMPIMAGES) {
	drawdisplays()
	disp.xstop = - fe.list.display_index * disp.spacing
	showdisp(false)
}

drawzmenu([""],[0xe900],"",0xe900,0,false)
prf.ZMENUON = false
zmenu.xstop = 0

local selected = {
	display = fe.list.display_index //TEST58 CHECK WITH NO DISPLAYS!!!
	zmenu = 0
}

zmenu_surface_container.visible = zmenu_surface_sh.visible = false

if (prf.DMPIMAGES) disp.starter = true //TET71


function displaygrouped(){
	prf.JUMPSHOW = true
	local grouplabel = ["ARCADE","CONSOLE","HANDHELD","COMPUTER","OTHER"]
	local groupname = ["zmenuarcade","zmenuconsole","zmenuhandheld","zmenucomputer","other"]
	local groupglyps = [0xeaeb,0xeaec,0xe959,0xe956,0xe912]
	local structure = {}

	foreach (data in grouplabel){
		structure [data] <- []
	}

	// NOTA BENE: Il current display fe.list.display_index considera tutti, anche quelli non mostrati, quindi va bene
	for (local i = 0 ; i < fe.displays.len() ; i++ ){
		if (fe.displays[i].in_menu){
			local systemtype = "OTHER"
			try{systemtype = system_data[fe.displays[i].name.tolower()].group} catch (err) {}
			structure[systemtype].push({name = fe.displays[i].name,index = i})
		}
	}

	local gmenu0 = 0
	local gmenu0out = 0
	local getout = false
	while ((gmenu0 != -1) && (!getout)) {
		gmenu0 = glyph_list_dialog(groupname,null,"Displays menu",0xe912,gmenu0out)
		gmenu0out = gmenu0

		if (gmenu0 != -1) {
			local temparray = []
			foreach (item in structure[grouplabel[gmenu0]]){
				temparray.push(item.name)
			}
			local gmenu1 = glyph_list_dialog(temparray,null,grouplabel[gmenu0],groupglyps[gmenu0],0)
			if (gmenu1 != -1 ) {
				
//				fe.set_display(structure[grouplabel[gmenu0]][gmenu1].index)
				local targetdisplay = structure[grouplabel[gmenu0]][gmenu1].index
				local jumps = targetdisplay - fe.list.display_index
				if (jumps != 0 ) {
					prf.JUMPSTEPS = abs(jumps)
					prf.JUMPDISPLAYS = true
				}
				if ( jumps > 0 ) {
					for (local i = 0; i < jumps; i++) fe.signal("next_display")
				}
				if ( jumps < 0 )  {
					for (local i = 0; i < abs(jumps); i++) fe.signal("prev_display")
				}
				getout = true
			}
		}
	}
	prf.JUMPSHOW = false

	//testpr ("current:" + fe.list.display_index)
	//testpr (structure["CONSOLE"].len())
}



/// Layout fades ///

function hideallbutbg () {
	flowT.data = startfade (flowT.data,-1,0.0)
	flowT.fg = startfade (flowT.fg,1,0.0)
	flowT.logo = startfade (flowT.logo,-1,0.0)
	flowT.history = startfade (flowT.history,-1.0,0.0)
	flowT.histtext = startfade (flowT.histtext,-1.0,0.0)				
	//history_hide()
}

function layoutfadein () {
	if (prf.SPLASHON){
		flowT.fg = [1.0,1.0,1.0,-0.011,1.0]
		flowT.data = [0.0,0.0,0.0,0.011,1.0]
		flowT.logo = [1.0,1.0,1.0,-0.017,1.0]
	}
	else {
		flowT.fg = [1.0,1.0,1.0,-0.016,-1.0]
		flowT.data = [0.0,0.0,0.0,0.016,-1.0]
		flowT.logo = [1.0,1.0,1.0,-0.02,1.0]
	}
}

data_surface.alpha = data_surface_sh.alpha = 0
fg_surface.alpha = 255

// moved after the fade if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

/// Attract mode ///
local attract = {
	start = true
	// updatesnap = false
	rolltext = false
	gametimer = false
	starttimer = false

	scanrows = 180.0
	scansize = 5

	textshadow = 80
	game_interval = 1000 * prf.AMCHANGETIMER
	attract_interval = 1000 * prf.AMTIMER
	timer = fe.layout.time
	w = 0
	nw = 0
	x = 0
	y = 0
	msg = prf.AMMESSAGE
	sound = prf.AMSOUND
}

// If the screen resolution is so low that 5 pixels per scanline would not fit,
// pixels per scanlines are calculated as integer and no rescaling is applied.
// otherwise scanlines are 5 pixel tall and image is 900x900 and rescaled to fit
// the actual screen resolution (to improve performance)

if (attract.scansize <= ceil (bgT.w/attract.scanrows)){
	attract.nw = attract.scansize * attract.scanrows
	attract.w = bgT.w * 1.01
	attract.x = bgT.x - bgT.w * 0.005
	attract.y = bgT.y - bgT.w * 0.005
}
else {
	attract.scansize = ceil (bgT.w/attract.scanrows)
	attract.nw = attract.scansize * attract.scanrows
	attract.w = attract.nw
	attract.x = bgT.x - (attract.nw - bgT.w)*0.5
	attract.y = bgT.y - (attract.nw - bgT.w)*0.5
}


local attract_surface = null
local attract_snap = null
local attract_black = null
local attract_text_surface = null
local attract_text = null
local attract_text2 = null

local attract_fade = null
local attract_vignette = null
local shader_2_lottes = null

function attractkick(){
	if (history_visible()) history_hide()
	if (overmenu_visible()) overmenu_hide(true)
	attract.start = true
	attract.starttimer = false
	attract_surface.visible = true
	attract_text.visible = attract_text2.visible = true
	attract_snap.shader = shader_2_lottes

	flowT.attract = startfade (flowT.attract, 0.1,0.0)
	flowT.logo = startfade (flowT.logo,0.1,0.0)
	flowT.fg = startfade (flowT.fg,0.1,0.0)
}

function attractupdatesnap(){
	attract_snap.file_name = fe.get_art("snap",fe.list.size*rand()/RAND_MAX)
	// attract_snap.file_name = fe.get_art("snap")

	if (attract_snap.texture_width >= attract_snap.texture_height){
		attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5
		attract_snap.subimg_height = attract.scanrows
		attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
		attract_snap.subimg_width = attract.scanrows * ((attract_snap.texture_width * 3.0/4.0)/attract_snap.texture_height)
	}
	else
	{
		attract_snap.subimg_x = attract_snap.texture_width * 0.5 - attract.scanrows * 0.5
		attract_snap.subimg_width = attract.scanrows
		attract_snap.subimg_y = attract_snap.texture_height * 0.5 - attract.scanrows * 0.5 * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
		attract_snap.subimg_height = attract.scanrows * ((attract_snap.texture_height * 3.0/4.0)/attract_snap.texture_width)
	}

	shader_2_lottes.set_param("vert", (attract_snap.texture_width >= attract_snap.texture_height ? 0.0 : 1.0))
	shader_2_lottes.set_param("color_texture_sz", attract_snap.texture_width, attract_snap.texture_height)
	shader_2_lottes.set_param("color_texture_pow2_sz", attract_snap.texture_width, attract_snap.texture_height)
}

if (prf.AMENABLE){

	shader_2_lottes = fe.add_shader(Shader.VertexAndFragment,"CRTL-geom_vsh.glsl","CRTL-geom_fsh.glsl");


	attract_surface = fe.add_surface (attract.nw,attract.nw)
	attract_surface.set_pos(attract.x,attract.y,attract.w,attract.w)
	attract_snap = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
	attract_snap.preserve_aspect_ratio = false

	attract_black = attract_surface.add_text("",0,0,attract.nw,attract.nw)
	attract_black.set_bg_rgb(0,0,0)
	attract_black.bg_alpha = 0

	//attract_text_surface = fe.add_surface (attract.w,attract.w)
	//attract_text_surface.set_pos(attract.x,attract.y)

	if (prf.SPLASHON) {
		attract_text = fe.add_text(attract.msg,attract.x,attract.y-attract_surface.y+fl.h-140*scalerate,attract_surface.width,140*scalerate)
	}
	else {
		attract_text = fe.add_text(attract.msg,attract.x,attract.y,attract.w,attract.w)
	}

	attract_text.char_size = 72 * scalerate
	attract_text.font = uifonts.gui
	attract_text.set_rgb (0,0,0)
	attract_text.alpha = attract.textshadow

	attract_text2 = fe.add_text(attract.msg,attract_text.x,attract_text.y-10*scalerate,attract_text.width,attract_text.height)
	
	attract_text2.char_size = 70*scalerate
	attract_text2.font = uifonts.gui
	attract_text2.set_rgb(255,255,255)

	attract_fade = attract_surface.add_image("abg.jpg",0,0,attract.nw,attract.nw)
	attract_fade.alpha = 80
	attract_fade.blend_mode = BlendMode.Add

	attract_vignette = attract_surface.add_image("vignette.png",0,0,attract.nw,attract.nw)
	// attract_vignette.alpha = 80


	//attract_snap.shader = shader_2_lottes
	attract_snap.shader = noshader

	//fg_surface.visible = false

	shader_2_lottes.set_param("aperature_type", 0.0); 	// 0.0 = none, 1.0 = TV style, 2.0 = Aperture grille, 3.0 = VGA
	shader_2_lottes.set_param("hardScan", -16.0);		// Hardness of Scanline 0.0 = none -8.0 = soft -16.0 = medium 
	shader_2_lottes.set_param("hardPix", -2.0);			// Hardness of pixels in scanline -2.0 = soft, -4.0 = hard
	shader_2_lottes.set_param("maskDark",0.65);			// Sets how dark a "dark subpixel" is in the aperture pattern.
	shader_2_lottes.set_param("maskLight", 1.35);		// Sets how dark a "bright subpixel" is in the aperture pattern
	shader_2_lottes.set_param("saturation", 1.0);		// 1.0 is normal saturation. Increase as needed.
	shader_2_lottes.set_param("tint", 0.0);				// 0.0 is 0.0 degrees of Tint. Adjust as needed.
	shader_2_lottes.set_param("blackClip", 0.3);			// Drops the final color value by this amount if GAMMA_CONTRAST_BOOST is defined
	shader_2_lottes.set_param("brightMult", 2.0);		// Multiplies the color values by this amount if GAMMA_CONTRAST_BOOST is defined
	shader_2_lottes.set_param("distortion", 0.2);		// 0.0 to 0.2 seems right
	shader_2_lottes.set_param("cornersize", 0.05);		// 0.0 to 0.1
	shader_2_lottes.set_param("cornersmooth", 60);		// Reduce jagginess of corners
	shader_2_lottes.set_param("vignettebase", 0.0,1.0,3.0);

}

if (prf.AMENABLE){
	if (prf.AMSTART) {
		attract_surface.alpha = 255
		attract_text.alpha = attract.textshadow
		attract_text2.alpha = 255
		attract.start = true
	}
	else {
		attract_snap.file_name = "transparent.png"
		attract_snap.shader = noshader
		attract_surface.visible = false
		attract_text.visible = attract_text2.visible = false
		attract_surface.alpha = 0
		attract_text.alpha = attract_text2.alpha = 0
		if(prf.AMTUNE != "") {
			snd.attracttune.playing = false
			if (prf.BACKGROUNDTUNE != "") snd.bgtune.playing = true
		}
		else if ((prf.BACKGROUNDTUNE != "") && (prf.NOBGONATTRACT)) snd.bgtune.playing = true
		attract.start = false
		attract.timer = fe.layout.time
		attract.starttimer = true
	}
}


/// Splash Screen ///

//local aflogo_surface = fe.add_surface(fl.w,fl.h)

// adds logo image to the logo surface
local aflogo = fe.add_image (prf.SPLASHLOGOFILE,0,0,fl.w,fl.h)
aflogo.visible = false

local aflogoT = {
	w = fl.w,
	h = fl.h,
	x = 0,
	y = 0,
	ar = aflogo.texture_width*1.0 / aflogo.texture_height
}

if (aflogoT.ar >= fl.w/(fl.h*1.0)){
	aflogoT.w = fl.w
	aflogoT.h = aflogoT.w / aflogoT.ar*1.0
	aflogoT.y = - (aflogoT.h - fl.h)*0.5
	aflogoT.x = 0
}
else {
	aflogoT.h = fl.h
	aflogoT.w = aflogoT.h * aflogoT.ar
	aflogoT.y = 0
	aflogoT.x = - (aflogoT.w - fl.w)*0.5
}

local aflogo_surface = fe.add_image (prf.SPLASHLOGOFILE,aflogoT.x,aflogoT.y,aflogoT.w,aflogoT.h)

if (!prf.SPLASHON) aflogo_surface.visible = false


/// Blanker for custom resolution ///

local blanker = {
	bl1 = null
	bl2 = null
}

if ((prf.CUSTOMSIZE != "") && (AR.display != AR.layout)){

	if (AR.display > AR.layout){
		blanker.bl1 = fe.add_image("black.png",-5+(fl.h/frostpic.h)*frost_picT.x,0,5-(fl.h/frostpic.h)*frost_picT.x,fl.h)
		blanker.bl2 = fe.add_image("black.png",fl.w,0,5-(fl.h/frostpic.h)*frost_picT.x,fl.h)
	}
	else{
		blanker.bl1 = fe.add_image("black.png",0,(fl.w/frostpic.w)*frost_picT.y,fl.w,-(fl.w/frostpic.w)*frost_picT.y)
		blanker.bl2 = fe.add_image("black.png",0,fl.h,fl.w,-(fl.w/frostpic.w)*frost_picT.y)
	}


}

/// Layout fade from black ///

local layoutblacker = fe.add_image("black.png",0,0,fl.w,fl.h)

flowT.blacker = [1.0,1.0,1.0,-0.09,1.0]

/// BGM Start ///

if(prf.BACKGROUNDTUNE != "") snd.bgtune.playing = true


/// FPS MONITOR ///

local fps = {
	monitor = null
	monitor2 = null
	x0 = null
	tick000 = null
	tickinterval = 10
}


if (prf.FPSON){
fps.monitor = fe.add_text ("",fe.layout.width*0.5-75*scalerate,0,150*scalerate,80*scalerate)
//fps.monitor = fe.add_text ("",0,0,fl.w,120)

fps.monitor.set_bg_rgb (50,50,50)
fps.monitor.bg_alpha = 200
fps.monitor.set_rgb (255,255,255)
fps.monitor.char_size = 50*scalerate
fps.monitor.zorder = 20000

fps.monitor2 = fe.add_text ("",0,0,10,10)
fps.monitor2.set_bg_rgb (255,0,0)
fps.monitor2.visible = true

fps.tick000 = 0
fps.x0 = 0

fe.add_ticks_callback(this,"monitortick")
}

function monitortick(tick_time){
//fps.monitor.msg =" var:" + var + "zvar:" + z_var + " offs:" + column.offset + " start:" + column.start + " stop:"+column.stop +" ccval:" +centercorr.val+" ccsh:" +centercorr.shift
	fps.monitor2.x ++
	if (fps.monitor2.x - fps.x0 == fps.tickinterval) {
		fps.monitor.msg = fps.tickinterval*1000/(tick_time - fps.tick000)
		fps.monitor2.y = (fl.h/60)*(60 - fps.tickinterval*1000/(tick_time - fps.tick000))
		fps.tick000 = tick_time
		fps.x0 = fps.monitor2.x
	}
	if (fps.monitor2.x >= fe.layout.width) {
		fps.monitor2.x = 0
		fps.x0 = 0
		fps.tick000=0
	}

}

/// Pre-Transition functions for labels jumps ///

local sortlabels = {}
local sortticks = {}

function resetkey (order){
	sortlabels [order].set_rgb (255,255,255)
	sortlabels [order].set_bg_rgb (0,0,0)
	sortlabels [order].bg_alpha = 255

}


function downkey (order){
	sortlabels [order].set_rgb (255,255,255)
	sortlabels [order].set_bg_rgb (0,0,0)
	sortlabels [order].bg_alpha = 255
}

function upkey (order){
	try{
		sortlabels [order].set_rgb (0,0,0)
		sortlabels [order].set_bg_rgb (255,255,255)
		sortlabels [order].bg_alpha = 255
	}
	catch (err){}
}

local labelorder = []
local labelcounter = {}

function updatebgsnap (index){
	bgs.bgpic_array[bgs.stacksize-1].file_name  = fe.get_art((prf.BOXARTMODE ? (prf.LAYERSNAP ? "snap" : prf.BOXARTSOURCE) : "snap") , offseTable[index],0,Art.ImagesOnly)

	if (prf.BOXARTMODE && (bgs.bgpic_array[bgs.stacksize-1].texture_width == 0 )) {
				//noboxart = true
				bgs.bgpic_array[bgs.stacksize-1].file_name = category_pic (offseTable[index])
				if (bgs.bgpic_array[bgs.stacksize-1].texture_width == 0 ) bgs.bgpic_array[bgs.stacksize-1].file_name = "grey.png"

				//gradzTable[i].smooth = 0
				bgs.bgpic_array[bgs.stacksize-1].shader.set_param("remap",true)
				
				local col1 = categorycolor(offseTable[index],2)
				local col2 = categorycolor(offseTable[index],3)

				bgs.bgpic_array[bgs.stacksize-1].shader.set_param("color1",col1[0],col1[1],col1[2])
				bgs.bgpic_array[bgs.stacksize-1].shader.set_param("color2",col2[0],col2[1],col2[2])

				bgs.bg_box[bgs.stacksize-1] = [true,col1,col2]
	}
	else{
				if (bgs.bgpic_array[bgs.stacksize-1].texture_width == 0 ) bgs.bgpic_array[bgs.stacksize-1].file_name = "snapx"+( (fe.game_info(Info.Title,offseTable[index]).len() % 7))+".png"
				bgs.bgpic_array[bgs.stacksize-1].shader.set_param("remap",false)
				bgs.bg_box[bgs.stacksize-1] = [false,[0,0,0],[0,0,0]]

	}
	
	bgs.bg_lcd[bgs.stacksize-1] = (screentype ( offseTable[index] , 0) != "CRT")
	bgs.bg_mono[bgs.stacksize-1] = screentype ( offseTable[index] , 0)
}

function ishorizgame (tileindex, tile2, var, boxart){
	local horizgame = z_list.gametable[ modwrap (z_list.index + tileindex + var, z_list.size) ].z_rotation

	if ((horizgame == "") || (boxart)){
		horizgame = boxorient(tile2,var)
		return horizgame
	}
	horizgame = ((horizgame == "0") || (horizgame == "180") || (horizgame == "horizontal") || (horizgame == "Horizontal"))
	return horizgame
}

function boxorient (tile, var){
	local orientation = null
	local results = [true, null, false]
	local aspects = [4.0/3.0,1.0,3.0/4.0]
	for (local i = 0 ; i < 3 ; i++) {
		aspects[i] = (aspects[i] - (1.0*tile.texture_width / tile.texture_height))
		if (aspects[i] < 0) aspects[i] = -1.0*aspects[i]
	}
	local minval = 0
	
	if ((aspects[0] < aspects[1]) && (aspects[0] < aspects[2]))
		minval = aspects[0]
	else if ((aspects[1] < aspects[0]) && (aspects[1] < aspects[2]))
		minval = aspects[1]
	else if ((aspects[2] < aspects[0]) && (aspects[2] < aspects[1]))
		minval = aspects[2]

	for (local i = 0 ; i < 3;i++) {
		if (aspects[i] == minval) orientation = results[i]
	}

	return orientation
}

function update_gradient(i,noboxart){
	if (((prf.SNAPGRADIENT) && (!prf.BOXARTMODE)) || ((prf.SNAPGRADIENT) && (prf.BOXARTMODE) && (prf.TITLEONBOX)))
		snapzTable[i].shader.set_param ("enabled",true)
	if ((prf.BOXARTMODE) && (!prf.LOWSPECMODE) && (!prf.TITLEONBOX) )
		snapzTable[i].shader.set_param ("enabled",false)
	if ((loshzTable[i].subimg_width == 0) && (!prf.MISSINGWHEEL )) snapzTable[i].shader.set_param("enabled",false)
		
	txshzTable[i].visible = txt1zTable[i].visible = txt2zTable[i].visible =  (  ((loshzTable[i].subimg_width == 0) && (prf.MISSINGWHEEL) && (!(prf.BOXARTMODE) || (prf.BOXARTMODE && prf.TITLEONBOX)) ))

}

// Function that updates snap position, size and internal crop
function update_snapcrop (i,var,indexoffsetvar,orient){
	local noboxart = false

			if (prf.BOXARTMODE && (gradzTable[i].texture_width == 0 )) {
				noboxart = true
				gradzTable[i].file_name = category_pic (indexoffsetvar)
				if (gradzTable[i].texture_width == 0 ) gradzTable[i].file_name = "grey.png"

				gradzTable[i].smooth = 0
				snapzTable[i].shader.set_param("remap",true)
				gradzTable[i].shader.set_param("remap",true)

				local col1 = categorycolor(indexoffsetvar,2)
				local col2 = categorycolor(indexoffsetvar,3)

				snapzTable[i].shader.set_param("color1",col1[0],col1[1],col1[2])
				snapzTable[i].shader.set_param("color2",col2[0],col2[1],col2[2])
				gradzTable[i].shader.set_param("color1",col1[0],col1[1],col1[2])
				gradzTable[i].shader.set_param("color2",col2[0],col2[1],col2[2])

				txboxTable[i].visible = false
				if (!prf.TITLEONBOX) txboxTable[i].visible = true
			}
			else if (prf.BOXARTMODE) {
				noboxart = false
				gradzTable[i].smooth = 1
				snapzTable[i].shader.set_param("remap",false)
				gradzTable[i].shader.set_param("remap",false)
				txboxTable[i].visible = false
			}
			else {
				if (gradzTable[i].texture_width == 0 ) gradzTable[i].file_name = "snapx"+( (fe.game_info(Info.Title,indexoffsetvar).len() % 7))+".png"
				txboxTable[i].visible = false
			}

	local horizgame = orient
	if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)) {
		// CROPSNAPS IS ENABLED
		snapzTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
		// vid2zTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
		// vidszTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
		
		if ((screentype(offseTable[i] , var) == "CRT" ) && (!prf.DISPLAYMENUON)){
			if (horizgame == true){
				gradzTable[i].subimg_x = snapzTable[i].subimg_x = snapzTable[i].texture_width/8.0
				gradzTable[i].subimg_width = snapzTable[i].subimg_width = snapzTable[i].texture_width*3.0/4.0
				}
			if (horizgame == false){
				gradzTable[i].subimg_y = snapzTable[i].subimg_y = snapzTable[i].texture_height/8.0
				gradzTable[i].subimg_height = snapzTable[i].subimg_height = snapzTable[i].texture_height*3.0/4.0
			}
		}
		else {
			gradzTable[i].subimg_width = gradzTable[i].subimg_height = snapzTable[i].subimg_width = snapzTable[i].subimg_height = min(snapzTable[i].texture_width,snapzTable[i].texture_height)
			gradzTable[i].subimg_y = snapzTable[i].subimg_y = 0.5*(snapzTable[i].texture_height - snapzTable[i].subimg_height)
			gradzTable[i].subimg_x = snapzTable[i].subimg_x = 0.5*(snapzTable[i].texture_width - snapzTable[i].subimg_width)
		}
	}
	else {
		// SNAP IS POSITIONED ACCORDING TO FUZZY ORIENTATION OF GAME OR BOXART
		if (horizgame == true){
			snapzTable[i].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift + height/8.0 ),selectorscale*width,selectorscale*height*3.0/4.0)
		}
		if (horizgame == false){
			snapzTable[i].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift),selectorscale*width*3.0/4.0,selectorscale*height)
		}
		if (horizgame == null){
			snapzTable[i].set_pos (selectorscale*padding*10.0/8.0,selectorscale*(padding*10.0/8.0-verticalshift),selectorscale*width*44.0/48.0,selectorscale*height*44.0/48.0)
		}
		// WHILE TV SYSTEMS ARE STRETCHED TO THE 4:3 or 3:4 AR, HANDHELD OR BOXARTS ARE CROPPED TO THE CLOSEST AR
		if (!(screentype(offseTable[i] , var) == "CRT") || (prf.BOXARTMODE == true)){
			if (horizgame == true){
				if (1.0*snapzTable[i].texture_width / snapzTable[i].texture_height >= 4.0/3.0){
					gradzTable[i].subimg_width = snapzTable[i].subimg_width = snapzTable[i].texture_height * 4.0/3.0
					gradzTable[i].subimg_height = snapzTable[i].subimg_height = snapzTable[i].texture_height
				}
				else {
					gradzTable[i].subimg_width = snapzTable[i].subimg_width = snapzTable[i].texture_width
					gradzTable[i].subimg_height = snapzTable[i].subimg_height = snapzTable[i].texture_width * 3.0/4.0
				}
			}

			if (horizgame == false) {
				if (1.0*snapzTable[i].texture_height / snapzTable[i].texture_width >= 4.0/3.0){
					gradzTable[i].subimg_height = snapzTable[i].subimg_height = snapzTable[i].texture_width*4.0/3.0
					gradzTable[i].subimg_width = snapzTable[i].subimg_width = snapzTable[i].texture_width
				}
				else {
					gradzTable[i].subimg_height = snapzTable[i].subimg_height = snapzTable[i].texture_height
					gradzTable[i].subimg_width = snapzTable[i].subimg_width = snapzTable[i].texture_height * 3.0/4.0
				}
			}

			if (horizgame == null){
				gradzTable[i].subimg_height = gradzTable[i].subimg_width = snapzTable[i].subimg_height = snapzTable[i].subimg_width = min (snapzTable[i].texture_width,snapzTable[i].texture_height)
			}

			gradzTable[i].subimg_y = snapzTable[i].subimg_y = 0.5*(snapzTable[i].texture_height - snapzTable[i].subimg_height)
			gradzTable[i].subimg_x = snapzTable[i].subimg_x = 0.5*(snapzTable[i].texture_width - snapzTable[i].subimg_width)
		}
	}

	// ACTIVATE GREEN LCD SHADER FOR SNAPS
	if ((!prf.BOXARTMODE) && (screenrecolor(offseTable[i] , var))) {
		
		local localcolor = (prf.GBRECOLOR == "AUTO" ? gbrgb[screentype(offseTable[i] , var)] : gbrgb[prf.GBRECOLOR] )

		snapzTable[i].shader.set_param ("remap",prf.GBRECOLOR!="NONE")
		snapzTable[i].shader.set_param("color1",localcolor.a.R,localcolor.a.G,localcolor.a.B)
		snapzTable[i].shader.set_param("color2",localcolor.b.R,localcolor.b.G,localcolor.b.B)
		gradzTable[i].shader.set_param ("remap",prf.GBRECOLOR!="NONE")
		gradzTable[i].shader.set_param("color1",localcolor.a.R,localcolor.a.G,localcolor.a.B)
		gradzTable[i].shader.set_param("color2",localcolor.b.R,localcolor.b.G,localcolor.b.B)
		
		}
	else if ((!prf.BOXARTMODE)) {
		snapzTable[i].shader.set_param ("remap",false)
		gradzTable[i].shader.set_param ("remap",false)
	}
	// ACTIVATE GREEN LCD SHADER FOR VIDEOS
	
	if ( (screenrecolor(offseTable[i] , var ))) {
		local localcolor = prf.GBRECOLOR == "AUTO" ? gbrgb[screentype(offseTable[i] , var)] : gbrgb[prf.GBRECOLOR]
		vidszTable[i].shader.set_param ("remap",prf.GBRECOLOR!="NONE")
		vidszTable[i].shader.set_param("color1",localcolor.a.R,localcolor.a.G,localcolor.a.B)
		vidszTable[i].shader.set_param("color2",localcolor.b.R,localcolor.b.G,localcolor.b.B)

	}
	else {
		vidszTable[i].shader.set_param ("remap",false)
	}

	update_gradient(i,noboxart)
}

function update_borderglow(i,var,orient){

	bd_mxTable[i].visible = true
	glomxTable[i].visible = prf.SNAPGLOW

	if (prf.SNAPGLOW) {
		glomxTable[i].shader = snap_glow[i]
		//snap_glow[i].set_param ("cropsnap",((prf.CROPSNAPS) && (!prf.BOXARTMODE)))
	}

	if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
		glomxTable[i].file_name = "glow_sq3.png"
		bd_mxTable[i].set_pos (selectorscale*padding*10.0/8.0*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(10.0/8.0)*(1.0 - whitemargin)),selectorscale*(width*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin),selectorscale*(height*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin))
		if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
		//if (prf.SNAPGLOW) snap_glow[i].set_param ("cropsnap",true)

	}
	else{
		if (orient == true){
			if (prf.SNAPGLOW) snap_glow[i].set_param ("orient",1.0)
			glomxTable[i].file_name = "glowx5d.png"
			bd_mxTable[i].set_pos (selectorscale*padding*(1.0-whitemargin),selectorscale*(-verticalshift + height/8.0 + padding*(1.0 - whitemargin)),selectorscale*(width + padding*2.0*whitemargin),selectorscale*(height*(3.0/4.0)+padding*2.0*whitemargin))
			if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
			//if (prf.SNAPGLOW) snap_glow[i].set_param ("cropsnap",false)
		}

		else if (orient == false){
			if (prf.SNAPGLOW) snap_glow[i].set_param ("orient",-1.0)
			glomxTable[i].file_name = "glowx5d.png"
			bd_mxTable[i].set_pos (selectorscale*(width/8.0 + padding*(1.0 - whitemargin)), selectorscale*(-verticalshift + padding*(1.0 - whitemargin)),selectorscale*(width*(3.0/4.0)+padding*2.0*whitemargin),selectorscale*(height + padding*2.0*whitemargin))
			if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
			//if (prf.SNAPGLOW) snap_glow[i].set_param ("cropsnap",false)
		}
		else {
			if (prf.SNAPGLOW) snap_glow[i].set_param ("orient",0.0)
			glomxTable[i].file_name = "glow_sq3.png"
			bd_mxTable[i].set_pos (selectorscale*padding*10.0/8.0*(1.0-whitemargin),selectorscale*(-verticalshift + padding*(10.0/8.0)*(1.0 - whitemargin)),selectorscale*(width*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin),selectorscale*(height*44.0/48.0 + padding*10.0/8.0*2.0*whitemargin))
			if (prf.SNAPGLOW) glomxTable[i].set_pos(0,-selectorscale*verticalshift)
			//if (prf.SNAPGLOW) snap_glow[i].set_param ("cropsnap",true)
		}
	}
}

function update_thumbdecor(i,var,orient){

	local z_list_target = modwrap(z_list.index + offseTable[i] + var,z_list.size)
	local fe_list_target = z_list.gametable[ z_list_target ].z_felistindex

	z_list.gametable[ z_list_target ].z_tags = fe.game_info(Info.Tags, fe_list_target - fe.list.index)
	z_list.gametable[ z_list_target ].z_favourite = fe.game_info(Info.Favourite, fe_list_target - fe.list.index)
	z_list.gametable[ z_list_target ].z_playedcount = fe.game_info(Info.PlayedCount, fe_list_target - fe.list.index)

	donezTable[i].visible = ((z_list.gametable [ z_list_target ].z_tags).tolower().find("completed") != null)

	favezTable[i].visible = (z_list.gametable[ z_list_target ].z_favourite == "1")
	
	logozTable[i].visible = loshzTable[i].visible = (!(prf.BOXARTMODE) || (prf.BOXARTMODE && prf.TITLEONBOX))
	//nw_mxTable[i].visible = (fe.game_info(Info.PlayedCount, offseTable[i]+var) == "0")
	nw_mxTable[i].visible = (z_list.gametable[ z_list_target ].z_playedcount == "0")

	//Check if only one tag is present and this tag is "Completed"
	local tagcheckerlist = z_list.gametable [ z_list_target ].z_tags
	tagcheckerlist = split (tagcheckerlist,";")
	if ((tagcheckerlist.len() == 1) && (tagcheckerlist[0].tolower() == "completed")) {
		tg_mxTable[i].visible = false
	}
	else tg_mxTable[i].visible = ((z_list.gametable [ z_list_target ].z_tags).tolower().find(prf.TAGNAME.tolower()) != null)
	
	
	if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
		sh_hzTable[i].visible = false
		sh_vzTable[i].visible = false
		sh_sqTable[i].visible = true
		nw_mxTable[i].set_pos(selectorscale*padding*10.0/8.0,selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.0/8.0)),width*selectorscale*(44.0/48.0)/8.0,height*selectorscale*(44.0/48.0)/8.0)
		tg_mxTable[i].set_pos(selectorscale*(padding*10.0/8.0+width*(7.0/8.0)*(44.0/48.0)),selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.2/8.0)))
	}
	else {
		if (orient == true){
			sh_hzTable[i].visible = true
			sh_vzTable[i].visible = false
			sh_sqTable[i].visible = false
			nw_mxTable[i].set_pos (selectorscale*padding,selectorscale*(padding-verticalshift+height*6.0/8.0))
			tg_mxTable[i].set_pos (selectorscale*(padding + width*7.0/8.0),selectorscale*(padding-verticalshift+height*6.2/8.0))

		}
		if (orient == false){
			sh_hzTable[i].visible = false
			sh_vzTable[i].visible = true
			sh_sqTable[i].visible = false
			nw_mxTable[i].set_pos (selectorscale*(padding+width/8.0),selectorscale*(padding-verticalshift+height*7.0/8.0))
			tg_mxTable[i].set_pos (selectorscale*(padding+width*6.0/8.0),selectorscale*(padding-verticalshift+height*7.2/8.0))
		}
		if (orient == null){
			sh_hzTable[i].visible = false
			sh_vzTable[i].visible = false
			sh_sqTable[i].visible = true
			nw_mxTable[i].set_pos(selectorscale*padding*10.0/8.0,selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.0/8.0)),width*selectorscale*(44.0/48.0)/8.0,height*selectorscale*(44.0/48.0)/8.0)
			tg_mxTable[i].set_pos(selectorscale*(padding*10.0/8.0+width*(7.0/8.0)*(44.0/48.0)),selectorscale*(-verticalshift + padding*10.0/8.0+height*(44.0/48.0)*(7.2/8.0)))
		}
	}
}



function switchmode(){
	prf.BOXARTMODE = !prf.BOXARTMODE

	z_listrefreshtiles()
	updatebgsnap (newfocusindex)

	DISPLAYTABLE [fe.displays[fe.list.display_index].name] <- (prf.BOXARTMODE ? ["BOXES"] : ["SNAPS"])
	//	try{fe.nv["AF_Display_Type"] <- DISPLAYTABLE} catch (err) {}
	savetabletofile(DISPLAYTABLE,"pref_thumbtype.txt")
}

function utilitymenu(){
	if (prf.FROSTEDGLASS){
		if (frg.immediatesignal){
		frg.immediatesignal = false
		}
		else{
		getsnap(prf.UTILITYMENUBUTTON)
		return true
		}
	}

	local switcharray1 = [
		"  "+ltxt("Sort by",TLNG)+"...",
		ltxt("Filters",TLNG),
		ltxt("Displays",TLNG),
		"  "+ltxt("Search for",TLNG)+"...",
		ltxt("Layout options",TLNG),
		ltxt("Attract mode",TLNG),
		(prf.BOXARTMODE ? (ltxt("Snaps tiles",TLNG)) : (ltxt("Box-Art tiles",TLNG))),
		ltxt("Reset Box Art",TLNG)
	]
	//local result1 = fe.overlay.list_dialog(switcharray1,"\t☰" + ltxt("\t Utility Menu   \t",TLNG) + "\t")
	local result1 = glyph_list_dialog (switcharray1, [0xea4c,0xea5b,0xe912,0xe986,0xe991,0xe9a5,(prf.BOXARTMODE ? 0xe917 : 0xe918),0xe965],(ltxt("Utility Menu",TLNG) ),0xe9bd,0)
	
	local ll = 0

	if (result1 == ll){

		local switcharray_sort = [
			""+ ltxt("Title",TLNG) + " ▲",
			""+ ltxt("Title",TLNG) + " ▼",
			""+ ltxt("Manufacturer",TLNG) + " ▲",
			""+ ltxt("Manufacturer",TLNG) + " ▼",
			""+ ltxt("Year",TLNG) + " ▲",
			""+ ltxt("Year",TLNG) + " ▼",
			""+ ltxt("Category",TLNG) + " ▲",
			""+ ltxt("Category",TLNG) + " ▼",
			""+ ltxt("System",TLNG) + " ▲",
			""+ ltxt("System",TLNG) + " ▼",
		]

		local glypharray_sort = []

		glypharray_sort.push (((z_list.orderby == Info.Title) && (z_list.reverse == false)) ? 0xea10 : 0) 
		glypharray_sort.push (((z_list.orderby == Info.Title) && (z_list.reverse == true)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Manufacturer) && (z_list.reverse == false)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Manufacturer) && (z_list.reverse == true)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Year) && (z_list.reverse == false)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Year) && (z_list.reverse == true)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Category) && (z_list.reverse == false)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.Category) && (z_list.reverse == true)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.System) && (z_list.reverse == false)) ? 0xea10 : 0)  
		glypharray_sort.push (((z_list.orderby == Info.System) && (z_list.reverse == true)) ? 0xea10 : 0)  

		local nowsort = 0
		for (local i = 0 ; i < glypharray_sort.len() ; i++) {
			if (glypharray_sort[i] != 0) nowsort = i
		}

		local result_sort = [ glyph_list_dialog(switcharray_sort,glypharray_sort,"  " + ltxt("Sort by",TLNG)+"...",0xea4c,nowsort) , false]

		if 	  (result_sort[0] == 0) result_sort = [Info.Title,false]
		else if (result_sort[0] == 1) result_sort = [Info.Title,true]
		else if (result_sort[0] == 2) result_sort = [Info.Manufacturer,false]
		else if (result_sort[0] == 3) result_sort = [Info.Manufacturer,true]
		else if (result_sort[0] == 4) result_sort = [Info.Year,false]
		else if (result_sort[0] == 5) result_sort = [Info.Year,true]
		else if (result_sort[0] == 6) result_sort = [Info.Category,false]
		else if (result_sort[0] == 7) result_sort = [Info.Category,true]
		else if (result_sort[0] == 8) result_sort = [Info.System,false]
		else if (result_sort[0] == 9) result_sort = [Info.System,true]

		if (result_sort[0] != -1 ){
			z_listsort(result_sort[0],result_sort[1])
			z_liststupdateindex()
			z_liststops()
			z_listrefreshlabels()
			z_listrefreshtiles()
			//if (DEBUG) z_listprint (z_list.gametable)
			//if (DEBUG) z_stopprint (z_list.jumptable)
		}
	}

	ll++
	if (result1 == ll){
		frg.immediatesignal = true
		fe.signal("filters_menu")
	}

	ll++
	if (result1 == ll){
		frg.immediatesignal = true
		fe.signal("displays_menu")
	}

	ll++
	if (result1 == ll){

		search.text = ""
		search.string = ""

		local switcharray2 = [
			ltxt("Title",TLNG),
			ltxt("Manufacturer",TLNG),
			ltxt("Year",TLNG),
			ltxt("Category",TLNG),
			ltxt("RESET (KEEP FOCUS)",TLNG)
			ltxt("RESET",TLNG)
		]
		local switchsearchval = ["Title","Manufacturer","Year","Category"]
		
		local result =glyph_list_dialog(switcharray2,null, "  "+ltxt("Search for",TLNG)+"...",0xe986,0)
		
		if(result==4){
			//fe.list.index += corrector + rows
			
			local currentname = z_list.gametable[z_list.index].z_name
			local currentsystem = z_list.gametable[z_list.index].z_system

			fe.list.search_rule =""
			searchdata.msg = ""
			/*
			if (backs.index != -1){
				fe.list.index = backs.index
				//corrector = backs.corrector
				backs.index = -1
			}
			*/
			for (local i = 0 ; i < fe.list.size -1;i++){
				if(( z_list.gametable[i].z_name == currentname) && (z_list.gametable[i].z_system == currentsystem) ) {
					z_list_indexchange (i)
					break
				}
			}
			//return
		}

		if(result==5){
			//fe.list.index += corrector + rows
			fe.list.search_rule =""
			searchdata.msg = ""

			if (backs.index != -1){
				fe.list.index = backs.index
				//corrector = backs.corrector
				backs.index = -1
			}
			
			//return
		}

		if ((result != 4) && (result != 5) && (result !=-1)){
			if (backs.index == -1){
				backs.index = fe.list.index
				//backs.corrector = corrector
			}
			if (prf.KEYBOARD) 
				search.text = fe.overlay.edit_dialog(ltxt("Search ",TLNG)+switcharray2[result]+": ",search.text)
			else
				search_base_rule = switchsearchval[result]
			
			
			if (prf.KEYBOARD) {
				if((search.text == "")){ //TEST66
					searchdata.msg = ""
					search.string = ""
					fe.list.search_rule = ""
					if (backs.index != -1){
						fe.list.index = backs.index
						//corrector = backs.corrector
						backs.index = -1
					}
				}
				else {
					search.string = ltxt(switchsearchval[result],TLNG) + ":" + search.text
					searchdata.msg = search.string
					fe.list.search_rule = switchsearchval[result] + " contains "+ recalculate(search.text)
					corrector = (rows == 1 ? -1 : 0)
				}
			}
			else {
				search_toggle()
			}
			
			return true
			
		}
		return true
	}

	ll++
	if (result1 == ll){
		frg.immediatesignal = true
		fe.signal("layout_options")
	}

	ll++
	if ((result1 == ll) && (prf.AMENABLE)){
		attractkick()
	}

	ll++
	if (result1 == ll){
		switchmode()
		if(prf.THEMEAUDIO) snd.wooshsound.playing = true	
	}

	ll++
	if (result1 == ll){
		DISPLAYTABLE = {}
		//try{fe.nv["AF_Display_Type"] <- DISPLAYTABLE} catch (err) {}
		savetabletofile (DISPLAYTABLE,"pref_thumbtype.txt")
		fe.signal("reload")
		if(prf.THEMEAUDIO) snd.wooshsound.playing = true
	}

}

function z_listrefreshtiles(){
	local logotitle = null
	local boxtitle = null

	scroller.x = footermargin + ((z_list.index/rows)*rows*1.0/(fe.list.size - 1 ))*(fl.w - 2.0*footermargin-scrollersize)
	scroller2.x = scroller.x-scrollersize*0.5

	// Reset vars and positions
	debugpr ("TRANSBLOCK 1 - TNL - RESET VAR centercorr.val ETC \n")
	var = 0
	tilesTablePos.Offset = 0
	surfacePos = 0.5
	column.offset = 0
	centercorr.val = 0
	centercorr.shift = centercorr.zero

	// loop for all tiles
	for ( local i = 0; i < tiles.total ; i++ ) {
		// reset gradient data
		//print("C")
		//update_gradient(i)

		// reset video fade data
		if (prf.THUMBVIDEO) {
			vidszTable[i].alpha = 0
			vid2zTable[i].alpha = 0
			vidpos[i] = 0
			vidszTableFade[i]=[0.0,0.0,0.0,0.0,0.0]
			vidszTable[i].file_name = "transparent.png"
		}

		// cleanup position of tiles
		picsize (tilesTable[i] , widthpadded, heightpadded,0,-0.025)
		tilesTable[i].zorder = -2
		tilesTableZoom[i] = [0.0,0.0,0.0,0.0,0.0]
		bd_mxTable[i].alpha = 0
		glomxTable[i].alpha = 0
	}

	corrector = (rows == 1 ? -1 : -((z_list.index + var) % rows) )

	column.stop = floor((z_list.index + var )*1.0/rows)
	column.start = floor((z_list.index )*1.0/rows)

	column.offset = (column.stop - column.start)
	tilesTablePos.Offset += column.offset*rows

	local index = - (floor(tiles.total/2) -1) + corrector

	// Determine center position correction when reaching beginning or end of list
	centercorr.shift = 0
	centercorr.val = 0

	if ((column.stop < deltacol) && (var < 0) ) {
		if (column.stop == deltacol - 1 )
			centercorr.shift = centercorr.zero + (deltacol - 1)*(width+padding)
		else
			centercorr.shift = - (width+padding)
	}
	else if ((column.start < deltacol) && (var > 0)) {
		if (column.start == deltacol - 1 )
			centercorr.shift = - centercorr.zero - (deltacol - 1)* (width+padding)
		else
			centercorr.shift = (width+padding)
	}

	if (z_list.index + var <= deltacol * rows -1){
		centercorr.val = centercorr.zero + floor(((z_list.index + var)/rows))*(width+padding)
	}
	
	if (column.offset == 0) centercorr.shift = 0

	// updates all the tiles

	for ( local i = 0; i < tiles.total ; i++ ) {

		local indexTemp = wrap( i + tilesTablePos.Offset, tiles.total )

		offseTable[indexTemp] = index

		local indexoffset = (z_list.gametable[modwrap(z_list.index + index,z_list.size)].z_felistindex) - fe.list.index
		local indexoffsetvar = (z_list.gametable[modwrap(z_list.index + index + var ,z_list.size)].z_felistindex) - fe.list.index


			loshzTable[indexTemp].file_name = fe.get_art("wheel" , indexoffsetvar,0,Art.ImagesOnly)
			gradzTable[indexTemp].file_name = fe.get_art((prf.BOXARTMODE ? prf.BOXARTSOURCE : "snap") , indexoffsetvar,0,Art.ImagesOnly)



			logotitle = wrapme( fe.game_info (Info.Title, indexoffsetvar) ,9,3)
			txt2zTable[indexTemp].msg = txt1zTable[indexTemp].msg = txshzTable[indexTemp].msg = logotitle.text

			txshzTable[indexTemp].char_size = min( ((txshzTable[indexTemp].width*100.0/600.0)*9)/logotitle.cols , ((txshzTable[indexTemp].width*100.0/600.0)*3)/logotitle.rows )
			txt2zTable[indexTemp].char_size = txt1zTable[indexTemp].char_size = txshzTable[indexTemp].char_size * txt1zTable[indexTemp].width / txshzTable[indexTemp].width

			txt2zTable[indexTemp].x = txt1zTable[indexTemp].x + 0.015 * txt1zTable[indexTemp].char_size
			txt2zTable[indexTemp].y = txt1zTable[indexTemp].y - 0.025 * txt1zTable[indexTemp].char_size

			boxtitle = wrapme( fe.game_info (Info.Title, indexoffsetvar) ,6,4)
			txboxTable[indexTemp].msg = boxtitle.text

			txboxTable[indexTemp].char_size = min( ((txboxTable[indexTemp].width*100.0/400.0)*6)/boxtitle.cols , ((txboxTable[indexTemp].width*100.0/400.0)*4)/boxtitle.rows )

			update_snapcrop (indexTemp , var, indexoffsetvar, ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE))
		

			local horizgame = ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE)
			// Update visibility of horizontal or vertical shadows, glow, indicator etc
			update_thumbdecor(indexTemp,var,horizgame)
			if (bd_mxTable[indexTemp].alpha != 0) update_borderglow(indexTemp,var,horizgame)
		
		tilesTable[indexTemp].zorder = -2


		tilesTablePos.X[indexTemp] = (i/rows) * (width+padding) + carrierT.x + centercorr.val + widthpadded*0.5
		tilesTablePos.Y[indexTemp] = (i%rows) * (height + padding) + carrierT.y + verticalshift + widthpadded*0.5

		tilesTable[indexTemp].visible = (( (z_list.index + var + index < 0) || (z_list.index + var + index > fe.list.size-1) ) == false)

		index++
	}
	
	// updates the size and features of the previously selected item and new selected item
	newfocusindex = wrap( floor(tiles.total/2)-1-corrector + tilesTablePos.Offset, tiles.total )
	oldfocusindex = wrap( floor(tiles.total/2)-1-corrector -var + tilesTablePos.Offset, tiles.total )

	tilesTableZoom[oldfocusindex] = startfade (tilesTableZoom[oldfocusindex],-0.055,1.0)
	tilesTableZoom[newfocusindex] = startfade (tilesTableZoom[newfocusindex],0.035,-5.0)

	//activate video load counter
	if ((prf.THUMBVIDEO) ){
		vidszTableFade[oldfocusindex] = startfade (vidszTableFade[oldfocusindex],-0.01,1.0)
		vidpos[oldfocusindex] = 0

		if (vidszTable[newfocusindex].alpha == 0) {
			vidpos[newfocusindex] = vidstarter
			vidindex[newfocusindex] = offseTable[newfocusindex]
		}
		else {
			vidszTableFade[newfocusindex] = startfade (vidszTableFade[newfocusindex],0.03,1.0)
		}
	}
	tilesTable[oldfocusindex].zorder = -2
	tilesTable[newfocusindex].zorder = -1
	letterobj.zorder = 0

	local horizgame = ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],var,prf.BOXARTMODE)

	// Update decorations related to newly focused index image
	update_borderglow(newfocusindex,0,horizgame)


	// trigger squaring of background thumbs
	squarizer = true
}

function z_listrefreshlabels(){
	// Clean old ticks and labels
	//filterdata.msg = (prf.CLEANLAYOUT ? "" : (prf.DISPLAYMENUON ? "DISPLAYS": "[FilterName]\n[!gamelistorder]"))
	filterdata.msg = (prf.CLEANLAYOUT ? "" : (prf.DISPLAYMENUON ? "DISPLAYS": ( (fe.filters.len() == 0) ? "" : fe.filters[fe.list.filter_index].name+ "\n")  + gamelistorder(0)))


	try {
		foreach (label in sortlabels){
			label.visible = false
		}
		foreach (tick in sortticks){
			tick.visible = false
		}
	}
	catch (err){}
	
	// Reinitialize tables
	labelorder = []
	labelcounter = {}
	sortlabels = {}
	sortticks = {}

	// Count how many games are in each label
	for (local i = 0 ; i < z_list.size ; i++){
		local s = (z_list.jumptable[i].key)
		try { labelcounter[s]++ }
		catch (err) {
			labelcounter[s] <- 1
			labelorder.push (s)
		}
	}

	local i = 0
	local w0 = fl.w - 2 * footermargin
	local x0 = footermargin
	local x00 = 0
	local label = {
		w = 100*scalerate,
		h = 40 * scalerate,
		font = 30 * scalerate
	}
	
	local label_obj = null

	if (prf.SCROLLERTYPE == "labellist"){

		w0 = (fl.w-2*footermargin)*1.0 
		x0 = (fl.w-w0) * 0.5
		x00 = 0
		label = {
			w = 100 * scalerate,
			h = 40 * scalerate,
			font = 30 * scalerate
		}

		if (prf.LOWRES){
			label = {
				w = 150 * scalerate,
				h = 70 * scalerate,
				font = 45 * scalerate
			}
		}

		labelstrip.set_pos (x0,fl.h-footer.h*0.5-label.h*0.5,w0,label.h)
		labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
		labelstrip.alpha = 100
		//labelstrip.visible = false

		//labelsurf.set_pos (0,0,w0,label.h)
		labelsurf.add_image("black.png",0,0,w0,label.h)
		foreach (key in labelorder){
			label_obj = labelsurf.add_text( ((z_list.orderby == Info.Category ? categorylabel(key,0) : (z_list.orderby == Info.System ? systemlabel(key) : key) )).toupper() ,x00,0,w0/labelorder.len(),label.h)
			label_obj.char_size = label.font
			label_obj.font = uifonts.gui
			label_obj.margin = 0
			label_obj.align = Align.MiddleCentre
			label_obj.set_rgb (255,255,255)
			label_obj.set_bg_rgb (0,0,0)
			label_obj.bg_alpha = 255
			label_obj.alpha = 255
			x00 = x00 + w0/labelorder.len()
			sortlabels[key] <- label_obj
			resetkey (key)
		}
		labelsurf.set_rgb(themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
		labelsurf.shader = txtoalpha

		local labelsurf0 = data_surface.add_clone (labelsurf)
		labelsurf0.set_pos(x0,fl.h-footer.h*0.5-label.h*0.5)
		labelsurf.visible = false
	if ((prf.SCROLLERTYPE == "labellist") && (fe.list.size !=0 ) ) upkey (z_list.jumptable[z_list.index].key)
	}

	if (prf.SCROLLERTYPE == "timeline"){
		labelstrip.set_pos(x0,fl.h - footer.h * 0.5,w0,label.h)
		labelstrip.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
		labelstrip.alpha = 100
		//labelstrip.visible = false
		foreach (key in labelorder){
			i=1 // REMOVE FOR ALTERNATING LETTERS
			local labelspacer = labelcounter[key]*w0/fe.list.size
			label_obj = data_surface.add_text(((z_list.orderby == Info.Category ? categorylabel (key,0) : (z_list.orderby == Info.System ? systemlabel(key) : key))).toupper(),x0 + labelspacer*0.5 - label.w*0.5, fl.h - footer.h * 0.5 , label.w,label.h)
			local tick_obj = data_surface.add_image("white.png",x0,fl.h - footer.h * 0.5 - 0.5*label.h*0.5,1,0.5*label.h+1)
			label_obj.char_size = label.font
			label_obj.font = uifonts.lite
			label_obj.margin = 0
			label_obj.align = Align.MiddleCentre
			label_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
			tick_obj.set_rgb (themeT.themetextcolor,themeT.themetextcolor,themeT.themetextcolor)
			i++
			label_obj.visible = !( (labelspacer < 0.5*label.h) || ((search.string != "") && (abs(label_obj.x+label_obj.width*0.5-fl.w*0.5) < searchdata.msg_width)))
			x0 = x0 + labelspacer
			sortlabels[key] <- label_obj
			sortticks[key] <- tick_obj
		}

		if (labelorder.len() != 0) sortticks[labelorder[0]].visible = false
	}
}


function repeatsignal (sig,counter){
	if (fe.get_input_state(sig)==false) {
		count.countstep = 0
		count.movestep = count.movestepslow
		return (0)
	}
	else {
		fe.signal(sig)
		counter ++
		if (counter - count.movestart == count.movestep + 1) {
			counter = count.movestart
			count.countstep ++
			count.movestep = round(count.movestepfast + (count.movestepslow-count.movestepfast)*pow(2.7182,-count.countstep/count.movestepdelay) , 1)
			//print (count.countstep + " " + count.movestep+"\n")
		}
		return counter
	}
}

function checkrepeat(counter){
	return ((counter == 0) || (counter == count.movestart))
}

fe.add_signal_handler( this, "on_signal" )
fe.add_transition_callback( this, "on_transition" )
fe.add_ticks_callback( this, "tick" )


/// On Transition ///


function on_transition( ttype, var0, ttime ) {

	//DEBUG transition
	debugpr ("\nTr:" + transdata[ttype] +" var0:" + var0 + "\n")

	if ((ttype == Transition.ToNewList) && (prf.JUMPDISPLAYS)) return false

	if (ttype == Transition.FromGame) {
		flowT.data = startfade (flowT.data,0.06,3.0)
		flowT.fg = startfade (flowT.fg,-0.06,3.0)		
	}

	if ((ttype == Transition.ShowOverlay) && (prf.THEMEAUDIO) ) snd.wooshsound.playing = true

	// ENABLE ZMENU FOR EXIT FROM DISPLAY MENU SUBMENU
	if ((ttype == Transition.ShowOverlay) && (!prfmenu.showing) ) {
		if (prf.ENHANCEDMENU) prf.ZMENUON = true
	}

	// RESET LISTBOX HEIGHT WHEN NO OPTIONS MENU IS SHOWN
	if ((ttype == Transition.ShowOverlay) && (!prfmenu.showing)) {
		overlay_listbox.height = overlay.fullheight
	}
	
  if ((ttype == Transition.NewSelOverlay) && (prfmenu.showing) ){
      //refresher = 1
      //print ("X\n")     
      updatemenu(prfmenu.level,var0)
      prfmenu.description.msg =  (prfmenu.level == 1 ? prefs.l0[var0].description : (prefs.l1[prfmenu.outres0][(prfmenu.level == 2 ? var0 : prfmenu.outres1)].help))
      //prfmenu.description.msg = 100*rand()/RAND_MAX
   }

  if ((ttype == Transition.NewSelOverlay) && (prfmenu.browsershowing) ){
	  prfmenu.helppic.file_name = prfmenu.browserdir[var0]
   }

   if (ttype == Transition.NewSelOverlay) {
		refreshglyphs(var0)
   }

	if (prf.LAYERVIDELAY) {
		 if (((ttype == Transition.ToNewSelection) || (ttype == Transition.ToNewList) ) && (prf.LAYERVIDEO)) {

		//background video delay load
			vidposbg = vidstarter
			bgs.bgvid_array[bgs.stacksize - 1].alpha = 0
			vidbgfade=[0.0,0.0,0.0,0.0,0.0]	
			bgs.bgvid_array[bgs.stacksize - 1].file_name ="transparent.png"
		 }
	}

	if (ttype == Transition.StartLayout){
		z_listcreate ()
		z_list.layoutstart = true
	}
	
	// sort list at new list or layout start 
	// TEST65 but not if we are adding favorites

	if (ttype == Transition.ToNewList) {
		if (favcheck.changed) {
			favcheck.listchange = ((favcheck.oldsize - fe.list.size) )
		}
		else favcheck.listchange = 0
	}

	if ( ((ttype == Transition.ToNewList) && (!favcheck.changed)) || ((ttype == Transition.ToNewList) && (favcheck.changed) && (favcheck.listchange != 0)) ){
		favcheck.changed = false
		if (!z_list.layoutstart) z_listcreate ()
		z_list_startorder()
		z_list.layoutstart = false
		if (!prf.DISPLAYMENUON) z_listsort(z_list.orderby,z_list.reverse)
		z_liststupdateindex()
		z_liststops()
		//if (DEBUG) z_listprint(z_list.gametable)
		//if (DEBUG) z_stopprint(z_list.jumptable)
	}

	if ((ttype == Transition.ToNewSelection) && (z_var != 0)) {
		// when transitioning to a new selection don't change the z_list.index immediately but use z_var as var
		debugpr ("TR:TNS zli:"+z_list.index+" zvar:"+z_var+" var:"+var+" var0:"+var0+"\n")
		var = z_var
	}

	if ((ttype == Transition.FromOldSelection) && (z_var != 0)) {
		// when transitioning from old selection apply the change to z_list.index
		z_list.index = modwrap ( (z_list.newindex) , z_list.size)
		debugpr ("TR:FOS zli:"+z_list.index+" zvar:"+z_var+" var:"+var+" var0:"+var0+"\n")
		var = -z_var

	}


	if ((tags.decortr == true) && (ttype == Transition.ToNewSelection)){
		update_thumbdecor (newfocusindex,0,ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],0,prf.BOXARTMODE))
		tags.decortr = false
	}

	local logotitle = null
	local boxtitle = null

	// PREVENT ATTRACT MODE ENGAGE WHEN RETURNING FROM GAME
	if (ttype == Transition.FromGame){
		attract.timer = fe.layout.time
	}

	
	// TEST71
	// MANAGE DISPLAYS LIST
	
	if (ttype == Transition.ShowOverlay) {
		
		// Update overlay label
		overlay_label.msg = overlay.labelmsg

		if ( (var0 == Overlay.Displays ) && (prf.DMPIMAGES) ) { //TEST70
			showdisp(true)

			zmenu_surface_sh.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.v : noshader)
			zmenu_surface_sh1.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.h : noshader)
			
			zmenu_surface_container.visible = zmenu_surface_sh.visible = true

			prf.DISPLAYLISTON = true
			overlay_listbox.width = overlay.fullwidth + padding - disp.width

			disp.xstop = - disp.dispcode.find(fe.list.display_index) * disp.spacing

			disp.xstart = disp.xstop
			for (local i = 0;i < disp.items.len() ; i++) {
				disp.items[i].y = disp.pos0[i] + disp.xstop
			}
			
		}

	}

	// MANAGE ZMENU LIST
	if ((ttype == Transition.ShowOverlay) && (prf.ZMENUON) ){

		// Update overlay label
		overlay_label.msg = overlay.labelmsg

		// Correct position of title glyph
		overlay_glyph.x = fl.w * 0.5 - overlay_label.msg_width * 0.5 - overlay.labelsize
		//		overlay_glyph.x = zmenu.glyphs[0].x

		local showexitarcadeflow = false

		if (var0 == Overlay.Exit) drawzmenu(ltxtarray(["Yes","No"],TLNG),[0xea10,0xea0f],ltxt("EXIT ARCADEFLOW?",TLNG),0xe9b6,1,false)

		// Overlay for displays menu
		if ((var0 == Overlay.Displays) || (prf.JUMPSHOW)){
			
			showexitarcadeflow = ((overlay_listbox.list_size == zmenu.shown) && (!prf.JUMPSHOW))

			// Only when listbox is actually shown we can tweak the zmenu to remove "exit arcadeflow"
			if ((!showexitarcadeflow) && (!prf.JUMPSHOW)){
				local exitarcadeflow = zmenu.items.pop()
				exitarcadeflow = zmenu.glyphs.pop()
				zmenu.shown = zmenu.shown -1
			}
			
			if (prf.DMPGENERATELOGO) {
				for (local i=0 ; i < (showexitarcadeflow ? zmenu.shown -1 : zmenu.shown); i++){
					
					zmenu.items[i].font = uifonts.gui
					//test72 zmenu.items[i].margin = 1
					zmenu.items[i].char_size = ( (vertical && prf.DMPIMAGES && !prf.DMPGROUPED) ? zmenu.tileh*0.5 : zmenu.tileh*0.7)
					zmenu.items[i].align = Align.MiddleCentre
					
					local renamer = systemfont(zmenu.items[i].msg,true)

					if (renamer == " ") {
						local bobwrapped = null
						bobwrapped = {
							text = zmenu.items[i].msg.toupper()
						}
						zmenu.items[i].font = uifonts.arcade
						zmenu.items[i].align = Align.MiddleCentre
						//test72 zmenu.items[i].margin = 0
						zmenu.items[i].line_spacing = 0.6
						zmenu.items[i].word_wrap = true
						zmenu.items[i].msg = bobwrapped.text
						zmenu.items[i].char_size = zmenu.items[i].height * ((vertical && prf.DMPIMAGES && !prf.DMPGROUPED) ? 1.25/3.0 : 2.0/3.0) 
					}
					else zmenu.items[i].msg = renamer
				}
			}
		}

		// Overlay for all menus
		zmenu_surface_sh.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.v : noshader)
		zmenu_surface_sh1.shader = (prf.DATASHADOWSMOOTH ? shader_tx2.h : noshader)
		
		zmenu_surface_container.visible = zmenu_surface_sh.visible = true

		//TEST70 prf.ZMENUON = true
		overlay_listbox.width = overlay.fullwidth 

		local menucorrect = 0
		if (zmenu.shown - 1 - zmenu.selected < (overlay.rows -1) / 2) menucorrect =  (overlay.rows -1) / 2 - zmenu.shown +1 + zmenu.selected
		if (zmenu.selected < (overlay.rows -1) / 2)  menucorrect = - (overlay.rows -1) / 2 + zmenu.selected
		zmenu.xstop = menucorrect * zmenu.tileh - zmenu.midoffset - zmenu.selected * zmenu.tileh + (zmenu.height - zmenu.tileh)*0.5
		if (zmenu.shown <= overlay.rows) zmenu.xstop = 0
		zmenu.xstart = zmenu.xstop

		// Initialize positions
		for (local i = 0;i < zmenu.shown ; i++) {
			zmenu.items[i].y = zmenu.pos0[i] + zmenu.xstop
			zmenu.glyphs[i].y = zmenu.pos0[i] + zmenu.xstop
//			zmenu.items[i].word_wrap = true
//			zmenu.items[i].margin = zmenu.glyphs[i].width - padding
		}
		
		for (local i = 0 ; i < zmenu.shown; i++){
			zmenu.items[i].set_rgb (255,255,255)
			zmenu.glyphs[i].set_rgb (255,255,255)			
		}

		//TEST70 CHECK zmenu.selected = PRESELECTED VALUE WAS disp.dispcode.find(fe.list.display_index) //TEST58 CHECK ROBUST?
		zmenu.items[zmenu.selected].set_rgb(0,0,0)
		zmenu.glyphs[zmenu.selected].set_rgb(0,0,0)
		zmenu.selectedbar.y = zmenu.items[zmenu.selected].y
	
	}


	if ((ttype == Transition.NewSelOverlay ) && (prf.ZMENUON) ){

		local menucorrect = 0

		if (zmenu.shown - 1 - var0 < (overlay.rows -1) / 2) menucorrect =  (overlay.rows -1) / 2 - zmenu.shown +1 + var0
		if (var0 < (overlay.rows -1) / 2) menucorrect = - (overlay.rows -1) / 2 + var0
		zmenu.xstop = menucorrect * zmenu.tileh - zmenu.midoffset - var0 * zmenu.tileh + (zmenu.height - zmenu.tileh)*0.5
		if (zmenu.shown <= overlay.rows) zmenu.xstop = 0
		
		zmenu.selected = var0

		for (local i = 0 ; i < zmenu.shown; i++){
			zmenu.items[i].set_rgb (255,255,255)
			zmenu.glyphs[i].set_rgb (255,255,255)
		}
		zmenu.items[zmenu.selected].set_rgb(0,0,0)
		zmenu.glyphs[zmenu.selected].set_rgb(0,0,0)
		zmenu.selectedbar.y = zmenu.items[zmenu.selected].y

	}

	if ((ttype == Transition.NewSelOverlay ) && (prf.DISPLAYLISTON) && (prf.DMPIMAGES)){
		disp.xstop = -var0*disp.spacing
	}
	
	
	// DISPLAY CHANGE REACTION
	if ((ttype == Transition.ToNewList) && (fe.list.display_index != displaystore)){
		fade.display = fade.displayzoom = 1

		//TEST71 disp.xstop = - fe.list.display_index * disp.spacing

		// restore global settings
		prf.CROPSNAPS = prfzero.CROPSNAPS
		prf.THUMBVIDEO = prfzero.THUMBVIDEO
		prf.LAYERSNAP = prfzero.LAYERSNAP
		prf.SNAPGRADIENT = prfzero.SNAPGRADIENT
		prf.BOXARTMODE = prfzero.BOXARTMODE

		if (prf.LOWSPECMODE){
			prf.FROSTEDGLASS = false
			prf.DATASHADOWSMOOTH = false
			prf.LOGOSHADOW = false
			prf.SNAPGRADIENT = false
			prf.SNAPGLOW = false
		}

		try {
			prf.BOXARTMODE = ( (DISPLAYTABLE[fe.displays[fe.list.display_index].name][0] == "BOXES") ? true : false )
		}
		catch (err){}

		displaystore = fe.list.display_index
	}
	


	// UPDATE LABEL WHEN NEW SELECTION
	if ((prf.SCROLLERTYPE == "labellist") && (ttype == Transition.ToNewSelection)){
		local sortl1 = z_list.jumptable[z_list.index].key
		local sortl2 = z_list.jumptable[modwrap(z_list.index + z_var,z_list.size)].key

		if (sortl1 != sortl2){
			downkey (sortl1)
			upkey (sortl2)
		}
	}
	
	// UPDATE SCROLLER LABELS WHEN CHANGING LIST
	if ((prf.SCROLLERTYPE != "Scroller") && ((ttype == Transition.ToNewList))){
		z_listrefreshlabels()
	}
	
	// UPDATE TILES FROM OLD SELECTION
	if (ttype == Transition.FromOldSelection) {
		updatebgsnap (newfocusindex)
		//squarizer = true
	}

	// UPDATE GAME DATA
	if ((ttype == Transition.StartLayout) || (ttype == Transition.ToNewList)){
		if (!prf.DISPLAYMENUON) dat.manufacturer_array[dat.stacksize - 1].msg = manufacturer_vec (0) 
		if (!prf.DISPLAYMENUON) dat.cat_array[dat.stacksize - 1].file_name = category_pic (0)
		dat.manufacturername_array[dat.stacksize - 1].visible = (dat.manufacturer_array[dat.stacksize - 1].msg == "")
		dat.but_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" : "button_images/" + fe.game_info(Info.Buttons, 0)+"button.png")
		dat.ply_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"players_images/players_" + fe.game_info(Info.Players,0)+".png")
		dat.ctl_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" : controller_pic (0))

		updatebgsnap (newfocusindex)
	}


	// cleanup frosted glass grabs when exiting AM
	if ((prf.FROSTEDGLASS) && (ttype == Transition.EndLayout) && (var0 == FromTo.Frontend)){
		for (local ig = 0; ig < frg.numgrabs ; ig++){
			remove(frg.createdgrabs[ig])
		}
	}


	// some fixes for the tags menu
	if (ttype == Transition.ShowOverlay){
		if (var0 == Overlay.Tags) tags.menu = true
		overlay_show(var0)
	}

	if (ttype == Transition.HideOverlay){
		prf.ZMENUON = false
		zmenu_surface_container.visible = zmenu_surface_sh.visible = false
		prf.DISPLAYLISTON = false
		overlay_listbox.width = overlay.fullwidth
		zmenu_surface_sh.shader = noshader
		zmenu_surface_sh1.shader = noshader

		overlay_hide()
		//TEST ADD THIS FOR FAVS?	zoompos = 1 
		if (tags.menu) {
			tags.menu = false
			tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
			tags.decor = true
			tags.decortr = true
		}
		zmenu.xstop = 0 

	}
	

	// scroller is always updated
	scroller.x = footermargin + ((z_list.index/rows)*rows*1.0/(fe.list.size - 1 ))*(fl.w - 2.0*footermargin-scrollersize)
	scroller2.x = scroller.x-scrollersize*0.5


	// RESET TILES WHEN GOING TO NEW LIST
	if ((ttype == Transition.ToNewList) ) {
		// Reset vars and positions
		debugpr ("TRANSBLOCK 1 - TNL - RESET VAR centercorr.val ETC \n")
		var = 0
		tilesTablePos.Offset = 0
		surfacePos = 0.5
		column.offset = 0
		centercorr.val = 0
		centercorr.shift = centercorr.zero

		// loop for all tiles
		for ( local i = 0; i < tiles.total ; i++ ) {
			// reset gradient data
			//update_gradient(i)

			// reset video fade data
			if (prf.THUMBVIDEO) {
				vidszTable[i].alpha = 0
				vid2zTable[i].alpha = 0
				vidpos[i] = 0
				vidszTableFade[i]=[0.0,0.0,0.0,0.0,0.0]
				vidszTable[i].file_name = "transparent.png"
			}

			// cleanup position of tiles
			picsize (tilesTable[i] , widthpadded, heightpadded,0,-0.025)
			tilesTable[i].zorder = -2
			tilesTable[i].visible = false
			tilesTableZoom[i] = [0.0,0.0,0.0,0.0,0.0]
			bd_mxTable[i].alpha = 0
			glomxTable[i].alpha = 0
		}
	}


	// UPDATE TILES DATA AND POSITION
	if ( (z_list.size > 0 ) && ((ttype == Transition.ToNewList) || (ttype == Transition.ToNewSelection) ) ) {
		debugpr ("TRANSBLOCK 2 - TNL TNS - UPDATE TILES \n")

		corrector = (rows == 1 ? -1 : -((z_list.index + var) % rows) )

		column.stop = floor((z_list.index + var )*1.0/rows)
		column.start = floor((z_list.index )*1.0/rows)

		column.offset = (column.stop - column.start)
		tilesTablePos.Offset += column.offset*rows

		local index = - (floor(tiles.total/2) -1) + corrector

		// Determine center position correction when reaching beginning or end of list
		centercorr.shift = 0
		centercorr.val = 0

		if ((column.stop < deltacol) && (var < 0) ) {
			if (column.stop == deltacol - 1 ){
				centercorr.shift = centercorr.zero + (deltacol - 1) * (width + padding)
			}
			else
				centercorr.shift = - (width + padding)
		}
		else if ((column.start < deltacol) && (var > 0)) {
			if (column.start == deltacol - 1 ){
				centercorr.shift = - centercorr.zero - (deltacol - 1) * (width+padding)
			}
			else
				centercorr.shift = (width + padding)
		}

		if (z_list.index + var <= deltacol * rows -1){
			centercorr.val = centercorr.zero + floor((z_list.index + var)/rows) * (width + padding)
		}
		
		if (column.offset == 0) centercorr.shift = 0
		
		// updates all the tiles
		debugpr ("TRANSBLOCK 2 - TNL TNS - CHANGE ALL TILES \n")

		for ( local i = 0; i < tiles.total ; i++ ) {

			local indexTemp = wrap( i + tilesTablePos.Offset, tiles.total )

			offseTable[indexTemp] = index
			local indexoffset = (z_list.gametable[modwrap(z_list.index + index,z_list.size)].z_felistindex) - fe.list.index
			local indexoffsetvar = (z_list.gametable[modwrap(z_list.index + index + var ,z_list.size)].z_felistindex) - fe.list.index
			
			
			if ( (ttype == Transition.ToNewList) || ((ttype == Transition.ToNewSelection) && (( ( (column.stop>column.start) && (i/rows >= tiles.total/rows - column.offset) ) || ( (column.stop < column.start) && (i/rows < -column.offset) ))))) {
				
				loshzTable[indexTemp].file_name = fe.get_art("wheel" , indexoffsetvar,0,Art.ImagesOnly)
				gradzTable[indexTemp].file_name = fe.get_art((prf.BOXARTMODE ? prf.BOXARTSOURCE : "snap") , indexoffsetvar,0,Art.ImagesOnly)

				//TEST62 CLEAN THE VIDEO SNAP HERE!

				if (prf.THUMBVIDEO){
					vidszTable[indexTemp].alpha = 0
					vid2zTable[indexTemp].alpha = 0
					vidszTable[indexTemp].file_name = "transparent.png"
					vidszTableFade[indexTemp] = [0.0,0.0,0.0,0.0,0.0]
					vidpos[indexTemp] = 0
				}

				//RESIZER
				logotitle = wrapme( fe.game_info (Info.Title, indexoffsetvar) ,9,3)
				txt2zTable[indexTemp].msg = txt1zTable[indexTemp].msg = txshzTable[indexTemp].msg = logotitle.text

				txshzTable[indexTemp].char_size = min( ((txshzTable[indexTemp].width*100.0/600.0)*9)/logotitle.cols , ((txshzTable[indexTemp].width*100.0/600.0)*3)/logotitle.rows )
				txt2zTable[indexTemp].char_size = txt1zTable[indexTemp].char_size = txshzTable[indexTemp].char_size * txt1zTable[indexTemp].width / txshzTable[indexTemp].width

				txt2zTable[indexTemp].x = txt1zTable[indexTemp].x + 0.015 * txt1zTable[indexTemp].char_size
				txt2zTable[indexTemp].y = txt1zTable[indexTemp].y - 0.025 * txt1zTable[indexTemp].char_size

			boxtitle = wrapme( fe.game_info (Info.Title, indexoffsetvar) ,6,4)
			txboxTable[indexTemp].msg = boxtitle.text

			txboxTable[indexTemp].char_size = min( ((txboxTable[indexTemp].width*100.0/400.0)*6)/boxtitle.cols , ((txboxTable[indexTemp].width*100.0/400.0)*4)/boxtitle.rows )

				update_snapcrop (indexTemp , var, indexoffsetvar, ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE))
			

				local horizgame = ishorizgame(offseTable[indexTemp],snapzTable[indexTemp],var,prf.BOXARTMODE)
				// Update visibility of horizontal or vertical shadows, glow, indicator etc
				update_thumbdecor(indexTemp,var,horizgame)
				if (bd_mxTable[indexTemp].alpha != 0) update_borderglow(indexTemp,var,horizgame)
			
			}
			
			tilesTable[indexTemp].zorder = -2


			tilesTablePos.X[indexTemp] = (i/rows) * (width+padding) + carrierT.x + centercorr.val + widthpadded*0.5
			tilesTablePos.Y[indexTemp] = (i%rows) * (height + padding) + carrierT.y + verticalshift + widthpadded*0.5

			tilesTable[indexTemp].visible = (( (z_list.index + var + index < 0) || (z_list.index + var + index > fe.list.size-1) ) == false)

			index++
		}
		
		// updates the size and features of the previously selected item and new selected item
		newfocusindex = wrap( floor(tiles.total/2)-1-corrector + tilesTablePos.Offset, tiles.total )
		oldfocusindex = wrap( floor(tiles.total/2)-1-corrector -var + tilesTablePos.Offset, tiles.total )

		tilesTableZoom[oldfocusindex] = startfade (tilesTableZoom[oldfocusindex],-0.055,1.0)
		tilesTableZoom[newfocusindex] = startfade (tilesTableZoom[newfocusindex],0.035,-5.0)

		//activate video load counter
		if ((prf.THUMBVIDEO) ){
			vidszTableFade[oldfocusindex] = startfade (vidszTableFade[oldfocusindex],-0.01,1.0)
			vidpos[oldfocusindex] = 0

			if (vidszTable[newfocusindex].alpha == 0) {
				vidpos[newfocusindex] = vidstarter
				vidindex[newfocusindex] = offseTable[newfocusindex]
			}
			else {
				vidszTableFade[newfocusindex] = startfade (vidszTableFade[newfocusindex],0.03,1.0)
			}
		}
		tilesTable[oldfocusindex].zorder = -2
		tilesTable[newfocusindex].zorder = -1
		letterobj.zorder = 0
		
		//favezTable[newfocusindex].visible = (fe.game_info(Info.Favourite, offseTable[newfocusindex]+var) == "1")
		//donezTable[newfocusindex].visible = ((fe.game_info(Info.Tags, offseTable[newfocusindex]+var)).find("Completed") != null)

		local horizgame = ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],var,prf.BOXARTMODE)

		// Update decorations related to newly focused index image
		update_borderglow(newfocusindex,0,horizgame)


		// trigger squaring of background thumbs
		squarizer = true
	}
	
	// if the transition is to a new selection initialize crossfade, scrolling and surfacepos
	if( (ttype == Transition.ToNewSelection) ){
		
		debugpr ("TRANSBLOCK 3.0 - TNS - TRANSITION TO NEW SELECTION ONLY \n")

		local l1 = z_list.jumptable[z_list.index].key
		local l2 = z_list.jumptable[z_list.newindex].key

		if (l1 != l2){
			fade.letter = 1
		}

		//bgs.bgpic_array[0].file_name = fe.get_art((prf.BOXARTMODE ? "flyer" : "snap") , loshzTable[newfocusindex].index_offset+var,0,Art.ImagesOnly)

		for (local i = 0; i < bgs.stacksize-1;i++){
			bgs.bgpic_array[i].swap(bgs.bgpic_array[i+1])
			bgs.alphapos[i] = bgs.alphapos[i+1]
			bgs.bg_lcd[i] = bgs.bg_lcd[i+1]
			bgs.bg_mono[i] = bgs.bg_mono[i+1]
			bgs.bg_box[i] = bgs.bg_box[i+1]
		}


		for (local i = 0; i < dat.stacksize - 2;i++){
			dat.var_array[i] = - var + dat.var_array[i+1]
		}
		dat.var_array [dat.stacksize - 1] = 0
		dat.var_array [dat.stacksize - 2] = - var

		local varoffset = 0

		for (local i=0 ; i< dat.stacksize -1 ; i++){
			// dat.manufacturer_array[i].rawset_index_offset(dat.var_array[i])
			// dat.cat_array[i].rawset_index_offset(dat.var_array[i])
			local msgtemp = dat.manufacturer_array[i].msg
			dat.manufacturer_array[i].msg = dat.manufacturer_array[i+1].msg
			dat.manufacturer_array[i+1].msg = msgtemp
			//TEST60 dat.manufacturer_array[i].swap (dat.manufacturer_array[i+1]) 
			dat.cat_array[i].swap (dat.cat_array[i+1])
			dat.but_array[i].swap (dat.but_array[i+1])
			dat.ply_array[i].swap (dat.ply_array[i+1])
			dat.ctl_array[i].swap (dat.ctl_array[i+1])

			varoffset = z_list.gametable[modwrap (z_list.newindex + dat.var_array[i] , z_list.size) ].z_felistindex - z_list.gametable[modwrap (z_list.newindex, z_list.size) ].z_felistindex

			dat.mainctg_array[i].index_offset = varoffset
			dat.gamename_array[i].index_offset = varoffset
			dat.gamesubname_array[i].index_offset = varoffset
			dat.gameyear_array[i].index_offset = varoffset
			dat.manufacturername_array[i].index_offset = varoffset

			dat.manufacturername_array[i].visible = (dat.manufacturer_array[i].msg == "") 

			if (i != dat.stacksize -2 )
				dat.alphapos[i] = dat.alphapos[i+1]
			else
				dat.alphapos[i] = 1.0 - dat.alphapos[i+1]
		}

		varoffset = z_list.gametable[modwrap (z_list.newindex , z_list.size) ].z_felistindex - z_list.gametable[modwrap (z_list.index, z_list.size) ].z_felistindex

		if (!prf.DISPLAYMENUON) dat.manufacturer_array[dat.stacksize - 1].msg = manufacturer_vec (varoffset) 
		if (!prf.DISPLAYMENUON) dat.cat_array[dat.stacksize - 1].file_name = category_pic (varoffset)
		dat.manufacturername_array[dat.stacksize - 1].visible = (dat.manufacturer_array[dat.stacksize - 1].msg == "") 
		dat.but_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"button_images/"+fe.game_info(Info.Buttons, varoffset)+"button.png")
		dat.ply_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :"players_images/players_" + fe.game_info (Info.Players , varoffset)+".png")
		dat.ctl_array[dat.stacksize - 1].file_name = (prf.DISPLAYMENUON ? "white.png" :controller_pic (varoffset))
		dat.alphapos [dat.stacksize - 1] = 1

		bgs.alphapos [bgs.stacksize - 1]= 255
		
		surfacePos += (column.offset * (width + padding) ) - centercorr.shift
		
	}

	return false
}


/// On Tick ///
function tick( tick_time ) {

	// prevent attract mode from running when menus are visible
	if ((overlay_listbox.visible == true) || (prf.ZMENUON)) attract.timer = fe.layout.time

	if (tags.decor == true){
		update_thumbdecor (newfocusindex,0,ishorizgame(offseTable[newfocusindex],snapzTable[newfocusindex],0,prf.BOXARTMODE))
		tags.decor = false
	}

	
	if (disp.starter){
		foreach (bob in disp.items){
			

			// Crop display artwork
				local extension = bob.file_name.slice (bob.file_name.len()-3,bob.file_name.len())
				if ( extension.tolower( )!= "png") {
					local sizew = min(bob.texture_width,bob.texture_height)
					bob.subimg_width = sizew
					bob.subimg_height = sizew
					bob.subimg_x = (bob.texture_width - sizew )*0.5
					bob.subimg_y = (bob.texture_height - sizew )*0.5
				}
			
			
		}
		
		
		disp.starter = false
	}


	if ((disp.xstart != disp.xstop) && (prf.DMPIMAGES) ){
		disp.speed = (0.2 * (disp.xstop - disp.xstart))
		if (absf(disp.speed) > 0.0005*disp.tileh) {

			if ((absf(disp.xstart - disp.xstop)) > disp.spacing * (fe.displays.len()-2)) {
				disp.xstart = disp.xstop
				for (local i = 0;i < disp.items.len() ; i++) {
					disp.items[i].y = disp.pos0[i] + disp.xstop
				}
			}
			else {
				for (local i = 0;i < disp.items.len() ; i++) {
					disp.items[i].y = disp.pos0[i] + disp.xstart + disp.speed
				}
				disp.xstart = disp.xstart + disp.speed
			}
		}
		else {
			disp.xstart = disp.xstop
			for (local i = 0;i < disp.items.len() ; i++) {
				disp.items[i].y = disp.pos0[i] + disp.xstop
			}
		}
	}
	

	if (zmenu.xstart != zmenu.xstop){
		zmenu.speed = (0.2 * (zmenu.xstop - zmenu.xstart))
		if (absf(zmenu.speed) > 0.0005*zmenu.tileh) {
			for (local i = 0;i < zmenu.shown ; i++) {
				zmenu.items[i].y = zmenu.pos0[i] + zmenu.xstart + zmenu.speed
				zmenu.glyphs[i].y = zmenu.pos0[i] + zmenu.xstart + zmenu.speed
			}

			zmenu.xstart = zmenu.xstart + zmenu.speed
		}
		else {
			zmenu.xstart = zmenu.xstop
			for (local i = 0;i < zmenu.shown ; i++) {
				zmenu.items[i].y = zmenu.pos0[i] + zmenu.xstop
				zmenu.glyphs[i].y = zmenu.pos0[i] + zmenu.xstop
			}
		}
		zmenu.selectedbar.y = zmenu.items[zmenu.selected].y

	}

	// Attract mode management
	if (prf.AMENABLE) {

		if (attract.start){
			// block theme videos and set snap audio
			if (prf.LAYERVIDEO) bgs.bgvid_array[bgs.stacksize - 1].video_playing = false
			if (prf.THUMBVIDEO) vidszTable[newfocusindex].video_playing = false
			if (!attract.sound) attract_snap.video_flags = Vid.NoAudio

			if(prf.AMTUNE != "") {
				snd.attracttune.playing = true
				if (prf.BACKGROUNDTUNE != "") snd.bgtune.playing = false
			}
			else if ((prf.BACKGROUNDTUNE != "") && (prf.NOBGONATTRACT)) snd.bgtune.playing = false

			attract.start = false
			attract.rolltext = true
			attract.gametimer = true
			//attract.updatesnap = true
			attractupdatesnap()
			attract.timer = tick_time
		}

		if (attract.rolltext){
			attract_text2.alpha = 255*(0.5+0.5*cos(tick_time/500.0))
			attract_text.alpha = attract.textshadow * attract_text2.alpha / 255
		}

		if (attract.gametimer){
			if ((tick_time - attract.timer) > attract.game_interval){
				flowT.gametoblack = startfade (flowT.gametoblack,0.1,0.0)
			}
		}

		if (attract.starttimer){
			if ((tick_time - attract.timer) > attract.attract_interval){
				attractkick()
			}
		}
	}

	// Apply square screen cropping for background artwork
	if (squarizer){
		squarizer = false
		squarebg()
	}

	if (count.right != 0) count.right = repeatsignal("right",count.right)
	if (count.left != 0) count.left = repeatsignal("left",count.left)
	if (count.up != 0) count.up = repeatsignal("up",count.up)
	if (count.down != 0) count.down = repeatsignal("down",count.down)

	if (count.prev_game != 0) count.prev_game = repeatsignal("prev_game",count.prev_game)
	if (count.next_game != 0) count.next_game = repeatsignal("next_game",count.next_game)

	if (count.prev_page != 0) count.prev_page = repeatsignal("prev_page",count.prev_page)
	if (count.next_page != 0) count.next_page = repeatsignal("next_page",count.next_page)
	
	if (count.prev_letter != 0) count.prev_letter = repeatsignal("prev_letter",count.prev_letter)
	if (count.next_letter != 0) count.next_letter = repeatsignal("next_letter",count.next_letter)

	// crossfade of the blurred background
	for (local i = 0 ; i < bgs.stacksize ; i++){
		if (bgs.alphapos[i] !=0){
			if ((bgs.alphapos[i] < 1) && (bgs.alphapos[i] > -1) ) bgs.alphapos[i] = 0
			bgs.alphapos[i] = bgs.alphapos[i] * spdT.bgfadespeed
			bgs.bgpic_array[i].alpha = 255-bgs.alphapos[i]
			if (prf.LAYERSNAP) bgs.bgvid_array[i].alpha = 255-bgs.alphapos[i]
		}
	}

	// fading of the initial letter of the name
	if (fade.letter != 0){
		if(fade.letter < 0.01) fade.letter = 0
		fade.letter = fade.letter * spdT.letterspeed
		letterobj.alpha = 255*(1-4.0*pow((0.5-fade.letter),2))
		letterobj.charsize = lettersize.name * (1.0 + 0.5*pow((1-fade.letter),2))
	}

	// fading of the initial letter of the name
	if (fade.display != 0){
		if(fade.display < 0.001) fade.display = 0
		fade.display = fade.display * spdT.displayspeed
		displayname.alpha = 255*(1.0 - 4.0*pow((0.5-fade.display),2))
	}

	if (fade.displayzoom != 0){
		if(fade.displayzoom < 0.001) fade.displayzoom = 0
		fade.displayzoom = fade.displayzoom * spdT.displayzoomspeed
		displayname.charsize = lettersize.display * (1.0 + 0.5*pow((1.0-fade.displayzoom),2))
	}

	// Manage tiles zoom and unzoom
	for(local i = 0 ; i < tiles.total ; i++){
		if (checkfade(tilesTableZoom[i])){
			tilesTableZoom[i] = fadeupdate(tilesTableZoom[i])
			local zoomtemp = tilesTableZoom[i]
			if ((zoomtemp[1] + zoomtemp[3] < 0) || (zoomtemp[1] + zoomtemp[3] > 1)){
				tilesTableZoom[i] = (zoomtemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
				zoomtemp = tilesTableZoom[i]
			}

			// hide glow image and border image when zero is reached
			if ((zoomtemp[1] == 0)){
				glomxTable[i].visible = false
				glomxTable[i].shader = noshader
				bd_mxTable[i].visible = false
			}

			// update size and glow alpha
			picsize(tilesTable[i], widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]), widthpadded + (selectorwidth-widthpadded)*(zoomtemp[1]) , 0, -0.025)
			if (zoomtemp[3] < 0){
				glomxTable[i].alpha = 255*pow(zoomtemp[1],5)
				bd_mxTable[i].alpha = 240*pow(zoomtemp[1],5)
			// vidszTable[i].alpha = vid2zTable[i].alpha = 255*(zoomtemp[1])
			}
			else{
				glomxTable[i].alpha = 255*(zoomtemp[1])
				bd_mxTable[i].alpha = 240*(zoomtemp[1])
			}
		}
	}


	// Manage video fade and unfade
	for(local i = 0 ; i < tiles.total ; i++){
		if (checkfade(vidszTableFade[i])){
			vidszTableFade[i] = fadeupdate(vidszTableFade[i])
			local fadetemp = vidszTableFade[i]
			if ((fadetemp[1] + fadetemp[3] < 0) || (fadetemp[1] + fadetemp[3] > 1)){
				vidszTableFade[i] = (fadetemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
				fadetemp = vidszTableFade[i]
			}

			// hide glow image and border image when zero is reached
			if ((fadetemp[1] == 0)){
					vidszTable[i].file_name = "transparent.png"
					vidszTable[i].alpha = 0
			}

			// update size and glow alpha
			vidszTable[i].alpha = vid2zTable[i].alpha = 255*(fadetemp[1])
		}
	}


	// crossfade of game data
	for (local i = 0 ; i < dat.stacksize ; i++){
		if (dat.alphapos[i] != 0 ){
			if ((dat.alphapos[i] <0.01) && (dat.alphapos[i] > -0.01)) dat.alphapos[i] = 0

			if (i != dat.stacksize -1){
				dat.alphapos[i] = dat.alphapos[i] * spdT.dataspeedout
				dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[i].alpha = dat.cat_array[i].alpha = dat.mainctg_array[i].alpha = dat.manufacturer_array[i].alpha = dat.gamename_array[i].alpha = dat.gamesubname_array[i].alpha = dat.manufacturername_array[i].alpha = dat.gameyear_array[i].alpha = 255 * (dat.alphapos[i])*1.0
			}
			else {
				dat.alphapos[dat.stacksize -1] = dat.alphapos[dat.stacksize - 1] * spdT.dataspeedin
				dat.ply_array[i].alpha = dat.ctl_array[i].alpha = dat.but_array[dat.stacksize - 1].alpha = dat.cat_array[dat.stacksize - 1].alpha = dat.mainctg_array[dat.stacksize - 1].alpha = dat.manufacturer_array[dat.stacksize - 1].alpha = dat.gamename_array[dat.stacksize - 1].alpha = dat.gamesubname_array[dat.stacksize - 1].alpha = dat.manufacturername_array[dat.stacksize - 1].alpha =dat.gameyear_array[dat.stacksize - 1].alpha = 255 * (1.0 - dat.alphapos[dat.stacksize - 1])*1.0
			}
		}
	}

	// tiles scrolling
	if ((surfacePos != 0)) {
		
		if ((surfacePos < 0.1) && (surfacePos > -0.1)) surfacePos = 0
		surfacePos = surfacePos * spdT.scrollspeed

		if (surfacePos > surfacePosOffset) surfacePos = surfacePosOffset
		if (surfacePos < -surfacePosOffset) surfacePos = -surfacePosOffset
		
		// repositioning of tiles
		for ( local i = 0; i < tiles.total; i++ ) {
			tilesTable[i].x = surfacePos - surfacePosOffset + tilesTablePos.X[i]
			tilesTable[i].y = tilesTablePos.Y[i]
		}

		globalposnew = tilesTable[newfocusindex].x
	}

	// fade of bg video
	if (prf.LAYERVIDELAY){
		if (vidposbg !=0){
			vidposbg = vidposbg - 1

			if (vidposbg == delayvid){

				bgs.bgvid_array[bgs.stacksize - 1].file_name = fe.get_art("snap",0)
				bgs.bgvid_array[bgs.stacksize - 1].alpha = 0
			}
			if (vidposbg == fadevid){
				vidbgfade = startfade (vidbgfade,0.03,1.0)
				vidposbg = 0
			}
		}

		if (checkfade(vidbgfade)){
			vidbgfade = fadeupdate(vidbgfade)
			local fadetemp = vidbgfade
			if ((fadetemp[1] + fadetemp[3] < 0) || (fadetemp[1] + fadetemp[3] > 1)){
				vidbgfade = (fadetemp[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
				fadetemp = vidbgfade
			}

			// update size and glow alpha
			bgs.bgvid_array[bgs.stacksize - 1].alpha = 255*(fadetemp[1])
		}
	}
	
	// crossfade of video snaps, tailored to skip initial fade in
	for (local i = 0 ; i < tiles.total; i++){
		if ( vidpos[i] != 0 ) {
			vidpos[i] = vidpos[i] - 1
			//if (vidpos[i] == 0) vidpos[i] = 0
			// newfocusindex = wrap( tiles.total/2-1-corrector + tilesTablePos.Offset, tiles.total )

			if ((vidpos[i] == delayvid) ){
				//vidszTable[newfocusindex].visible = true
				if ((prf.THUMBVIDEO)){
					vidszTable[i].file_name = fe.get_art("snap",vidindex[i])
					if ((prf.AUDIOVIDSNAPS) && (!history_visible()) && (!overlay_visible())) vidszTable[i].video_flags = Vid.Default
				}
				if (prf.AMENABLE) {
					if (attract.rolltext) vidszTable[i].video_playing = false
				}

				vidszTable[i].alpha = vid2zTable[i].alpha = 0

				vid2zTable[i].set_pos(snapzTable[i].x,snapzTable[i].y,snapzTable[i].width,snapzTable[i].height)

				local horizgame = ishorizgame(offseTable[i],snapzTable[i],0,prf.BOXARTMODE)
				local horizvideo = ishorizgame (offseTable[i],vid2zTable[i],0,false)

				if ((prf.CROPSNAPS) && (!prf.BOXARTMODE)){
					//TEST58 is AR ok?
					//vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vid2zTable[i].subimg_height = vidszTable[i].subimg_height = min(vidszTable[i].texture_height,vidszTable[i].texture_width)
					if (horizvideo == true ) {
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_width*(3.0/4.0)
						vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_height
					}
					else{
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_width
						vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_height*(3.0/4.0)						
					}
				}
				else if ((prf.BOXARTMODE) && (screentype(offseTable[i],0)=="CRT") ) //AR is 4:3 or 3:4 if not LCD
				{
					if (horizgame == true){ //LA LABEL E' ORIZZONTALE
						// LA LARGHEZZA E' TUTTA LA LARGHEZZA
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width

						if (horizvideo == true) // Horizontal game screen, stretched to 4:3
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
						else // vertical game screen, cropped to 4:3 equivalent
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height*(3.0/4.0)/(4.0/3.0)
					}
					if (horizgame == false){ // LABEL VERTICALE
						vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height

						if (horizvideo == true) 
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width*(3.0/4.0)/(4.0/3.0)
						else // vertical screen, no crop
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width
					}
					if (horizgame == null){
						//vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = min(vidszTable[i].texture_width,vidszTable[i].texture_height)
						if (horizvideo == true ) {
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_width*(3.0/4.0)
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_height
						}
						else{
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_width
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].subimg_height = vid2zTable[i].subimg_height = vidszTable[i].texture_height*(3.0/4.0)
						}
					}
				}
				else if (screentype(offseTable[i],0) != "CRT") { //Only LCDs are cropped, CRT are scaled to 4:3 or 3:4

					if (horizgame == true){
						//vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_height*4.0/3.0
						//vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
						if (1.0*vidszTable[i].texture_width / vidszTable[i].texture_height >= 4.0/3.0){
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_height * 4.0/3.0
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
						}
						else {
							vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width
							vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_width * 3.0/4.0
						}	
					}
					if (horizgame == false){
						//vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_width*4.0/3.0
						//vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width
					if (1.0*vidszTable[i].texture_height / vidszTable[i].texture_width >= 4.0/3.0){
						vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_width*4.0/3.0
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_width
					}
					else {
						vid2zTable[i].subimg_height = vidszTable[i].subimg_height = vidszTable[i].texture_height
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].texture_height * 3.0/4.0
					}
				}
					if (horizgame == null){
						vid2zTable[i].subimg_width = vidszTable[i].subimg_width = vidszTable[i].subimg_height = vid2zTable[i].subimg_height =min(vidszTable[i].texture_width,vidszTable[i].texture_height)
					}
				}
	
				vid2zTable[i].subimg_x = vidszTable[i].subimg_x = 0.5*(vidszTable[i].texture_width - vidszTable[i].subimg_width)
				vid2zTable[i].subimg_y = vidszTable[i].subimg_y = 0.5*(vidszTable[i].texture_height - vidszTable[i].subimg_height)

			}
			
			if (vidpos[i] == fadevid){
				vidszTableFade[i] = startfade (vidszTableFade[i],0.03,1.0)
				vidpos[i] = 0
				//vidszTable[i].alpha = vid2zTable[i].alpha = 255.0*(1-0.01*vidpos[i]*(1/fadevid))
				//else
				//vidszTable[newfocusindex].alpha = vid2zTable[newfocusindex].alpha = 0
			}
		}
	}

	// screen grabbing for frosted surface
	if (frg.grabdither != 0) {
		frg.grabdither --
		pixelpic.x = frg.grabdither
		if (prf.FROSTEDGLASS){
			if (frost.top.file_name != "transparent.png") frost.top.file_name = "transparent.png" 
		}
	}

	if (frg.grabticker != 0)
	{
		frg.grabticker --
		if (frg.grabticker == 0){
			try{
				rename (frg.firstpath,frg.grabpath)
			} catch (err) {}
			frost.pic.file_name = frg.grabpath

			frost.top.alpha = 255
			flowT.frostfade = [1.0,1.0,1.0,0.0,0.0]
			frost.top.file_name = frg.grabpath
			flowT.frostfade = startfade (flowT.frostfade, -0.1,0.0)
			if (rotation.r90){
				
			}
		frg.immediatesignal = true
		fe.signal(frg.grabsignal)
		}
	}

	// context menu fade in fade out

	if ((overmenu.visible) && (flowT.overmenu[3] >= 0) && (surfacePos != 0)) {
		overmenu.x = globalposnew - overmenuwidth*0.5
	}


	if (checkfade (flowT.frostfade)){
		flowT.frostfade = fadeupdate(flowT.frostfade)
		if ((flowT.frostfade[1] + flowT.frostfade[3] < 0) || (flowT.frostfade[1] + flowT.frostfade[3] > 1)){
			flowT.frostfade = (flowT.frostfade[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
		}
		frost.top.alpha = 255 * (flowT.frostfade[1])
	}


	if (checkfade (flowT.historyblack)){
		flowT.historyblack = fadeupdate(flowT.historyblack)

		if ((flowT.historyblack[1] + flowT.historyblack[3] < 0) || (flowT.historyblack[1] + flowT.historyblack[3] > 1)){
			flowT.historyblack = (flowT.historyblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.historyblack[1] == 1) {
				// history_updatesnap()
				flowT.historyblack = startfade (flowT.historyblack,-flowT.historyscroll[3]*2.0,0.0)
			}
		}

		hist_screensurf.set_rgb (255 * (1.0 - flowT.historyblack[1]),255 * (1.0 - flowT.historyblack[1]),255 * (1.0 - flowT.historyblack[1]))
		hist_glow_pic.set_rgb (255 * (1.0 - flowT.historyblack[1]),255 * (1.0 - flowT.historyblack[1]),255 * (1.0 - flowT.historyblack[1]))
		hist_glow_pic.alpha = hist_screensurf.alpha = 255 * (1.0 - flowT.historyblack[1])

	}

	if (checkfade (flowT.historyscroll)){
		flowT.historyscroll = fadeupdate(flowT.historyscroll)

		if ((flowT.historyscroll[1] + flowT.historyscroll[3] < 0) || (flowT.historyscroll[1] + flowT.historyscroll[3] > 1)){
			flowT.historyscroll = (flowT.historyscroll[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.historyscroll[1] == 1) {
				history_updatesnap()
				hist.scrollreset = false
				flowT.historyscroll = [0.0,0.0,0.0,0.0751,0.0]
			}
		}

		if ((flowT.historyscroll[1] < 0.5) && (flowT.historyscroll[1] > 0.5 - flowT.historyscroll[3]) && (!hist.scrollreset)) flowT.historyscroll = [0.5,0.5,0.5,0.0,0.0]

		if (!vertical){
			hist_screensurf.y = hist_screenT.y + historypadding - hist.direction * 1.50 * fl.h * (flowT.historyscroll[1] - 0.5)
			shadowsurf2.y = histglow.y - shadow.radius - hist.direction * 1.50 * fl.h * (flowT.historyscroll[1] - 0.5)
		}
		else
		{
			hist_screensurf.x = hist_screenT.x + historypadding - hist.direction * 1.50 * fl.w * (flowT.historyscroll[1] - 0.5)
			shadowsurf2.x = histglow.x - shadow.radius - hist.direction * 1.50 * fl.w * (flowT.historyscroll[1] - 0.5)
		}
	}


	if (checkfade (flowT.historydata)){
		flowT.historydata = fadeupdate(flowT.historydata)

		if ((flowT.historydata[1] + flowT.historydata[3] < 0) || (flowT.historydata[1] + flowT.historydata[3] > 1)){
			flowT.historydata = (flowT.historydata[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.historydata[1] == 1) {
				history_updatetext()
				flowT.historydata = startfade (flowT.historydata,-0.101,3.0)
			}
		}

		hist_text.alpha = 255 * (1.0 - flowT.historydata[1])

		if (prf.HISTORYPANEL) {
			hist_titletxt_bot.alpha = hist_title.alpha = hist_titleT.transparency * (1.0 - flowT.historydata[1])
			hist_titletxt_bd.alpha = hist_titletxt.alpha = hist_title_top.alpha = 255 * (1.0 - flowT.historydata[1])
		}
		else {
			hist_titletxt_bd.alpha = hist_titletxt.alpha = hist_title.alpha = 255 * (1.0 - flowT.historydata[1])
		}

	}


	if (checkfade(flowT.overmenu)){
		flowT.overmenu = fadeupdate(flowT.overmenu)

		if ((flowT.overmenu[1] + flowT.overmenu[3] < 0) || (flowT.overmenu[1] + flowT.overmenu[3] > 1)){
			flowT.overmenu = (flowT.overmenu[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.overmenu[1] == 0) {
				overmenu.visible = false
			}
		}

		overmenu.alpha = 255 * flowT.overmenu[1]
	}

	// splash logo fade in fade out
	if (checkfade(flowT.logo)){
		flowT.logo = fadeupdate(flowT.logo)

		if ((flowT.logo[1] + flowT.logo[3] < 0) || (flowT.logo[1] + flowT.logo[3] > 1)){
			flowT.logo = (flowT.logo[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
		}

		aflogo_surface.alpha = 255 * flowT.logo[1]
	}


	// data surface fade in and fade out
	if (checkfade(flowT.data)){
		flowT.data = fadeupdate(flowT.data)

		if ((flowT.data[1] + flowT.data[3] < 0) || (flowT.data[1] + flowT.data[3] > 1)){
			flowT.data = (flowT.data[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
		}

		data_surface.alpha = 255 * flowT.data[1]
		data_surface_sh.alpha = themeT.themeshadow * flowT.data[1]
	}

	// foreground surface fade in and fade out
	if (checkfade(flowT.fg)){
		flowT.fg = fadeupdate(flowT.fg)

		if ((flowT.fg[1] + flowT.fg[3] < 0) || (flowT.fg[1] + flowT.fg[3] > 1)){
			flowT.fg = (flowT.fg[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
		}
		fg_surface.alpha = 255 * flowT.fg[1]
	}

	// attract mode surface fade
	if (checkfade(flowT.attract)){
		flowT.attract = fadeupdate(flowT.attract)

		if ((flowT.attract[1] + flowT.attract[3] < 0) || (flowT.attract[1] + flowT.attract[3] > 1)){
			flowT.attract = (flowT.attract[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			
			if (flowT.attract[1] == 0) {
				attract_snap.file_name = "transparent.png"
				attract_snap.shader = noshader
				attract_surface.visible = false
				attract_text.visible = attract_text2.visible = false
				attract.starttimer = true
				if(prf.AMTUNE != "") {
					snd.attracttune.playing = false
					if (prf.BACKGROUNDTUNE != "") snd.bgtune.playing = true
				}
				else if ((prf.BACKGROUNDTUNE != "") && (prf.NOBGONATTRACT)) snd.bgtune.playing = true

			}
		}
		attract_surface.alpha = attract_text2.alpha = 255 * flowT.attract[1]
		attract_text.alpha = attract.textshadow * flowT.attract[1]
	}

	// Fade to black games in attract mode
	if (checkfade(flowT.gametoblack)){
		
		flowT.gametoblack = fadeupdate(flowT.gametoblack)

		if ((flowT.gametoblack[1] + flowT.gametoblack[3] < 0) || (flowT.gametoblack[1] + flowT.gametoblack[3] > 1)){
			flowT.gametoblack = (flowT.gametoblack[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.gametoblack[1] == 1) {

				attract_snap.alpha = 255
				attractupdatesnap()
				attract.timer = tick_time
				flowT.gametoblack = startfade (flowT.gametoblack,-0.02,0.0)
			}
		}
		attract_black.bg_alpha = 255 * flowT.gametoblack[1]
	}

	// Fade whole layout from black
	if (checkfade(flowT.blacker)){
		flowT.blacker = fadeupdate(flowT.blacker)

		if ((flowT.blacker[1] + flowT.blacker[3] < 0) || (flowT.blacker[1] + flowT.blacker[3] > 1)){
			flowT.blacker = (flowT.blacker[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.blacker[1] == 0) {
				layoutblacker.visible = false
				if ((!prf.AMENABLE) || (!prf.AMSTART)) layoutfadein ()

			}
		}
		layoutblacker.alpha = 255 * flowT.blacker[1]
	}

	// history text fade
	if (checkfade(flowT.histtext)){
		flowT.histtext = fadeupdate(flowT.histtext)

		if ((flowT.histtext[1] + flowT.histtext[3] < 0) || (flowT.histtext[1] + flowT.histtext[3] > 1)){
			flowT.histtext = (flowT.histtext[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
		}

		hist_text.y = hist_textT.h * (1.0 - flowT.histtext[1])
	}

	// history page fade in fade out
	if (checkfade(flowT.history)){
		flowT.history = fadeupdate(flowT.history)

		if ((flowT.history[1] + flowT.history[3] < 0) || (flowT.history[1] + flowT.history[3] > 1)){
			flowT.history = (flowT.history[3] > 0 ? [1.0,1.0,1.0,0.0,0.0] : [0.0,0.0,0.0,0.0,0.0])
			if (flowT.history[1] == 0) {
				hist_title.file_name = "transparent.png"
				hist_screen.file_name = "transparent.png"
				hist_screen.shader = noshader
				shadowsurf1.shader = noshader
				shadowsurf2.shader = noshader
				hist_text_surf.shader = noshader
				history_surface.visible = false
			}
		}

		history_surface.alpha = 255 * flowT.history[1]
	}
}




/// On Signal ///
function on_signal( sig ){
	debugpr ("\n Si:" + sig )
	
//if (sig == "custom1"){hideallbutbg()}
//if (sig == "custom1") reset_layout()
/*
if (sig == "custom1") {
	local pippo = []
	for (local i = 0 ; i < 500 ; i=i+10) {
		pippo.push (i.tostring())
	}
	local pappo = fe.overlay.list_dialog (pippo,"TTT")
}
*/
	//if (sig == "exit"){fe.signal("exit_to_desktop")}

	/*
	if (sig == "layout_options"){
		optionsmenu()
		return true
	}
*/

	// Manage display jumps for nested displays list
	if ( ((sig == "prev_display") || (sig == "next_display")) && (prf.JUMPDISPLAYS)) {
		prf.JUMPSTEPS --
		if (prf.JUMPSTEPS == 0) prf.JUMPDISPLAYS = false
	}

	// Key response when attract mode is enabled (running or not)
	if (prf.AMENABLE){
		// Resets attract timer so when attract is not running the wait time is reset
		attract.timer = fe.layout.time
		
		if (attract.rolltext){
			// If attract is running stops attract unless we are taking screenshots

			if (sig == "screenshot") return false

			flowT.attract = [1.0,1.0,1.0,-0.09,1.0]
			attract.start = false
			attract.rolltext = false
			attract.gametimer = false

			layoutfadein()
			return true
		}

	}
	
	// Signal responses that are available in every context

	// Switch thumbnails between snaps and boxart
	if ((sig == prf.SWITCHMODEBUTTON) && (!prf.DISPLAYMENUON)){
		switchmode()
		return true
	}


	// Manage exit arcadeflow from displays menu
	if ((sig == "select") && ((prf.DISPLAYMENUON)) ) {
		if (fe.list.index < fe.displays.len())
			fe.set_display(fe.list.index)
		else
			fe.signal("exit")
		return true
	}

	if (sig == "exit"){
		if (prf.FROSTEDGLASS){
			if (frg.immediatesignal){
				frg.immediatesignal = false
			}
			else{
				getsnap("exit")
				return true
			}
		}

		local result = glyph_list_dialog(ltxtarray(["Yes","No"],TLNG),[0xea10,0xea0f],ltxt("EXIT ARCADEFLOW?",TLNG),0xe9b6,1)		
		if (result == 0) {fe.signal("exit_to_desktop")}
		return true
	}

	
	// This is the way to call a frosted glass menu:
	if ((sig == "layout_options") && (!prf.OLDOPTIONSPAGE)) {	// Check if the desired signal is triggered
		if (history_visible()) return true
		if (prf.FROSTEDGLASS){		// If frosted glass is on, the first thing to check is "immediatesignal"
			if (frg.immediatesignal){	// If immediatesignal is true then immediatesignal is switched to false and then the final part of code is executed
				frg.immediatesignal = false
			}
			else{
				getsnap("layout_options") // If immediatesignal is false, which is the first iteration, getsnap fucntion generates the background and respawn the command
				return true
			}
		}
		optionsmenu() // This is the final part where custom code to manage the signal can be added.
			
		return true
	}

	if (sig == "add_favourite"){
		if (history_visible()) return true
		
		if (prf.FROSTEDGLASS){
			if (frg.immediatesignal){
				frg.immediatesignal = false
			}
			else{
				getsnap("add_favourite")
				return true
			}
		} 
		
		drawzmenu ([(fe.game_info(Info.Favourite)=="1" ? ltxt("Remove Favourite",TLNG) : ltxt("Add Favourite",TLNG)),ltxt("Cancel",TLNG)],[(fe.game_info(Info.Favourite)=="1" ? 0xe9d7 : 0xe9d9),0xea0f],ltxt("FAVOURITES",TLNG),0xe9d8,1,false)
		favcheck.oldsize = fe.list.size
		favcheck.changed = true
		return false
	}

	if (sig == "displays_menu"){
		if (history_visible()) return true
		
		if (prf.FROSTEDGLASS){
			if (frg.immediatesignal){
				frg.immediatesignal = false
				//return false
			}
			else{
				getsnap("displays_menu")
				return true
			}
		}

		if ((prf.DMPGROUPED) && (!prf.DISPLAYMENUON)){
			displaygrouped()
			return true
		}
		else {
			local displaysarray = []
			local currentdisplay = 0
			local inmenudisplay = 0
			for(local i = 0 ; i < fe.displays.len();i++){
				if (fe.displays[i].in_menu) {
					displaysarray.push(fe.displays[i].name)
					if (i == fe.list.display_index) currentdisplay = inmenudisplay
					inmenudisplay ++
				}
			}
				displaysarray.push(ltxt("EXIT ARCADEFLOW",TLNG))
				drawzmenu(displaysarray,null,ltxt("DISPLAYS",TLNG),0xe912,currentdisplay,prf.DMPIMAGES)  
		}		//return true
	}

	if (sig == "filters_menu"){
		if (history_visible()) return true

		if (prf.FROSTEDGLASS){
			if (frg.immediatesignal){
				frg.immediatesignal = false
				//return false
			}
			else{
				getsnap("filters_menu")
				return true
			}
		}	
		
		local filterarray = []
		local filterglyphs = []
		local filterindex = 0
		for(local i = 0; i <fe.filters.len();i++){
			filterarray.push (fe.filters[i].name + " - " + fe.filters[i].size)
			filterglyphs.push (fe.filters[i].name == fe.list.filter ? 0xea10 : 0) 
		}
		drawzmenu(filterarray,filterglyphs,ltxt("FILTERS",TLNG),0xea5b,(fe.filters.len() != 0 ? fe.list.filter_index : 0 ),false)
		//return true
	}

	// frosted glass effect signal response
	if (sig == "add_tags"){
		if (history_visible()) return true
		
		if (prf.FROSTEDGLASS){
			if (frg.immediatesignal){
				frg.immediatesignal = false
				//return false
			}
			else{
				getsnap("add_tags")
				return true
			}
		}
		
		local tagsarray = taglister()
		local tagsglyphs = []
		for(local i= 0;i<tagsarray.len();i++){
			tagsglyphs.push("")
		}

		local gametags = fe.game_info(Info.Tags)

		for (local i = 0 ; i < tagsarray.len();i++){
			//tagsarray[i] = ( (gametags.find(tagsarray[i]) == null) ? "+🏷 " : "-🏷 " ) + tagsarray[i]
			tagsglyphs[i] = ( (gametags.find(tagsarray[i]) == null) ? 0xea0a : 0xea0b ) 
		}
		
		tagsarray.push (ltxt("Create New Tag",TLNG))
		tagsarray.push (ltxt("Back",TLNG))
		tagsglyphs.push (0xe935)
		tagsglyphs.push(0xea0f)
		drawzmenu(tagsarray,tagsglyphs,ltxt("TAGS",TLNG),0xe936,0,false)
	}

	// rotation controls signal response
	if(sig == "toggle_rotate_right"){
		if (fe.layout.toggle_rotation == RotateScreen.None)
		{
			fe.layout.toggle_rotation = RotateScreen.Right
			fe.signal ("reload")
		}
		else{
			fe.layout.toggle_rotation = RotateScreen.None
			fe.signal ("reload")
		}
		return true
	}

	if(sig == "toggle_rotate_left"){
		if (fe.layout.toggle_rotation == RotateScreen.None)
		{
			fe.layout.toggle_rotation = RotateScreen.Left
			fe.signal ("reload")
		}
		else{
			fe.layout.toggle_rotation = RotateScreen.None
			fe.signal ("reload")
		}
		return true
	}




	// SPECIAL CASES SIGNAL RESPONSE
	// context menu signal response
	if (overmenu_visible())
	{
		debugpr (" OVERMENU \n")

		if (sig == "up"){
			
			if (prf.FROSTEDGLASS){
				if (frg.immediatesignal){
					frg.immediatesignal = false
				}
				else{
					getsnap("up")
					return true
				}
			}

			overmenu_hide(true)

			search.text =""
			local taglist = split(fe.game_info(Info.Tags),";")
			local switcharray = [
				ltxt("Year",TLNG) + " (" + fe.game_info(Info.Year)+")",
				ltxt("Decade",TLNG) + " (" + fe.game_info(Info.Year).slice(0,3)+"x)",
				ltxt("Manufacturer",TLNG) + "\n(" + fe.game_info(Info.Manufacturer) + ")",
				ltxt("Main Category",TLNG) + "\n(" + split(fe.game_info(Info.Category),"/")[0] + ")",
				ltxt("Sub Category",TLNG) + "\n(" + fe.game_info(Info.Category) + ")",
				ltxt("Orientation",TLNG) + " (" + fe.game_info(Info.Rotation) + ")",
				ltxt("Favourite state",TLNG) + " (" + (fe.game_info(Info.Favourite) == "1" ? ltxt("Yes",TLNG) : ltxt("No",TLNG) )+ ")",
			]
			local numset = switcharray.len()
			
			switcharray.extend( taglist.map (function(value){ return ("🏷 "+value)}) )
			local numtag = switcharray.len()
			switcharray.push ("RESET")

			local result = glyph_list_dialog(switcharray,null, "  " + ltxt("More of the same",TLNG)+"...",0xe987,0)
			
			if(result==numtag){
				//fe.list.index += corrector + rows
				fe.list.search_rule =""
				searchdata.msg = ""
				if (backs.index != -1){
					fe.list.index = backs.index
					//corrector = backs.corrector
					backs.index = -1
				}
			}
			
			if (result == 0) {
				search.text = "Year contains "+ fe.game_info(Info.Year)
				search.string = ltxt("Year",TLNG)+":"+ fe.game_info(Info.Year)
			}

			if (result == 1) {
				search.text = "Year contains "+ fe.game_info(Info.Year).slice(0,3)
				search.string = ltxt("Decennio",TLNG)+":"+ fe.game_info(Info.Year).slice(0,3)+"x"
			}

			if (result == 2) {
				search.text = "Manufacturer contains "+fe.game_info(Info.Manufacturer)
				search.string = ltxt("Manufacturer",TLNG)+":"+fe.game_info(Info.Manufacturer)
			}

			if (result == 3) {
				search.text = (fe.game_info(Info.Category))
				local s = split( search.text, "/" )
				search.text = "Category contains "+s[0]
				search.string = ltxt("Category",TLNG)+":"+s[0]
			}

			if (result == 4) {
				search.text = "Category equals "+fe.game_info(Info.Category)
				search.string = ltxt("Category",TLNG)+":"+fe.game_info(Info.Category)
			}
			
			if (result == 5) {
				search.text = "Rotation equals "+fe.game_info(Info.Rotation)
				search.string = ltxt("Rotation",TLNG)+":"+fe.game_info(Info.Rotation)
			}

			if (result == 6) {
				search.text = "Favourite equals "+fe.game_info(Info.Favourite)
				search.string = ltxt("Favourite",TLNG)+":"+fe.game_info(Info.Favourite)
			}

			if ((result >= numset) && (result < numtag)) {
				search.text = "Tags contains " + taglist[result - numset]
				search.string = ltxt("Tags",TLNG)+":"+ taglist[result - numset]
			}

			// GOOD
			if ((result != numtag) && (result != -1)) {

				local currentname = z_list.gametable[z_list.index].z_name
				local currentsystem = z_list.gametable[z_list.index].z_system
				if (backs.index == -1) {
					backs.index = fe.list.index
				}
				fe.list.search_rule = search.text

				for (local i = 0 ; i < fe.list.size -1;i++){
					if(( z_list.gametable[i].z_name == currentname) && (z_list.gametable[i].z_system == currentsystem) ) {
						z_list_indexchange (i)
						break
					}
				}
				corrector = (rows == 1 ? -1 : 0)
				searchdata.msg = search.string
			}
			return true
		}

		else if (sig == "down") {
			overmenu_hide(false)
			history_show(true)

			return true
		}

		else if (sig == "left") {
			// add tags
			overmenu_hide(true)
			fe.signal ("add_tags")
			return true
		}

		else if (sig == "right") {
			// add current game to favorites
			overmenu_hide(true)
			fe.signal("add_favourite")
			return true
		}

		else if (sig == "back") {
			overmenu_hide(false)
			return true
		}

		else if (sig == "select") {
		 //data_surface.visible = false
		/*
			fg_surface.visible = true
			fg_surface.alpha = 255
			data_surface.visible = false
			data_surface_sh.visible = false
			*/
			hideallbutbg ()
			overmenu_hide(true)
			return false
		}
		else if ((sig == prf.OVERMENUBUTTON) && (prf.OVERMENUBUTTON != "select")) {
			
			overmenu_hide(false)
			return true
		}
		
		return false
	}
	
	// search page signal response
	else if (search_visible())
	{
		debugpr (" SEARCH \n")

		if ( sig == "up" ) {
			search_select_relative( 0, -1 )
			while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, -1 )
		}

		else if ( sig == "down" ) {
			search_select_relative( 0, 1 )
			while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 0, 1 )
		}

		else if ( sig == "left" ) {
			search_select_relative( -1, 0 )
			while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( -1, 0 )
		}

		else if ( sig == "right" ) {
			search_select_relative( 1, 0 )
			while (key_rows[key_selected[1]][key_selected[0]].tochar()=="_") search_select_relative( 1, 0 )
		}

		else if ( sig == "select" ) search_type( key_rows[key_selected[1]][key_selected[0]].tochar() )
		//else if ( sig == "back" ) search_type("<")
		//else if ( sig == "exit" ) search_toggle()
		else if ( sig == "back" ) search_toggle()
	
		else if (sig == "screenshot"){
			return false
		}

		return true
	}

	// IF NO OVERMENU OR SEARCH, WE ARE IN HISTORY OR GRID, SO PREV/NEXT CONTROLS ARE COMMON
	else {

		// next and previous game or page signal response
		if (sig == "next_game") {
			if (checkrepeat(count.next_game)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				if (z_list.index < (z_list.size -1 )) z_list_indexchange(z_list.index + 1 )
				else z_list_indexchange( 0 )
				if (history_visible()) history_changegame(1)
				count.next_game ++
			}
			return true
		}
		if (sig == "prev_game") {
			if (checkrepeat(count.prev_game)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				if (z_list.index > 0) z_list_indexchange(z_list.index - 1 )
				else z_list_indexchange( z_list.size - 1 )
				if (history_visible()) history_changegame(-1)
				count.prev_game ++
			}
			return true
		}	
		
		if(sig == "prev_page"){
			if (checkrepeat(count.prev_page)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				if (z_list.index > rows*(cols - 2)) z_list_indexchange (z_list.index - rows*(cols - 2))
				else z_list_indexchange (0)
				if (history_visible()) history_changegame(-1)
				count.prev_page ++
			}
			return true
		}
		if(sig == "next_page"){
			if (checkrepeat(count.next_page)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				if (z_list.index < z_list.size - 1 - rows*(cols - 2)) z_list_indexchange(z_list.index + rows*(cols -2))
				else z_list_indexchange (z_list.size -1 )
				if (history_visible()) history_changegame(1)
				count.next_page ++
			}
			return true
		}
		

		if (sig =="next_letter"){
			if (checkrepeat(count.next_page)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				z_list_indexchange (z_list.jumptable[z_list.index].next)
				if (history_visible()) history_changegame(1)
				count.next_letter ++
			}
			return true
		}
		if (sig =="prev_letter"){
			if (checkrepeat(count.next_page)) {
				if(prf.THEMEAUDIO) snd.ticksound.playing = true
				z_list_indexchange (z_list.jumptable[z_list.index].prev)
				if (history_visible()) history_changegame(-1)
				count.prev_letter ++
			}
			return true
		}
		if (sig == "random_game"){
			z_list_indexchange(z_list.size*rand()/RAND_MAX )
			if(prf.THEMEAUDIO) snd.ticksound.playing = true
			if (history_visible()) history_changegame(1)
			return true
		}

		// history page signal response
		if (history_visible())
		{
			debugpr (" HISTORY \n")

			if (sig == "select") {
				hideallbutbg ()
			}

			if (sig == "up") {
				if (checkrepeat(count.up)){
					on_scroll_up()
					count.up ++
					return true
				}
				else return true
			}

			else if (sig == "down") {
				if (checkrepeat(count.down)){
					on_scroll_down()
					count.down ++
					return true
				}
				else return true
			}

			else if ((sig == "left")) {
				if (checkrepeat(count.left)){

					if (z_list.index > 0) {
						z_list_indexchange (z_list.index - 1)
						history_changegame(-1)
					}
					else{
						z_list_indexchange (z_list.size - 1)
						history_changegame(1)
					}

					count.left++
					//history_show(false)
					return true
				}
				else return true
			}

			else if ((sig == "right") ) {
				if (checkrepeat(count.right)){
					if (z_list.index < (z_list.size -1 )) {
						z_list_indexchange (z_list.index + 1)
						history_changegame(1)
					}
					else {
						z_list_indexchange (0)
						history_changegame (-1)
					}
					//history_show(false)
					count.right++
					return true
				}
				else return true
			}

			else if (sig == "back") {
				history_exit()
				return true
			}

			return false
		}

	
	
		// normal signal response no history visible
		else {
			
			if ((sig == "select") && (prf.HISTORYBUTTON != "select") && (prf.OVERMENUBUTTON != "select")){
				hideallbutbg ()
			}

			if ((sig == prf.UTILITYMENUBUTTON) && (prf.UTILITYMENUBUTTON != "up")){
				utilitymenu()
				return true
			}



			debugpr (" NORMAL \n")
			switch ( sig ){

				case prf.HISTORYBUTTON:
				if (!prf.DISPLAYMENUON) history_show(true)
				return true

				case prf.OVERMENUBUTTON:
				if (!prf.DISPLAYMENUON) overmenu_show()
				return true

				case "left":
				if ( checkrepeat(count.left) ){
					if (sortjump){
						fe.signal ("prev_letter")
					}
					else {
						if (z_list.index > scrollstep - 1) {
								z_list_indexchange (z_list.index - scrollstep)
								if(prf.THEMEAUDIO) snd.ticksound.playing = true
							}
						else if ((count.left == 0)){
							z_list_indexchange (fe.list.size - 1)
							count.forceleft = false
							return true
						}
						else if ((!count.forceleft) && (count.left != 0)){
							tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
							count.forceleft = true
							return true
						}
					}
					count.left ++
				}				
				return true

				case "right":

				if (checkrepeat(count.right)){
					if (sortjump){
						fe.signal ("next_letter")
					}
					else {
						if ((z_list.index < fe.list.size - scrollstep)){
								z_list_indexchange (z_list.index + scrollstep)
								if(prf.THEMEAUDIO) snd.ticksound.playing = true
							}
						else if ((count.right == 0)){
							z_list_indexchange (0)
							count.forceright = false
							return true
						}
						else if ((!count.forceright) && (count.right != 0)){
							tilesTableZoom[newfocusindex] = [0.8,0.8,0.8,0.04,0.0]
							count.forceright = true
							return true
						}
					}
					count.right ++
				}				
				return true
				
				case "up":
				if (checkrepeat(count.up)){

					if ((z_list.index % rows > 0) && (scrolljump == false) && (sortjump == false)) {
						z_list_indexchange (z_list.index -1)
						if(prf.THEMEAUDIO) snd.ticksound.playing = true
					}
					else if (scrolljump == true){
						if(prf.THEMEAUDIO) snd.wooshsound.playing = true

						scrolljump = false
						scrollstep = rows
						scroller2.visible = scrollineglow.visible = false
					}
					else if (sortjump == true){
						if(prf.THEMEAUDIO) snd.wooshsound.playing = true

						sortjump = false
						labelstrip.visible = false
						foreach (key in sortlabels) {
							key.style = Style.Regular
							key.char_size = 30 * scalerate

						}
						if (prf.SCROLLERTYPE != "labellist") {
							scrolljump = true
							scrollstep = rows*(cols-2)
							scroller2.visible = scrollineglow.visible = true
						}
					}

					else {
						count.up = -1
						if (prf.UTILITYMENUBUTTON == "up") {

							utilitymenu()
						}
					}
					count.up ++
				}
				return true
				
				case "down":
				if (checkrepeat(count.down)){

				if ((scrolljump == false) && (sortjump == false) && ((z_list.index % rows < rows -1) && ( ! ( (z_list.index / rows == z_list.size / rows)&&(z_list.index%rows + 1 > (z_list.size -1)%rows) ))) ){
					if ((corrector == 0) && (z_list.index == z_list.size-1)) return true
					z_list_indexchange (z_list.index + 1)
					if(prf.THEMEAUDIO) snd.ticksound.playing = true
				}

				// if you go down and label list is not active, activate scrolljump
				else if ((scrolljump == false) && (sortjump == false) && (prf.SCROLLERTYPE != "labellist")){
					if(prf.THEMEAUDIO) snd.wooshsound.playing = true

					scrolljump = true
					scrollstep = rows*(cols-2)
					scroller2.visible = scrollineglow.visible = true
					sortjump = false
				}
				
				// if scrolljump is enabled and we are not in scrollbar mode, or if we are in labellist mode, activate sortjump
				else if (((scrolljump == true) && (sortjump == false) && (z_list.size > 0) && (prf.SCROLLERTYPE != "scrollbar")) || ((prf.SCROLLERTYPE == "labellist") && (z_list.size > 0) && (sortjump == false))){
					if(prf.THEMEAUDIO) snd.wooshsound.playing = true

					scrolljump = false
					scroller2.visible = scrollineglow.visible = false
					sortjump = true
					labelstrip.visible = true
					foreach (key in sortlabels) {
						key.style = Style.Bold
						key.char_size = 30 * scalerate
					}
				}
				count.down++
				}
				return true

				// All other cases
				//default:
					//if(prf.THEMEAUDIO) {snd.wooshsound.playing = true
						//		testpr("snd25")}

				
			}// END OF SWITCH SIGNAL LOOP
		}// CLOSE ELSE GROUP
	}
	return false
}
